from __future__ import absolute_import
from __future__ import print_function
import veriloggen
import thread_multibank_ram_dma

expected_verilog = """
module test;

  reg CLK;
  reg RST;
  wire [32-1:0] myaxi_awaddr;
  wire [8-1:0] myaxi_awlen;
  wire myaxi_awvalid;
  reg myaxi_awready;
  wire [128-1:0] myaxi_wdata;
  wire [16-1:0] myaxi_wstrb;
  wire myaxi_wlast;
  wire myaxi_wvalid;
  reg myaxi_wready;
  wire [32-1:0] myaxi_araddr;
  wire [8-1:0] myaxi_arlen;
  wire myaxi_arvalid;
  reg myaxi_arready;
  reg [128-1:0] myaxi_rdata;
  reg myaxi_rlast;
  reg myaxi_rvalid;
  wire myaxi_rready;
  wire [32-1:0] memory_awaddr;
  wire [8-1:0] memory_awlen;
  wire memory_awvalid;
  reg memory_awready;
  wire [128-1:0] memory_wdata;
  wire [16-1:0] memory_wstrb;
  wire memory_wlast;
  wire memory_wvalid;
  reg memory_wready;
  wire [32-1:0] memory_araddr;
  wire [8-1:0] memory_arlen;
  wire memory_arvalid;
  reg memory_arready;
  reg [128-1:0] memory_rdata;
  reg memory_rlast;
  reg memory_rvalid;
  wire memory_rready;
  reg [8-1:0] _memory_mem [0:2**20-1];

  initial begin
    $readmemh("_memory_memimg_.out", _memory_mem);
  end

  reg [32-1:0] _memory_fsm;
  localparam _memory_fsm_init = 0;
  reg [33-1:0] _write_count;
  reg [32-1:0] _write_addr;
  reg [33-1:0] _read_count;
  reg [32-1:0] _read_addr;
  reg [33-1:0] _sleep_count;
  reg [32-1:0] _d1__memory_fsm;
  reg __memory_fsm_cond_100_0_1;
  reg __memory_fsm_cond_200_1_1;
  reg __memory_fsm_cond_211_2_1;
  assign memory_awaddr = myaxi_awaddr;
  assign memory_awlen = myaxi_awlen;
  assign memory_awvalid = myaxi_awvalid;
  wire _tmp_0;
  assign _tmp_0 = memory_awready;

  always @(*) begin
    myaxi_awready = _tmp_0;
  end

  assign memory_wdata = myaxi_wdata;
  assign memory_wstrb = myaxi_wstrb;
  assign memory_wlast = myaxi_wlast;
  assign memory_wvalid = myaxi_wvalid;
  wire _tmp_1;
  assign _tmp_1 = memory_wready;

  always @(*) begin
    myaxi_wready = _tmp_1;
  end

  assign memory_araddr = myaxi_araddr;
  assign memory_arlen = myaxi_arlen;
  assign memory_arvalid = myaxi_arvalid;
  wire _tmp_2;
  assign _tmp_2 = memory_arready;

  always @(*) begin
    myaxi_arready = _tmp_2;
  end


  always @(*) begin
    myaxi_rdata <= memory_rdata;
  end

  wire _tmp_3;
  assign _tmp_3 = memory_rlast;

  always @(*) begin
    myaxi_rlast = _tmp_3;
  end

  wire _tmp_4;
  assign _tmp_4 = memory_rvalid;

  always @(*) begin
    myaxi_rvalid = _tmp_4;
  end

  assign memory_rready = myaxi_rready;

  blinkled
  uut
  (
    .CLK(CLK),
    .RST(RST),
    .myaxi_awaddr(myaxi_awaddr),
    .myaxi_awlen(myaxi_awlen),
    .myaxi_awvalid(myaxi_awvalid),
    .myaxi_awready(myaxi_awready),
    .myaxi_wdata(myaxi_wdata),
    .myaxi_wstrb(myaxi_wstrb),
    .myaxi_wlast(myaxi_wlast),
    .myaxi_wvalid(myaxi_wvalid),
    .myaxi_wready(myaxi_wready),
    .myaxi_araddr(myaxi_araddr),
    .myaxi_arlen(myaxi_arlen),
    .myaxi_arvalid(myaxi_arvalid),
    .myaxi_arready(myaxi_arready),
    .myaxi_rdata(myaxi_rdata),
    .myaxi_rlast(myaxi_rlast),
    .myaxi_rvalid(myaxi_rvalid),
    .myaxi_rready(myaxi_rready)
  );


  initial begin
    $dumpfile("uut.vcd");
    $dumpvars(0, uut);
  end


  initial begin
    CLK = 0;
    forever begin
      #5 CLK = !CLK;
    end
  end


  initial begin
    RST = 0;
    memory_awready = 0;
    memory_wready = 0;
    memory_arready = 0;
    memory_rdata = 0;
    memory_rlast = 0;
    memory_rvalid = 0;
    _memory_fsm = _memory_fsm_init;
    _write_count = 0;
    _write_addr = 0;
    _read_count = 0;
    _read_addr = 0;
    _sleep_count = 0;
    _d1__memory_fsm = _memory_fsm_init;
    __memory_fsm_cond_100_0_1 = 0;
    __memory_fsm_cond_200_1_1 = 0;
    __memory_fsm_cond_211_2_1 = 0;
    #100;
    RST = 1;
    #100;
    RST = 0;
    #100000;
    $finish;
  end

  localparam _memory_fsm_200 = 200;
  localparam _memory_fsm_201 = 201;
  localparam _memory_fsm_202 = 202;
  localparam _memory_fsm_203 = 203;
  localparam _memory_fsm_204 = 204;
  localparam _memory_fsm_205 = 205;
  localparam _memory_fsm_206 = 206;
  localparam _memory_fsm_207 = 207;
  localparam _memory_fsm_208 = 208;
  localparam _memory_fsm_209 = 209;
  localparam _memory_fsm_210 = 210;
  localparam _memory_fsm_211 = 211;
  localparam _memory_fsm_100 = 100;
  localparam _memory_fsm_101 = 101;
  localparam _memory_fsm_102 = 102;
  localparam _memory_fsm_103 = 103;
  localparam _memory_fsm_104 = 104;
  localparam _memory_fsm_105 = 105;
  localparam _memory_fsm_106 = 106;
  localparam _memory_fsm_107 = 107;
  localparam _memory_fsm_108 = 108;
  localparam _memory_fsm_109 = 109;
  localparam _memory_fsm_110 = 110;
  localparam _memory_fsm_111 = 111;
  localparam _memory_fsm_112 = 112;

  always @(posedge CLK) begin
    if(RST) begin
      _memory_fsm <= _memory_fsm_init;
      _d1__memory_fsm <= _memory_fsm_init;
      memory_awready <= 0;
      _write_addr <= 0;
      _write_count <= 0;
      __memory_fsm_cond_100_0_1 <= 0;
      memory_wready <= 0;
      memory_arready <= 0;
      _read_addr <= 0;
      _read_count <= 0;
      __memory_fsm_cond_200_1_1 <= 0;
      memory_rdata[7:0] <= (0 >> 0) & { 8{ 1'd1 } };
      memory_rdata[15:8] <= (0 >> 8) & { 8{ 1'd1 } };
      memory_rdata[23:16] <= (0 >> 16) & { 8{ 1'd1 } };
      memory_rdata[31:24] <= (0 >> 24) & { 8{ 1'd1 } };
      memory_rdata[39:32] <= (0 >> 32) & { 8{ 1'd1 } };
      memory_rdata[47:40] <= (0 >> 40) & { 8{ 1'd1 } };
      memory_rdata[55:48] <= (0 >> 48) & { 8{ 1'd1 } };
      memory_rdata[63:56] <= (0 >> 56) & { 8{ 1'd1 } };
      memory_rdata[71:64] <= (0 >> 64) & { 8{ 1'd1 } };
      memory_rdata[79:72] <= (0 >> 72) & { 8{ 1'd1 } };
      memory_rdata[87:80] <= (0 >> 80) & { 8{ 1'd1 } };
      memory_rdata[95:88] <= (0 >> 88) & { 8{ 1'd1 } };
      memory_rdata[103:96] <= (0 >> 96) & { 8{ 1'd1 } };
      memory_rdata[111:104] <= (0 >> 104) & { 8{ 1'd1 } };
      memory_rdata[119:112] <= (0 >> 112) & { 8{ 1'd1 } };
      memory_rdata[127:120] <= (0 >> 120) & { 8{ 1'd1 } };
      memory_rvalid <= 0;
      memory_rlast <= 0;
      __memory_fsm_cond_211_2_1 <= 0;
      memory_rdata <= 0;
      _sleep_count <= 0;
    end else begin
      _sleep_count <= _sleep_count + 1;
      if(_sleep_count == 3) begin
        _sleep_count <= 0;
      end 
      _d1__memory_fsm <= _memory_fsm;
      case(_d1__memory_fsm)
        _memory_fsm_100: begin
          if(__memory_fsm_cond_100_0_1) begin
            memory_awready <= 0;
          end 
        end
        _memory_fsm_200: begin
          if(__memory_fsm_cond_200_1_1) begin
            memory_arready <= 0;
          end 
        end
        _memory_fsm_211: begin
          if(__memory_fsm_cond_211_2_1) begin
            memory_rvalid <= 0;
            memory_rlast <= 0;
          end 
        end
      endcase
      case(_memory_fsm)
        _memory_fsm_init: begin
          if(memory_awvalid) begin
            _memory_fsm <= _memory_fsm_100;
          end 
          if(memory_arvalid) begin
            _memory_fsm <= _memory_fsm_200;
          end 
        end
        _memory_fsm_100: begin
          if(memory_awvalid) begin
            memory_awready <= 1;
            _write_addr <= memory_awaddr;
            _write_count <= memory_awlen + 1;
          end 
          __memory_fsm_cond_100_0_1 <= 1;
          if(!memory_awvalid) begin
            _memory_fsm <= _memory_fsm_init;
          end 
          if(memory_awvalid) begin
            _memory_fsm <= _memory_fsm_101;
          end 
        end
        _memory_fsm_101: begin
          _memory_fsm <= _memory_fsm_102;
        end
        _memory_fsm_102: begin
          _memory_fsm <= _memory_fsm_103;
        end
        _memory_fsm_103: begin
          _memory_fsm <= _memory_fsm_104;
        end
        _memory_fsm_104: begin
          _memory_fsm <= _memory_fsm_105;
        end
        _memory_fsm_105: begin
          _memory_fsm <= _memory_fsm_106;
        end
        _memory_fsm_106: begin
          _memory_fsm <= _memory_fsm_107;
        end
        _memory_fsm_107: begin
          _memory_fsm <= _memory_fsm_108;
        end
        _memory_fsm_108: begin
          _memory_fsm <= _memory_fsm_109;
        end
        _memory_fsm_109: begin
          _memory_fsm <= _memory_fsm_110;
        end
        _memory_fsm_110: begin
          _memory_fsm <= _memory_fsm_111;
        end
        _memory_fsm_111: begin
          memory_wready <= 1;
          _memory_fsm <= _memory_fsm_112;
        end
        _memory_fsm_112: begin
          if(memory_wvalid && memory_wstrb[0]) begin
            _memory_mem[_write_addr + 0] <= memory_wdata[7:0];
          end 
          if(memory_wvalid && memory_wstrb[1]) begin
            _memory_mem[_write_addr + 1] <= memory_wdata[15:8];
          end 
          if(memory_wvalid && memory_wstrb[2]) begin
            _memory_mem[_write_addr + 2] <= memory_wdata[23:16];
          end 
          if(memory_wvalid && memory_wstrb[3]) begin
            _memory_mem[_write_addr + 3] <= memory_wdata[31:24];
          end 
          if(memory_wvalid && memory_wstrb[4]) begin
            _memory_mem[_write_addr + 4] <= memory_wdata[39:32];
          end 
          if(memory_wvalid && memory_wstrb[5]) begin
            _memory_mem[_write_addr + 5] <= memory_wdata[47:40];
          end 
          if(memory_wvalid && memory_wstrb[6]) begin
            _memory_mem[_write_addr + 6] <= memory_wdata[55:48];
          end 
          if(memory_wvalid && memory_wstrb[7]) begin
            _memory_mem[_write_addr + 7] <= memory_wdata[63:56];
          end 
          if(memory_wvalid && memory_wstrb[8]) begin
            _memory_mem[_write_addr + 8] <= memory_wdata[71:64];
          end 
          if(memory_wvalid && memory_wstrb[9]) begin
            _memory_mem[_write_addr + 9] <= memory_wdata[79:72];
          end 
          if(memory_wvalid && memory_wstrb[10]) begin
            _memory_mem[_write_addr + 10] <= memory_wdata[87:80];
          end 
          if(memory_wvalid && memory_wstrb[11]) begin
            _memory_mem[_write_addr + 11] <= memory_wdata[95:88];
          end 
          if(memory_wvalid && memory_wstrb[12]) begin
            _memory_mem[_write_addr + 12] <= memory_wdata[103:96];
          end 
          if(memory_wvalid && memory_wstrb[13]) begin
            _memory_mem[_write_addr + 13] <= memory_wdata[111:104];
          end 
          if(memory_wvalid && memory_wstrb[14]) begin
            _memory_mem[_write_addr + 14] <= memory_wdata[119:112];
          end 
          if(memory_wvalid && memory_wstrb[15]) begin
            _memory_mem[_write_addr + 15] <= memory_wdata[127:120];
          end 
          if(memory_wvalid && memory_wready) begin
            _write_addr <= _write_addr + 16;
            _write_count <= _write_count - 1;
          end 
          if(_sleep_count == 3) begin
            memory_wready <= 0;
          end else begin
            memory_wready <= 1;
          end
          if(memory_wvalid && memory_wready && (_write_count == 1)) begin
            memory_wready <= 0;
          end 
          if(memory_wvalid && memory_wready && (_write_count == 1)) begin
            _memory_fsm <= _memory_fsm_init;
          end 
        end
        _memory_fsm_200: begin
          if(memory_arvalid) begin
            memory_arready <= 1;
            _read_addr <= memory_araddr;
            _read_count <= memory_arlen + 1;
          end 
          __memory_fsm_cond_200_1_1 <= 1;
          if(!memory_arvalid) begin
            _memory_fsm <= _memory_fsm_init;
          end 
          if(memory_arvalid) begin
            _memory_fsm <= _memory_fsm_201;
          end 
        end
        _memory_fsm_201: begin
          _memory_fsm <= _memory_fsm_202;
        end
        _memory_fsm_202: begin
          _memory_fsm <= _memory_fsm_203;
        end
        _memory_fsm_203: begin
          _memory_fsm <= _memory_fsm_204;
        end
        _memory_fsm_204: begin
          _memory_fsm <= _memory_fsm_205;
        end
        _memory_fsm_205: begin
          _memory_fsm <= _memory_fsm_206;
        end
        _memory_fsm_206: begin
          _memory_fsm <= _memory_fsm_207;
        end
        _memory_fsm_207: begin
          _memory_fsm <= _memory_fsm_208;
        end
        _memory_fsm_208: begin
          _memory_fsm <= _memory_fsm_209;
        end
        _memory_fsm_209: begin
          _memory_fsm <= _memory_fsm_210;
        end
        _memory_fsm_210: begin
          _memory_fsm <= _memory_fsm_211;
        end
        _memory_fsm_211: begin
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[7:0] <= _memory_mem[_read_addr + 0];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[15:8] <= _memory_mem[_read_addr + 1];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[23:16] <= _memory_mem[_read_addr + 2];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[31:24] <= _memory_mem[_read_addr + 3];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[39:32] <= _memory_mem[_read_addr + 4];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[47:40] <= _memory_mem[_read_addr + 5];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[55:48] <= _memory_mem[_read_addr + 6];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[63:56] <= _memory_mem[_read_addr + 7];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[71:64] <= _memory_mem[_read_addr + 8];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[79:72] <= _memory_mem[_read_addr + 9];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[87:80] <= _memory_mem[_read_addr + 10];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[95:88] <= _memory_mem[_read_addr + 11];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[103:96] <= _memory_mem[_read_addr + 12];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[111:104] <= _memory_mem[_read_addr + 13];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[119:112] <= _memory_mem[_read_addr + 14];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[127:120] <= _memory_mem[_read_addr + 15];
          end 
          if((_sleep_count < 3) && (_read_count > 0) && memory_rready | !memory_rvalid) begin
            memory_rvalid <= 1;
            _read_addr <= _read_addr + 16;
            _read_count <= _read_count - 1;
          end 
          if((_sleep_count < 3) && (_read_count == 1) && memory_rready | !memory_rvalid) begin
            memory_rlast <= 1;
          end 
          __memory_fsm_cond_211_2_1 <= 1;
          if(memory_rvalid && !memory_rready) begin
            memory_rvalid <= memory_rvalid;
            memory_rdata <= memory_rdata;
            memory_rlast <= memory_rlast;
          end 
          if(memory_rvalid && memory_rready && (_read_count == 0)) begin
            _memory_fsm <= _memory_fsm_init;
          end 
        end
      endcase
    end
  end


endmodule



module blinkled
(
  input CLK,
  input RST,
  output reg [32-1:0] myaxi_awaddr,
  output reg [8-1:0] myaxi_awlen,
  output reg myaxi_awvalid,
  input myaxi_awready,
  output reg [128-1:0] myaxi_wdata,
  output reg [16-1:0] myaxi_wstrb,
  output reg myaxi_wlast,
  output reg myaxi_wvalid,
  input myaxi_wready,
  output reg [32-1:0] myaxi_araddr,
  output reg [8-1:0] myaxi_arlen,
  output reg myaxi_arvalid,
  input myaxi_arready,
  input [128-1:0] myaxi_rdata,
  input myaxi_rlast,
  input myaxi_rvalid,
  output myaxi_rready
);

  reg [10-1:0] myram_0_0_addr;
  wire [32-1:0] myram_0_0_rdata;
  reg [32-1:0] myram_0_0_wdata;
  reg myram_0_0_wenable;

  myram_0
  inst_myram_0
  (
    .CLK(CLK),
    .myram_0_0_addr(myram_0_0_addr),
    .myram_0_0_rdata(myram_0_0_rdata),
    .myram_0_0_wdata(myram_0_0_wdata),
    .myram_0_0_wenable(myram_0_0_wenable)
  );

  reg [10-1:0] myram_1_0_addr;
  wire [32-1:0] myram_1_0_rdata;
  reg [32-1:0] myram_1_0_wdata;
  reg myram_1_0_wenable;

  myram_1
  inst_myram_1
  (
    .CLK(CLK),
    .myram_1_0_addr(myram_1_0_addr),
    .myram_1_0_rdata(myram_1_0_rdata),
    .myram_1_0_wdata(myram_1_0_wdata),
    .myram_1_0_wenable(myram_1_0_wenable)
  );

  reg [10-1:0] myram_2_0_addr;
  wire [32-1:0] myram_2_0_rdata;
  reg [32-1:0] myram_2_0_wdata;
  reg myram_2_0_wenable;

  myram_2
  inst_myram_2
  (
    .CLK(CLK),
    .myram_2_0_addr(myram_2_0_addr),
    .myram_2_0_rdata(myram_2_0_rdata),
    .myram_2_0_wdata(myram_2_0_wdata),
    .myram_2_0_wenable(myram_2_0_wenable)
  );

  reg [10-1:0] myram_3_0_addr;
  wire [32-1:0] myram_3_0_rdata;
  reg [32-1:0] myram_3_0_wdata;
  reg myram_3_0_wenable;

  myram_3
  inst_myram_3
  (
    .CLK(CLK),
    .myram_3_0_addr(myram_3_0_addr),
    .myram_3_0_rdata(myram_3_0_rdata),
    .myram_3_0_wdata(myram_3_0_wdata),
    .myram_3_0_wenable(myram_3_0_wenable)
  );

  reg _tmp_0;
  reg [32-1:0] th_blink;
  localparam th_blink_init = 0;
  reg signed [32-1:0] _th_blink_size_0;
  reg signed [32-1:0] _th_blink_i_1;
  reg signed [32-1:0] _th_blink_offset_2;
  reg signed [32-1:0] _th_blink_size_3;
  reg signed [32-1:0] _th_blink_offset_4;
  reg signed [32-1:0] _th_blink_bank_5;
  reg signed [32-1:0] _th_blink_i_6;
  reg signed [32-1:0] _th_blink_wdata_7;
  reg _myram_0_cond_0_1;
  reg _myram_1_cond_0_1;
  reg _myram_2_cond_0_1;
  reg _myram_3_cond_0_1;
  reg signed [32-1:0] _th_blink_laddr_8;
  reg signed [32-1:0] _th_blink_gaddr_9;
  reg [10-1:0] _tmp_1;
  reg [32-1:0] _tmp_2;
  reg [32-1:0] _tmp_3;
  reg [32-1:0] _tmp_fsm_0;
  localparam _tmp_fsm_0_init = 0;
  reg [32-1:0] _tmp_4;
  reg [33-1:0] _tmp_5;
  reg [33-1:0] _tmp_6;
  reg _tmp_7;
  reg _tmp_8;
  wire _tmp_9;
  wire _tmp_10;
  assign _tmp_10 = 1;
  localparam _tmp_11 = 1;
  wire [_tmp_11-1:0] _tmp_12;
  assign _tmp_12 = (_tmp_9 || !_tmp_7) && (_tmp_10 || !_tmp_8);
  reg [_tmp_11-1:0] __tmp_12_1;
  wire [32-1:0] _tmp_13;
  reg [32-1:0] __tmp_13_1;
  assign _tmp_13 = (__tmp_12_1)? myram_0_0_rdata : __tmp_13_1;
  reg _tmp_14;
  reg _tmp_15;
  reg _tmp_16;
  reg _tmp_17;
  reg [33-1:0] _tmp_18;
  reg _tmp_19;
  reg _tmp_20;
  wire _tmp_21;
  wire _tmp_22;
  assign _tmp_22 = 1;
  localparam _tmp_23 = 1;
  wire [_tmp_23-1:0] _tmp_24;
  assign _tmp_24 = (_tmp_21 || !_tmp_19) && (_tmp_22 || !_tmp_20);
  reg [_tmp_23-1:0] __tmp_24_1;
  wire [32-1:0] _tmp_25;
  reg [32-1:0] __tmp_25_1;
  assign _tmp_25 = (__tmp_24_1)? myram_1_0_rdata : __tmp_25_1;
  reg _tmp_26;
  reg _tmp_27;
  reg _tmp_28;
  reg _tmp_29;
  reg [33-1:0] _tmp_30;
  reg _tmp_31;
  reg _tmp_32;
  wire _tmp_33;
  wire _tmp_34;
  assign _tmp_34 = 1;
  localparam _tmp_35 = 1;
  wire [_tmp_35-1:0] _tmp_36;
  assign _tmp_36 = (_tmp_33 || !_tmp_31) && (_tmp_34 || !_tmp_32);
  reg [_tmp_35-1:0] __tmp_36_1;
  wire [32-1:0] _tmp_37;
  reg [32-1:0] __tmp_37_1;
  assign _tmp_37 = (__tmp_36_1)? myram_2_0_rdata : __tmp_37_1;
  reg _tmp_38;
  reg _tmp_39;
  reg _tmp_40;
  reg _tmp_41;
  reg [33-1:0] _tmp_42;
  reg _tmp_43;
  reg _tmp_44;
  wire _tmp_45;
  wire _tmp_46;
  assign _tmp_46 = 1;
  localparam _tmp_47 = 1;
  wire [_tmp_47-1:0] _tmp_48;
  assign _tmp_48 = (_tmp_45 || !_tmp_43) && (_tmp_46 || !_tmp_44);
  reg [_tmp_47-1:0] __tmp_48_1;
  wire [32-1:0] _tmp_49;
  reg [32-1:0] __tmp_49_1;
  assign _tmp_49 = (__tmp_48_1)? myram_3_0_rdata : __tmp_49_1;
  reg _tmp_50;
  reg _tmp_51;
  reg _tmp_52;
  reg _tmp_53;
  reg [33-1:0] _tmp_54;
  reg [9-1:0] _tmp_55;
  reg _myaxi_cond_0_1;
  reg _tmp_56;
  wire [128-1:0] _cat_data_57;
  wire _cat_valid_57;
  wire _cat_ready_57;
  assign _cat_ready_57 = (_tmp_fsm_0 == 4) && ((_tmp_55 > 0) && (myaxi_wready || !myaxi_wvalid));
  reg _myaxi_cond_1_1;
  reg _tmp_58;
  reg [32-1:0] _d1__tmp_fsm_0;
  reg __tmp_fsm_0_cond_5_0_1;
  reg _myram_0_cond_1_1;
  reg _myram_1_cond_1_1;
  reg _myram_2_cond_1_1;
  reg _myram_3_cond_1_1;
  reg [10-1:0] _tmp_59;
  reg [32-1:0] _tmp_60;
  reg [32-1:0] _tmp_61;
  reg [32-1:0] _tmp_fsm_1;
  localparam _tmp_fsm_1_init = 0;
  reg [32-1:0] _tmp_62;
  reg [33-1:0] _tmp_63;
  reg [33-1:0] _tmp_64;
  reg _tmp_65;
  reg _tmp_66;
  wire _tmp_67;
  wire _tmp_68;
  assign _tmp_68 = 1;
  localparam _tmp_69 = 1;
  wire [_tmp_69-1:0] _tmp_70;
  assign _tmp_70 = (_tmp_67 || !_tmp_65) && (_tmp_68 || !_tmp_66);
  reg [_tmp_69-1:0] __tmp_70_1;
  wire [32-1:0] _tmp_71;
  reg [32-1:0] __tmp_71_1;
  assign _tmp_71 = (__tmp_70_1)? myram_0_0_rdata : __tmp_71_1;
  reg _tmp_72;
  reg _tmp_73;
  reg _tmp_74;
  reg _tmp_75;
  reg [33-1:0] _tmp_76;
  reg _tmp_77;
  reg _tmp_78;
  wire _tmp_79;
  wire _tmp_80;
  assign _tmp_80 = 1;
  localparam _tmp_81 = 1;
  wire [_tmp_81-1:0] _tmp_82;
  assign _tmp_82 = (_tmp_79 || !_tmp_77) && (_tmp_80 || !_tmp_78);
  reg [_tmp_81-1:0] __tmp_82_1;
  wire [32-1:0] _tmp_83;
  reg [32-1:0] __tmp_83_1;
  assign _tmp_83 = (__tmp_82_1)? myram_1_0_rdata : __tmp_83_1;
  reg _tmp_84;
  reg _tmp_85;
  reg _tmp_86;
  reg _tmp_87;
  reg [33-1:0] _tmp_88;
  reg _tmp_89;
  reg _tmp_90;
  wire _tmp_91;
  wire _tmp_92;
  assign _tmp_92 = 1;
  localparam _tmp_93 = 1;
  wire [_tmp_93-1:0] _tmp_94;
  assign _tmp_94 = (_tmp_91 || !_tmp_89) && (_tmp_92 || !_tmp_90);
  reg [_tmp_93-1:0] __tmp_94_1;
  wire [32-1:0] _tmp_95;
  reg [32-1:0] __tmp_95_1;
  assign _tmp_95 = (__tmp_94_1)? myram_2_0_rdata : __tmp_95_1;
  reg _tmp_96;
  reg _tmp_97;
  reg _tmp_98;
  reg _tmp_99;
  reg [33-1:0] _tmp_100;
  reg _tmp_101;
  reg _tmp_102;
  wire _tmp_103;
  wire _tmp_104;
  assign _tmp_104 = 1;
  localparam _tmp_105 = 1;
  wire [_tmp_105-1:0] _tmp_106;
  assign _tmp_106 = (_tmp_103 || !_tmp_101) && (_tmp_104 || !_tmp_102);
  reg [_tmp_105-1:0] __tmp_106_1;
  wire [32-1:0] _tmp_107;
  reg [32-1:0] __tmp_107_1;
  assign _tmp_107 = (__tmp_106_1)? myram_3_0_rdata : __tmp_107_1;
  reg _tmp_108;
  reg _tmp_109;
  reg _tmp_110;
  reg _tmp_111;
  reg [33-1:0] _tmp_112;
  reg [9-1:0] _tmp_113;
  reg _myaxi_cond_2_1;
  reg _tmp_114;
  wire [128-1:0] _cat_data_115;
  wire _cat_valid_115;
  wire _cat_ready_115;
  assign _cat_ready_115 = (_tmp_fsm_1 == 4) && ((_tmp_113 > 0) && (myaxi_wready || !myaxi_wvalid));
  reg _myaxi_cond_3_1;
  reg _tmp_116;
  reg [32-1:0] _d1__tmp_fsm_1;
  reg __tmp_fsm_1_cond_5_0_1;
  reg [10-1:0] _tmp_117;
  reg [32-1:0] _tmp_118;
  reg [32-1:0] _tmp_119;
  reg [32-1:0] _tmp_fsm_2;
  localparam _tmp_fsm_2_init = 0;
  reg [32-1:0] _tmp_120;
  reg [33-1:0] _tmp_121;
  reg [33-1:0] _tmp_122;
  reg [128-1:0] _tmp_123;
  reg _tmp_124;
  reg [33-1:0] _tmp_125;
  reg _tmp_126;
  wire [33-1:0] _slice_data_127;
  wire _slice_valid_127;
  wire _slice_ready_127;
  assign _slice_ready_127 = (_tmp_125 > 0) && !_tmp_126;
  reg _myram_0_cond_2_1;
  reg [33-1:0] _tmp_128;
  reg _tmp_129;
  wire [33-1:0] _slice_data_130;
  wire _slice_valid_130;
  wire _slice_ready_130;
  assign _slice_ready_130 = (_tmp_128 > 0) && !_tmp_129;
  reg _myram_1_cond_2_1;
  reg [33-1:0] _tmp_131;
  reg _tmp_132;
  wire [33-1:0] _slice_data_133;
  wire _slice_valid_133;
  wire _slice_ready_133;
  assign _slice_ready_133 = (_tmp_131 > 0) && !_tmp_132;
  reg _myram_2_cond_2_1;
  reg [33-1:0] _tmp_134;
  reg _tmp_135;
  wire [33-1:0] _slice_data_136;
  wire _slice_valid_136;
  wire _slice_ready_136;
  assign _slice_ready_136 = (_tmp_134 > 0) && !_tmp_135;
  reg _myram_3_cond_2_1;
  reg [9-1:0] _tmp_137;
  reg _myaxi_cond_4_1;
  reg [32-1:0] _d1__tmp_fsm_2;
  reg __tmp_fsm_2_cond_4_0_1;
  reg _tmp_138;
  reg __tmp_fsm_2_cond_5_1_1;
  reg _tmp_139;
  reg _myram_0_cond_3_1;
  reg _myram_0_cond_4_1;
  reg _myram_0_cond_4_2;
  reg _tmp_140;
  reg _myram_1_cond_3_1;
  reg _myram_1_cond_4_1;
  reg _myram_1_cond_4_2;
  reg _tmp_141;
  reg _myram_2_cond_3_1;
  reg _myram_2_cond_4_1;
  reg _myram_2_cond_4_2;
  reg _tmp_142;
  reg _myram_3_cond_3_1;
  reg _myram_3_cond_4_1;
  reg _myram_3_cond_4_2;
  reg signed [32-1:0] _tmp_143;
  reg signed [32-1:0] _th_blink_rdata_10;
  reg [10-1:0] _tmp_144;
  reg [32-1:0] _tmp_145;
  reg [32-1:0] _tmp_146;
  reg [32-1:0] _tmp_fsm_3;
  localparam _tmp_fsm_3_init = 0;
  reg [32-1:0] _tmp_147;
  reg [33-1:0] _tmp_148;
  reg [33-1:0] _tmp_149;
  reg [128-1:0] _tmp_150;
  reg _tmp_151;
  reg [33-1:0] _tmp_152;
  reg _tmp_153;
  wire [33-1:0] _slice_data_154;
  wire _slice_valid_154;
  wire _slice_ready_154;
  assign _slice_ready_154 = (_tmp_152 > 0) && !_tmp_153;
  reg _myram_0_cond_5_1;
  reg [33-1:0] _tmp_155;
  reg _tmp_156;
  wire [33-1:0] _slice_data_157;
  wire _slice_valid_157;
  wire _slice_ready_157;
  assign _slice_ready_157 = (_tmp_155 > 0) && !_tmp_156;
  reg _myram_1_cond_5_1;
  reg [33-1:0] _tmp_158;
  reg _tmp_159;
  wire [33-1:0] _slice_data_160;
  wire _slice_valid_160;
  wire _slice_ready_160;
  assign _slice_ready_160 = (_tmp_158 > 0) && !_tmp_159;
  reg _myram_2_cond_5_1;
  reg [33-1:0] _tmp_161;
  reg _tmp_162;
  wire [33-1:0] _slice_data_163;
  wire _slice_valid_163;
  wire _slice_ready_163;
  assign _slice_ready_163 = (_tmp_161 > 0) && !_tmp_162;
  reg _myram_3_cond_5_1;
  reg [9-1:0] _tmp_164;
  reg _myaxi_cond_5_1;
  assign myaxi_rready = (_tmp_fsm_2 == 4) || (_tmp_fsm_3 == 4);
  reg [32-1:0] _d1__tmp_fsm_3;
  reg __tmp_fsm_3_cond_4_0_1;
  reg _tmp_165;
  reg __tmp_fsm_3_cond_5_1_1;
  reg _tmp_166;
  reg _myram_0_cond_6_1;
  reg _myram_0_cond_7_1;
  reg _myram_0_cond_7_2;
  reg _tmp_167;
  reg _myram_1_cond_6_1;
  reg _myram_1_cond_7_1;
  reg _myram_1_cond_7_2;
  reg _tmp_168;
  reg _myram_2_cond_6_1;
  reg _myram_2_cond_7_1;
  reg _myram_2_cond_7_2;
  reg _tmp_169;
  reg _myram_3_cond_6_1;
  reg _myram_3_cond_7_1;
  reg _myram_3_cond_7_2;
  reg signed [32-1:0] _tmp_170;

  always @(posedge CLK) begin
    if(RST) begin
      myaxi_awaddr <= 0;
      myaxi_awlen <= 0;
      myaxi_awvalid <= 0;
      _tmp_55 <= 0;
      _myaxi_cond_0_1 <= 0;
      myaxi_wdata <= 0;
      myaxi_wvalid <= 0;
      myaxi_wlast <= 0;
      myaxi_wstrb <= 0;
      _tmp_56 <= 0;
      _myaxi_cond_1_1 <= 0;
      _tmp_113 <= 0;
      _myaxi_cond_2_1 <= 0;
      _tmp_114 <= 0;
      _myaxi_cond_3_1 <= 0;
      myaxi_araddr <= 0;
      myaxi_arlen <= 0;
      myaxi_arvalid <= 0;
      _tmp_137 <= 0;
      _myaxi_cond_4_1 <= 0;
      _tmp_164 <= 0;
      _myaxi_cond_5_1 <= 0;
    end else begin
      if(_myaxi_cond_0_1) begin
        myaxi_awvalid <= 0;
      end 
      if(_myaxi_cond_1_1) begin
        myaxi_wvalid <= 0;
        myaxi_wlast <= 0;
        _tmp_56 <= 0;
      end 
      if(_myaxi_cond_2_1) begin
        myaxi_awvalid <= 0;
      end 
      if(_myaxi_cond_3_1) begin
        myaxi_wvalid <= 0;
        myaxi_wlast <= 0;
        _tmp_114 <= 0;
      end 
      if(_myaxi_cond_4_1) begin
        myaxi_arvalid <= 0;
      end 
      if(_myaxi_cond_5_1) begin
        myaxi_arvalid <= 0;
      end 
      if((_tmp_fsm_0 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_55 == 0))) begin
        myaxi_awaddr <= _tmp_4;
        myaxi_awlen <= _tmp_5 - 1;
        myaxi_awvalid <= 1;
        _tmp_55 <= _tmp_5;
      end 
      if((_tmp_fsm_0 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_55 == 0)) && (_tmp_5 == 0)) begin
        myaxi_awvalid <= 0;
      end 
      _myaxi_cond_0_1 <= 1;
      if(myaxi_awvalid && !myaxi_awready) begin
        myaxi_awvalid <= myaxi_awvalid;
      end 
      if(_cat_valid_57 && ((_tmp_fsm_0 == 4) && ((_tmp_55 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_55 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_55 > 0))) begin
        myaxi_wdata <= _cat_data_57;
        myaxi_wvalid <= 1;
        myaxi_wlast <= 0;
        myaxi_wstrb <= { 16{ 1'd1 } };
        _tmp_55 <= _tmp_55 - 1;
      end 
      if(_cat_valid_57 && ((_tmp_fsm_0 == 4) && ((_tmp_55 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_55 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_55 > 0)) && (_tmp_55 == 1)) begin
        myaxi_wlast <= 1;
        _tmp_56 <= 1;
      end 
      _myaxi_cond_1_1 <= 1;
      if(myaxi_wvalid && !myaxi_wready) begin
        myaxi_wvalid <= myaxi_wvalid;
        myaxi_wlast <= myaxi_wlast;
        _tmp_56 <= _tmp_56;
      end 
      if((_tmp_fsm_1 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_113 == 0))) begin
        myaxi_awaddr <= _tmp_62;
        myaxi_awlen <= _tmp_63 - 1;
        myaxi_awvalid <= 1;
        _tmp_113 <= _tmp_63;
      end 
      if((_tmp_fsm_1 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_113 == 0)) && (_tmp_63 == 0)) begin
        myaxi_awvalid <= 0;
      end 
      _myaxi_cond_2_1 <= 1;
      if(myaxi_awvalid && !myaxi_awready) begin
        myaxi_awvalid <= myaxi_awvalid;
      end 
      if(_cat_valid_115 && ((_tmp_fsm_1 == 4) && ((_tmp_113 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_113 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_113 > 0))) begin
        myaxi_wdata <= _cat_data_115;
        myaxi_wvalid <= 1;
        myaxi_wlast <= 0;
        myaxi_wstrb <= { 16{ 1'd1 } };
        _tmp_113 <= _tmp_113 - 1;
      end 
      if(_cat_valid_115 && ((_tmp_fsm_1 == 4) && ((_tmp_113 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_113 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_113 > 0)) && (_tmp_113 == 1)) begin
        myaxi_wlast <= 1;
        _tmp_114 <= 1;
      end 
      _myaxi_cond_3_1 <= 1;
      if(myaxi_wvalid && !myaxi_wready) begin
        myaxi_wvalid <= myaxi_wvalid;
        myaxi_wlast <= myaxi_wlast;
        _tmp_114 <= _tmp_114;
      end 
      if((_tmp_fsm_2 == 3) && ((myaxi_arready || !myaxi_arvalid) && (_tmp_137 == 0))) begin
        myaxi_araddr <= _tmp_120;
        myaxi_arlen <= _tmp_121 - 1;
        myaxi_arvalid <= 1;
        _tmp_137 <= _tmp_121;
      end 
      _myaxi_cond_4_1 <= 1;
      if(myaxi_arvalid && !myaxi_arready) begin
        myaxi_arvalid <= myaxi_arvalid;
      end 
      if(myaxi_rready && myaxi_rvalid && (_tmp_137 > 0)) begin
        _tmp_137 <= _tmp_137 - 1;
      end 
      if((_tmp_fsm_3 == 3) && ((myaxi_arready || !myaxi_arvalid) && (_tmp_164 == 0))) begin
        myaxi_araddr <= _tmp_147;
        myaxi_arlen <= _tmp_148 - 1;
        myaxi_arvalid <= 1;
        _tmp_164 <= _tmp_148;
      end 
      _myaxi_cond_5_1 <= 1;
      if(myaxi_arvalid && !myaxi_arready) begin
        myaxi_arvalid <= myaxi_arvalid;
      end 
      if(myaxi_rready && myaxi_rvalid && (_tmp_164 > 0)) begin
        _tmp_164 <= _tmp_164 - 1;
      end 
    end
  end

  reg [33-1:0] _slice_data_171;
  reg _slice_valid_171;
  wire _slice_ready_171;
  reg [33-1:0] _slice_data_172;
  reg _slice_valid_172;
  wire _slice_ready_172;
  reg [33-1:0] _slice_data_173;
  reg _slice_valid_173;
  wire _slice_ready_173;
  reg [33-1:0] _slice_data_174;
  reg _slice_valid_174;
  wire _slice_ready_174;
  reg [33-1:0] _slice_data_175;
  reg _slice_valid_175;
  wire _slice_ready_175;
  reg [33-1:0] _slice_data_176;
  reg _slice_valid_176;
  wire _slice_ready_176;
  reg [33-1:0] _slice_data_177;
  reg _slice_valid_177;
  wire _slice_ready_177;
  reg [33-1:0] _slice_data_178;
  reg _slice_valid_178;
  wire _slice_ready_178;
  assign _slice_data_127 = _slice_data_171;
  assign _slice_valid_127 = _slice_valid_171;
  assign _slice_ready_171 = _slice_ready_127;
  assign _slice_data_130 = _slice_data_172;
  assign _slice_valid_130 = _slice_valid_172;
  assign _slice_ready_172 = _slice_ready_130;
  assign _slice_data_133 = _slice_data_173;
  assign _slice_valid_133 = _slice_valid_173;
  assign _slice_ready_173 = _slice_ready_133;
  assign _slice_data_136 = _slice_data_174;
  assign _slice_valid_136 = _slice_valid_174;
  assign _slice_ready_174 = _slice_ready_136;
  assign _slice_data_154 = _slice_data_175;
  assign _slice_valid_154 = _slice_valid_175;
  assign _slice_ready_175 = _slice_ready_154;
  assign _slice_data_157 = _slice_data_176;
  assign _slice_valid_157 = _slice_valid_176;
  assign _slice_ready_176 = _slice_ready_157;
  assign _slice_data_160 = _slice_data_177;
  assign _slice_valid_160 = _slice_valid_177;
  assign _slice_ready_177 = _slice_ready_160;
  assign _slice_data_163 = _slice_data_178;
  assign _slice_valid_163 = _slice_valid_178;
  assign _slice_ready_178 = _slice_ready_163;

  always @(posedge CLK) begin
    if(RST) begin
      _slice_data_171 <= 0;
      _slice_valid_171 <= 0;
      _slice_data_172 <= 0;
      _slice_valid_172 <= 0;
      _slice_data_173 <= 0;
      _slice_valid_173 <= 0;
      _slice_data_174 <= 0;
      _slice_valid_174 <= 0;
      _slice_data_175 <= 0;
      _slice_valid_175 <= 0;
      _slice_data_176 <= 0;
      _slice_valid_176 <= 0;
      _slice_data_177 <= 0;
      _slice_valid_177 <= 0;
      _slice_data_178 <= 0;
      _slice_valid_178 <= 0;
    end else begin
      if((_slice_ready_171 || !_slice_valid_171) && 1 && _tmp_124) begin
        _slice_data_171 <= _tmp_123[7'sd32:1'sd0];
      end 
      if(_slice_valid_171 && _slice_ready_171) begin
        _slice_valid_171 <= 0;
      end 
      if((_slice_ready_171 || !_slice_valid_171) && 1) begin
        _slice_valid_171 <= _tmp_124;
      end 
      if((_slice_ready_172 || !_slice_valid_172) && 1 && _tmp_124) begin
        _slice_data_172 <= _tmp_123[8'sd64:7'sd32];
      end 
      if(_slice_valid_172 && _slice_ready_172) begin
        _slice_valid_172 <= 0;
      end 
      if((_slice_ready_172 || !_slice_valid_172) && 1) begin
        _slice_valid_172 <= _tmp_124;
      end 
      if((_slice_ready_173 || !_slice_valid_173) && 1 && _tmp_124) begin
        _slice_data_173 <= _tmp_123[8'sd96:8'sd64];
      end 
      if(_slice_valid_173 && _slice_ready_173) begin
        _slice_valid_173 <= 0;
      end 
      if((_slice_ready_173 || !_slice_valid_173) && 1) begin
        _slice_valid_173 <= _tmp_124;
      end 
      if((_slice_ready_174 || !_slice_valid_174) && 1 && _tmp_124) begin
        _slice_data_174 <= _tmp_123[9'sd128:8'sd96];
      end 
      if(_slice_valid_174 && _slice_ready_174) begin
        _slice_valid_174 <= 0;
      end 
      if((_slice_ready_174 || !_slice_valid_174) && 1) begin
        _slice_valid_174 <= _tmp_124;
      end 
      if((_slice_ready_175 || !_slice_valid_175) && 1 && _tmp_151) begin
        _slice_data_175 <= _tmp_150[7'sd32:1'sd0];
      end 
      if(_slice_valid_175 && _slice_ready_175) begin
        _slice_valid_175 <= 0;
      end 
      if((_slice_ready_175 || !_slice_valid_175) && 1) begin
        _slice_valid_175 <= _tmp_151;
      end 
      if((_slice_ready_176 || !_slice_valid_176) && 1 && _tmp_151) begin
        _slice_data_176 <= _tmp_150[8'sd64:7'sd32];
      end 
      if(_slice_valid_176 && _slice_ready_176) begin
        _slice_valid_176 <= 0;
      end 
      if((_slice_ready_176 || !_slice_valid_176) && 1) begin
        _slice_valid_176 <= _tmp_151;
      end 
      if((_slice_ready_177 || !_slice_valid_177) && 1 && _tmp_151) begin
        _slice_data_177 <= _tmp_150[8'sd96:8'sd64];
      end 
      if(_slice_valid_177 && _slice_ready_177) begin
        _slice_valid_177 <= 0;
      end 
      if((_slice_ready_177 || !_slice_valid_177) && 1) begin
        _slice_valid_177 <= _tmp_151;
      end 
      if((_slice_ready_178 || !_slice_valid_178) && 1 && _tmp_151) begin
        _slice_data_178 <= _tmp_150[9'sd128:8'sd96];
      end 
      if(_slice_valid_178 && _slice_ready_178) begin
        _slice_valid_178 <= 0;
      end 
      if((_slice_ready_178 || !_slice_valid_178) && 1) begin
        _slice_valid_178 <= _tmp_151;
      end 
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      myram_0_0_addr <= 0;
      myram_0_0_wdata <= 0;
      myram_0_0_wenable <= 0;
      _myram_0_cond_0_1 <= 0;
      __tmp_12_1 <= 0;
      __tmp_13_1 <= 0;
      _tmp_17 <= 0;
      _tmp_7 <= 0;
      _tmp_8 <= 0;
      _tmp_15 <= 0;
      _tmp_16 <= 0;
      _tmp_14 <= 0;
      _tmp_18 <= 0;
      _myram_0_cond_1_1 <= 0;
      __tmp_70_1 <= 0;
      __tmp_71_1 <= 0;
      _tmp_75 <= 0;
      _tmp_65 <= 0;
      _tmp_66 <= 0;
      _tmp_73 <= 0;
      _tmp_74 <= 0;
      _tmp_72 <= 0;
      _tmp_76 <= 0;
      _tmp_125 <= 0;
      _tmp_126 <= 0;
      _myram_0_cond_2_1 <= 0;
      _myram_0_cond_3_1 <= 0;
      _tmp_139 <= 0;
      _myram_0_cond_4_1 <= 0;
      _myram_0_cond_4_2 <= 0;
      _tmp_152 <= 0;
      _tmp_153 <= 0;
      _myram_0_cond_5_1 <= 0;
      _myram_0_cond_6_1 <= 0;
      _tmp_166 <= 0;
      _myram_0_cond_7_1 <= 0;
      _myram_0_cond_7_2 <= 0;
    end else begin
      if(_myram_0_cond_4_2) begin
        _tmp_139 <= 0;
      end 
      if(_myram_0_cond_7_2) begin
        _tmp_166 <= 0;
      end 
      if(_myram_0_cond_0_1) begin
        myram_0_0_wenable <= 0;
      end 
      if(_myram_0_cond_1_1) begin
        myram_0_0_wenable <= 0;
      end 
      if(_myram_0_cond_2_1) begin
        myram_0_0_wenable <= 0;
        _tmp_126 <= 0;
      end 
      if(_myram_0_cond_3_1) begin
        _tmp_139 <= 1;
      end 
      _myram_0_cond_4_2 <= _myram_0_cond_4_1;
      if(_myram_0_cond_5_1) begin
        myram_0_0_wenable <= 0;
        _tmp_153 <= 0;
      end 
      if(_myram_0_cond_6_1) begin
        _tmp_166 <= 1;
      end 
      _myram_0_cond_7_2 <= _myram_0_cond_7_1;
      if((th_blink == 12) && (_th_blink_bank_5 == 0)) begin
        myram_0_0_addr <= _th_blink_i_6;
        myram_0_0_wdata <= _th_blink_wdata_7;
        myram_0_0_wenable <= 1;
      end 
      _myram_0_cond_0_1 <= (th_blink == 12) && (_th_blink_bank_5 == 0);
      __tmp_12_1 <= _tmp_12;
      __tmp_13_1 <= _tmp_13;
      if((_tmp_9 || !_tmp_7) && (_tmp_10 || !_tmp_8) && _tmp_15) begin
        _tmp_17 <= 0;
        _tmp_7 <= 0;
        _tmp_8 <= 0;
        _tmp_15 <= 0;
      end 
      if((_tmp_9 || !_tmp_7) && (_tmp_10 || !_tmp_8) && _tmp_14) begin
        _tmp_7 <= 1;
        _tmp_8 <= 1;
        _tmp_17 <= _tmp_16;
        _tmp_16 <= 0;
        _tmp_14 <= 0;
        _tmp_15 <= 1;
      end 
      if((_tmp_fsm_0 == 1) && (_tmp_18 == 0) && !_tmp_16 && !_tmp_17) begin
        myram_0_0_addr <= _tmp_1;
        _tmp_18 <= _tmp_3 - 1;
        _tmp_14 <= 1;
        _tmp_16 <= _tmp_3 == 1;
      end 
      if((_tmp_9 || !_tmp_7) && (_tmp_10 || !_tmp_8) && (_tmp_18 > 0)) begin
        myram_0_0_addr <= myram_0_0_addr + 1;
        _tmp_18 <= _tmp_18 - 1;
        _tmp_14 <= 1;
        _tmp_16 <= 0;
      end 
      if((_tmp_9 || !_tmp_7) && (_tmp_10 || !_tmp_8) && (_tmp_18 == 1)) begin
        _tmp_16 <= 1;
      end 
      if((th_blink == 25) && (_th_blink_bank_5 == 0)) begin
        myram_0_0_addr <= _th_blink_i_6;
        myram_0_0_wdata <= _th_blink_wdata_7;
        myram_0_0_wenable <= 1;
      end 
      _myram_0_cond_1_1 <= (th_blink == 25) && (_th_blink_bank_5 == 0);
      __tmp_70_1 <= _tmp_70;
      __tmp_71_1 <= _tmp_71;
      if((_tmp_67 || !_tmp_65) && (_tmp_68 || !_tmp_66) && _tmp_73) begin
        _tmp_75 <= 0;
        _tmp_65 <= 0;
        _tmp_66 <= 0;
        _tmp_73 <= 0;
      end 
      if((_tmp_67 || !_tmp_65) && (_tmp_68 || !_tmp_66) && _tmp_72) begin
        _tmp_65 <= 1;
        _tmp_66 <= 1;
        _tmp_75 <= _tmp_74;
        _tmp_74 <= 0;
        _tmp_72 <= 0;
        _tmp_73 <= 1;
      end 
      if((_tmp_fsm_1 == 1) && (_tmp_76 == 0) && !_tmp_74 && !_tmp_75) begin
        myram_0_0_addr <= _tmp_59;
        _tmp_76 <= _tmp_61 - 1;
        _tmp_72 <= 1;
        _tmp_74 <= _tmp_61 == 1;
      end 
      if((_tmp_67 || !_tmp_65) && (_tmp_68 || !_tmp_66) && (_tmp_76 > 0)) begin
        myram_0_0_addr <= myram_0_0_addr + 1;
        _tmp_76 <= _tmp_76 - 1;
        _tmp_72 <= 1;
        _tmp_74 <= 0;
      end 
      if((_tmp_67 || !_tmp_65) && (_tmp_68 || !_tmp_66) && (_tmp_76 == 1)) begin
        _tmp_74 <= 1;
      end 
      if((_tmp_fsm_2 == 1) && (_tmp_125 == 0)) begin
        myram_0_0_addr <= _tmp_117 - 1;
        _tmp_125 <= _tmp_119;
      end 
      if(_slice_valid_127 && ((_tmp_125 > 0) && !_tmp_126) && (_tmp_125 > 0)) begin
        myram_0_0_addr <= myram_0_0_addr + 1;
        myram_0_0_wdata <= _slice_data_127;
        myram_0_0_wenable <= 1;
        _tmp_125 <= _tmp_125 - 1;
      end 
      if(_slice_valid_127 && ((_tmp_125 > 0) && !_tmp_126) && (_tmp_125 == 1)) begin
        _tmp_126 <= 1;
      end 
      _myram_0_cond_2_1 <= 1;
      if(th_blink == 42) begin
        myram_0_0_addr <= _th_blink_i_6;
      end 
      _myram_0_cond_3_1 <= th_blink == 42;
      _myram_0_cond_4_1 <= th_blink == 42;
      if((_tmp_fsm_3 == 1) && (_tmp_152 == 0)) begin
        myram_0_0_addr <= _tmp_144 - 1;
        _tmp_152 <= _tmp_146;
      end 
      if(_slice_valid_154 && ((_tmp_152 > 0) && !_tmp_153) && (_tmp_152 > 0)) begin
        myram_0_0_addr <= myram_0_0_addr + 1;
        myram_0_0_wdata <= _slice_data_154;
        myram_0_0_wenable <= 1;
        _tmp_152 <= _tmp_152 - 1;
      end 
      if(_slice_valid_154 && ((_tmp_152 > 0) && !_tmp_153) && (_tmp_152 == 1)) begin
        _tmp_153 <= 1;
      end 
      _myram_0_cond_5_1 <= 1;
      if(th_blink == 58) begin
        myram_0_0_addr <= _th_blink_i_6;
      end 
      _myram_0_cond_6_1 <= th_blink == 58;
      _myram_0_cond_7_1 <= th_blink == 58;
    end
  end

  reg [128-1:0] _cat_data_179;
  reg _cat_valid_179;
  wire _cat_ready_179;
  assign _tmp_45 = 1 && ((_cat_ready_179 || !_cat_valid_179) && (_tmp_43 && _tmp_31 && _tmp_19 && _tmp_7));
  assign _tmp_33 = 1 && ((_cat_ready_179 || !_cat_valid_179) && (_tmp_43 && _tmp_31 && _tmp_19 && _tmp_7));
  assign _tmp_21 = 1 && ((_cat_ready_179 || !_cat_valid_179) && (_tmp_43 && _tmp_31 && _tmp_19 && _tmp_7));
  assign _tmp_9 = 1 && ((_cat_ready_179 || !_cat_valid_179) && (_tmp_43 && _tmp_31 && _tmp_19 && _tmp_7));
  reg [128-1:0] _cat_data_180;
  reg _cat_valid_180;
  wire _cat_ready_180;
  assign _tmp_103 = 1 && ((_cat_ready_180 || !_cat_valid_180) && (_tmp_101 && _tmp_89 && _tmp_77 && _tmp_65));
  assign _tmp_91 = 1 && ((_cat_ready_180 || !_cat_valid_180) && (_tmp_101 && _tmp_89 && _tmp_77 && _tmp_65));
  assign _tmp_79 = 1 && ((_cat_ready_180 || !_cat_valid_180) && (_tmp_101 && _tmp_89 && _tmp_77 && _tmp_65));
  assign _tmp_67 = 1 && ((_cat_ready_180 || !_cat_valid_180) && (_tmp_101 && _tmp_89 && _tmp_77 && _tmp_65));
  assign _cat_data_57 = _cat_data_179;
  assign _cat_valid_57 = _cat_valid_179;
  assign _cat_ready_179 = _cat_ready_57;
  assign _cat_data_115 = _cat_data_180;
  assign _cat_valid_115 = _cat_valid_180;
  assign _cat_ready_180 = _cat_ready_115;

  always @(posedge CLK) begin
    if(RST) begin
      _cat_data_179 <= 0;
      _cat_valid_179 <= 0;
      _cat_data_180 <= 0;
      _cat_valid_180 <= 0;
    end else begin
      if((_cat_ready_179 || !_cat_valid_179) && (_tmp_45 && _tmp_33 && _tmp_21 && _tmp_9) && (_tmp_43 && _tmp_31 && _tmp_19 && _tmp_7)) begin
        _cat_data_179 <= { _tmp_49, _tmp_37, _tmp_25, _tmp_13 };
      end 
      if(_cat_valid_179 && _cat_ready_179) begin
        _cat_valid_179 <= 0;
      end 
      if((_cat_ready_179 || !_cat_valid_179) && (_tmp_45 && _tmp_33 && _tmp_21 && _tmp_9)) begin
        _cat_valid_179 <= _tmp_43 && _tmp_31 && _tmp_19 && _tmp_7;
      end 
      if((_cat_ready_180 || !_cat_valid_180) && (_tmp_103 && _tmp_91 && _tmp_79 && _tmp_67) && (_tmp_101 && _tmp_89 && _tmp_77 && _tmp_65)) begin
        _cat_data_180 <= { _tmp_107, _tmp_95, _tmp_83, _tmp_71 };
      end 
      if(_cat_valid_180 && _cat_ready_180) begin
        _cat_valid_180 <= 0;
      end 
      if((_cat_ready_180 || !_cat_valid_180) && (_tmp_103 && _tmp_91 && _tmp_79 && _tmp_67)) begin
        _cat_valid_180 <= _tmp_101 && _tmp_89 && _tmp_77 && _tmp_65;
      end 
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      myram_1_0_addr <= 0;
      myram_1_0_wdata <= 0;
      myram_1_0_wenable <= 0;
      _myram_1_cond_0_1 <= 0;
      __tmp_24_1 <= 0;
      __tmp_25_1 <= 0;
      _tmp_29 <= 0;
      _tmp_19 <= 0;
      _tmp_20 <= 0;
      _tmp_27 <= 0;
      _tmp_28 <= 0;
      _tmp_26 <= 0;
      _tmp_30 <= 0;
      _myram_1_cond_1_1 <= 0;
      __tmp_82_1 <= 0;
      __tmp_83_1 <= 0;
      _tmp_87 <= 0;
      _tmp_77 <= 0;
      _tmp_78 <= 0;
      _tmp_85 <= 0;
      _tmp_86 <= 0;
      _tmp_84 <= 0;
      _tmp_88 <= 0;
      _tmp_128 <= 0;
      _tmp_129 <= 0;
      _myram_1_cond_2_1 <= 0;
      _myram_1_cond_3_1 <= 0;
      _tmp_140 <= 0;
      _myram_1_cond_4_1 <= 0;
      _myram_1_cond_4_2 <= 0;
      _tmp_155 <= 0;
      _tmp_156 <= 0;
      _myram_1_cond_5_1 <= 0;
      _myram_1_cond_6_1 <= 0;
      _tmp_167 <= 0;
      _myram_1_cond_7_1 <= 0;
      _myram_1_cond_7_2 <= 0;
    end else begin
      if(_myram_1_cond_4_2) begin
        _tmp_140 <= 0;
      end 
      if(_myram_1_cond_7_2) begin
        _tmp_167 <= 0;
      end 
      if(_myram_1_cond_0_1) begin
        myram_1_0_wenable <= 0;
      end 
      if(_myram_1_cond_1_1) begin
        myram_1_0_wenable <= 0;
      end 
      if(_myram_1_cond_2_1) begin
        myram_1_0_wenable <= 0;
        _tmp_129 <= 0;
      end 
      if(_myram_1_cond_3_1) begin
        _tmp_140 <= 1;
      end 
      _myram_1_cond_4_2 <= _myram_1_cond_4_1;
      if(_myram_1_cond_5_1) begin
        myram_1_0_wenable <= 0;
        _tmp_156 <= 0;
      end 
      if(_myram_1_cond_6_1) begin
        _tmp_167 <= 1;
      end 
      _myram_1_cond_7_2 <= _myram_1_cond_7_1;
      if((th_blink == 12) && (_th_blink_bank_5 == 1)) begin
        myram_1_0_addr <= _th_blink_i_6;
        myram_1_0_wdata <= _th_blink_wdata_7;
        myram_1_0_wenable <= 1;
      end 
      _myram_1_cond_0_1 <= (th_blink == 12) && (_th_blink_bank_5 == 1);
      __tmp_24_1 <= _tmp_24;
      __tmp_25_1 <= _tmp_25;
      if((_tmp_21 || !_tmp_19) && (_tmp_22 || !_tmp_20) && _tmp_27) begin
        _tmp_29 <= 0;
        _tmp_19 <= 0;
        _tmp_20 <= 0;
        _tmp_27 <= 0;
      end 
      if((_tmp_21 || !_tmp_19) && (_tmp_22 || !_tmp_20) && _tmp_26) begin
        _tmp_19 <= 1;
        _tmp_20 <= 1;
        _tmp_29 <= _tmp_28;
        _tmp_28 <= 0;
        _tmp_26 <= 0;
        _tmp_27 <= 1;
      end 
      if((_tmp_fsm_0 == 1) && (_tmp_30 == 0) && !_tmp_28 && !_tmp_29) begin
        myram_1_0_addr <= _tmp_1;
        _tmp_30 <= _tmp_3 - 1;
        _tmp_26 <= 1;
        _tmp_28 <= _tmp_3 == 1;
      end 
      if((_tmp_21 || !_tmp_19) && (_tmp_22 || !_tmp_20) && (_tmp_30 > 0)) begin
        myram_1_0_addr <= myram_1_0_addr + 1;
        _tmp_30 <= _tmp_30 - 1;
        _tmp_26 <= 1;
        _tmp_28 <= 0;
      end 
      if((_tmp_21 || !_tmp_19) && (_tmp_22 || !_tmp_20) && (_tmp_30 == 1)) begin
        _tmp_28 <= 1;
      end 
      if((th_blink == 25) && (_th_blink_bank_5 == 1)) begin
        myram_1_0_addr <= _th_blink_i_6;
        myram_1_0_wdata <= _th_blink_wdata_7;
        myram_1_0_wenable <= 1;
      end 
      _myram_1_cond_1_1 <= (th_blink == 25) && (_th_blink_bank_5 == 1);
      __tmp_82_1 <= _tmp_82;
      __tmp_83_1 <= _tmp_83;
      if((_tmp_79 || !_tmp_77) && (_tmp_80 || !_tmp_78) && _tmp_85) begin
        _tmp_87 <= 0;
        _tmp_77 <= 0;
        _tmp_78 <= 0;
        _tmp_85 <= 0;
      end 
      if((_tmp_79 || !_tmp_77) && (_tmp_80 || !_tmp_78) && _tmp_84) begin
        _tmp_77 <= 1;
        _tmp_78 <= 1;
        _tmp_87 <= _tmp_86;
        _tmp_86 <= 0;
        _tmp_84 <= 0;
        _tmp_85 <= 1;
      end 
      if((_tmp_fsm_1 == 1) && (_tmp_88 == 0) && !_tmp_86 && !_tmp_87) begin
        myram_1_0_addr <= _tmp_59;
        _tmp_88 <= _tmp_61 - 1;
        _tmp_84 <= 1;
        _tmp_86 <= _tmp_61 == 1;
      end 
      if((_tmp_79 || !_tmp_77) && (_tmp_80 || !_tmp_78) && (_tmp_88 > 0)) begin
        myram_1_0_addr <= myram_1_0_addr + 1;
        _tmp_88 <= _tmp_88 - 1;
        _tmp_84 <= 1;
        _tmp_86 <= 0;
      end 
      if((_tmp_79 || !_tmp_77) && (_tmp_80 || !_tmp_78) && (_tmp_88 == 1)) begin
        _tmp_86 <= 1;
      end 
      if((_tmp_fsm_2 == 1) && (_tmp_128 == 0)) begin
        myram_1_0_addr <= _tmp_117 - 1;
        _tmp_128 <= _tmp_119;
      end 
      if(_slice_valid_130 && ((_tmp_128 > 0) && !_tmp_129) && (_tmp_128 > 0)) begin
        myram_1_0_addr <= myram_1_0_addr + 1;
        myram_1_0_wdata <= _slice_data_130;
        myram_1_0_wenable <= 1;
        _tmp_128 <= _tmp_128 - 1;
      end 
      if(_slice_valid_130 && ((_tmp_128 > 0) && !_tmp_129) && (_tmp_128 == 1)) begin
        _tmp_129 <= 1;
      end 
      _myram_1_cond_2_1 <= 1;
      if(th_blink == 42) begin
        myram_1_0_addr <= _th_blink_i_6;
      end 
      _myram_1_cond_3_1 <= th_blink == 42;
      _myram_1_cond_4_1 <= th_blink == 42;
      if((_tmp_fsm_3 == 1) && (_tmp_155 == 0)) begin
        myram_1_0_addr <= _tmp_144 - 1;
        _tmp_155 <= _tmp_146;
      end 
      if(_slice_valid_157 && ((_tmp_155 > 0) && !_tmp_156) && (_tmp_155 > 0)) begin
        myram_1_0_addr <= myram_1_0_addr + 1;
        myram_1_0_wdata <= _slice_data_157;
        myram_1_0_wenable <= 1;
        _tmp_155 <= _tmp_155 - 1;
      end 
      if(_slice_valid_157 && ((_tmp_155 > 0) && !_tmp_156) && (_tmp_155 == 1)) begin
        _tmp_156 <= 1;
      end 
      _myram_1_cond_5_1 <= 1;
      if(th_blink == 58) begin
        myram_1_0_addr <= _th_blink_i_6;
      end 
      _myram_1_cond_6_1 <= th_blink == 58;
      _myram_1_cond_7_1 <= th_blink == 58;
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      myram_2_0_addr <= 0;
      myram_2_0_wdata <= 0;
      myram_2_0_wenable <= 0;
      _myram_2_cond_0_1 <= 0;
      __tmp_36_1 <= 0;
      __tmp_37_1 <= 0;
      _tmp_41 <= 0;
      _tmp_31 <= 0;
      _tmp_32 <= 0;
      _tmp_39 <= 0;
      _tmp_40 <= 0;
      _tmp_38 <= 0;
      _tmp_42 <= 0;
      _myram_2_cond_1_1 <= 0;
      __tmp_94_1 <= 0;
      __tmp_95_1 <= 0;
      _tmp_99 <= 0;
      _tmp_89 <= 0;
      _tmp_90 <= 0;
      _tmp_97 <= 0;
      _tmp_98 <= 0;
      _tmp_96 <= 0;
      _tmp_100 <= 0;
      _tmp_131 <= 0;
      _tmp_132 <= 0;
      _myram_2_cond_2_1 <= 0;
      _myram_2_cond_3_1 <= 0;
      _tmp_141 <= 0;
      _myram_2_cond_4_1 <= 0;
      _myram_2_cond_4_2 <= 0;
      _tmp_158 <= 0;
      _tmp_159 <= 0;
      _myram_2_cond_5_1 <= 0;
      _myram_2_cond_6_1 <= 0;
      _tmp_168 <= 0;
      _myram_2_cond_7_1 <= 0;
      _myram_2_cond_7_2 <= 0;
    end else begin
      if(_myram_2_cond_4_2) begin
        _tmp_141 <= 0;
      end 
      if(_myram_2_cond_7_2) begin
        _tmp_168 <= 0;
      end 
      if(_myram_2_cond_0_1) begin
        myram_2_0_wenable <= 0;
      end 
      if(_myram_2_cond_1_1) begin
        myram_2_0_wenable <= 0;
      end 
      if(_myram_2_cond_2_1) begin
        myram_2_0_wenable <= 0;
        _tmp_132 <= 0;
      end 
      if(_myram_2_cond_3_1) begin
        _tmp_141 <= 1;
      end 
      _myram_2_cond_4_2 <= _myram_2_cond_4_1;
      if(_myram_2_cond_5_1) begin
        myram_2_0_wenable <= 0;
        _tmp_159 <= 0;
      end 
      if(_myram_2_cond_6_1) begin
        _tmp_168 <= 1;
      end 
      _myram_2_cond_7_2 <= _myram_2_cond_7_1;
      if((th_blink == 12) && (_th_blink_bank_5 == 2)) begin
        myram_2_0_addr <= _th_blink_i_6;
        myram_2_0_wdata <= _th_blink_wdata_7;
        myram_2_0_wenable <= 1;
      end 
      _myram_2_cond_0_1 <= (th_blink == 12) && (_th_blink_bank_5 == 2);
      __tmp_36_1 <= _tmp_36;
      __tmp_37_1 <= _tmp_37;
      if((_tmp_33 || !_tmp_31) && (_tmp_34 || !_tmp_32) && _tmp_39) begin
        _tmp_41 <= 0;
        _tmp_31 <= 0;
        _tmp_32 <= 0;
        _tmp_39 <= 0;
      end 
      if((_tmp_33 || !_tmp_31) && (_tmp_34 || !_tmp_32) && _tmp_38) begin
        _tmp_31 <= 1;
        _tmp_32 <= 1;
        _tmp_41 <= _tmp_40;
        _tmp_40 <= 0;
        _tmp_38 <= 0;
        _tmp_39 <= 1;
      end 
      if((_tmp_fsm_0 == 1) && (_tmp_42 == 0) && !_tmp_40 && !_tmp_41) begin
        myram_2_0_addr <= _tmp_1;
        _tmp_42 <= _tmp_3 - 1;
        _tmp_38 <= 1;
        _tmp_40 <= _tmp_3 == 1;
      end 
      if((_tmp_33 || !_tmp_31) && (_tmp_34 || !_tmp_32) && (_tmp_42 > 0)) begin
        myram_2_0_addr <= myram_2_0_addr + 1;
        _tmp_42 <= _tmp_42 - 1;
        _tmp_38 <= 1;
        _tmp_40 <= 0;
      end 
      if((_tmp_33 || !_tmp_31) && (_tmp_34 || !_tmp_32) && (_tmp_42 == 1)) begin
        _tmp_40 <= 1;
      end 
      if((th_blink == 25) && (_th_blink_bank_5 == 2)) begin
        myram_2_0_addr <= _th_blink_i_6;
        myram_2_0_wdata <= _th_blink_wdata_7;
        myram_2_0_wenable <= 1;
      end 
      _myram_2_cond_1_1 <= (th_blink == 25) && (_th_blink_bank_5 == 2);
      __tmp_94_1 <= _tmp_94;
      __tmp_95_1 <= _tmp_95;
      if((_tmp_91 || !_tmp_89) && (_tmp_92 || !_tmp_90) && _tmp_97) begin
        _tmp_99 <= 0;
        _tmp_89 <= 0;
        _tmp_90 <= 0;
        _tmp_97 <= 0;
      end 
      if((_tmp_91 || !_tmp_89) && (_tmp_92 || !_tmp_90) && _tmp_96) begin
        _tmp_89 <= 1;
        _tmp_90 <= 1;
        _tmp_99 <= _tmp_98;
        _tmp_98 <= 0;
        _tmp_96 <= 0;
        _tmp_97 <= 1;
      end 
      if((_tmp_fsm_1 == 1) && (_tmp_100 == 0) && !_tmp_98 && !_tmp_99) begin
        myram_2_0_addr <= _tmp_59;
        _tmp_100 <= _tmp_61 - 1;
        _tmp_96 <= 1;
        _tmp_98 <= _tmp_61 == 1;
      end 
      if((_tmp_91 || !_tmp_89) && (_tmp_92 || !_tmp_90) && (_tmp_100 > 0)) begin
        myram_2_0_addr <= myram_2_0_addr + 1;
        _tmp_100 <= _tmp_100 - 1;
        _tmp_96 <= 1;
        _tmp_98 <= 0;
      end 
      if((_tmp_91 || !_tmp_89) && (_tmp_92 || !_tmp_90) && (_tmp_100 == 1)) begin
        _tmp_98 <= 1;
      end 
      if((_tmp_fsm_2 == 1) && (_tmp_131 == 0)) begin
        myram_2_0_addr <= _tmp_117 - 1;
        _tmp_131 <= _tmp_119;
      end 
      if(_slice_valid_133 && ((_tmp_131 > 0) && !_tmp_132) && (_tmp_131 > 0)) begin
        myram_2_0_addr <= myram_2_0_addr + 1;
        myram_2_0_wdata <= _slice_data_133;
        myram_2_0_wenable <= 1;
        _tmp_131 <= _tmp_131 - 1;
      end 
      if(_slice_valid_133 && ((_tmp_131 > 0) && !_tmp_132) && (_tmp_131 == 1)) begin
        _tmp_132 <= 1;
      end 
      _myram_2_cond_2_1 <= 1;
      if(th_blink == 42) begin
        myram_2_0_addr <= _th_blink_i_6;
      end 
      _myram_2_cond_3_1 <= th_blink == 42;
      _myram_2_cond_4_1 <= th_blink == 42;
      if((_tmp_fsm_3 == 1) && (_tmp_158 == 0)) begin
        myram_2_0_addr <= _tmp_144 - 1;
        _tmp_158 <= _tmp_146;
      end 
      if(_slice_valid_160 && ((_tmp_158 > 0) && !_tmp_159) && (_tmp_158 > 0)) begin
        myram_2_0_addr <= myram_2_0_addr + 1;
        myram_2_0_wdata <= _slice_data_160;
        myram_2_0_wenable <= 1;
        _tmp_158 <= _tmp_158 - 1;
      end 
      if(_slice_valid_160 && ((_tmp_158 > 0) && !_tmp_159) && (_tmp_158 == 1)) begin
        _tmp_159 <= 1;
      end 
      _myram_2_cond_5_1 <= 1;
      if(th_blink == 58) begin
        myram_2_0_addr <= _th_blink_i_6;
      end 
      _myram_2_cond_6_1 <= th_blink == 58;
      _myram_2_cond_7_1 <= th_blink == 58;
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      myram_3_0_addr <= 0;
      myram_3_0_wdata <= 0;
      myram_3_0_wenable <= 0;
      _myram_3_cond_0_1 <= 0;
      __tmp_48_1 <= 0;
      __tmp_49_1 <= 0;
      _tmp_53 <= 0;
      _tmp_43 <= 0;
      _tmp_44 <= 0;
      _tmp_51 <= 0;
      _tmp_52 <= 0;
      _tmp_50 <= 0;
      _tmp_54 <= 0;
      _myram_3_cond_1_1 <= 0;
      __tmp_106_1 <= 0;
      __tmp_107_1 <= 0;
      _tmp_111 <= 0;
      _tmp_101 <= 0;
      _tmp_102 <= 0;
      _tmp_109 <= 0;
      _tmp_110 <= 0;
      _tmp_108 <= 0;
      _tmp_112 <= 0;
      _tmp_134 <= 0;
      _tmp_135 <= 0;
      _myram_3_cond_2_1 <= 0;
      _myram_3_cond_3_1 <= 0;
      _tmp_142 <= 0;
      _myram_3_cond_4_1 <= 0;
      _myram_3_cond_4_2 <= 0;
      _tmp_161 <= 0;
      _tmp_162 <= 0;
      _myram_3_cond_5_1 <= 0;
      _myram_3_cond_6_1 <= 0;
      _tmp_169 <= 0;
      _myram_3_cond_7_1 <= 0;
      _myram_3_cond_7_2 <= 0;
    end else begin
      if(_myram_3_cond_4_2) begin
        _tmp_142 <= 0;
      end 
      if(_myram_3_cond_7_2) begin
        _tmp_169 <= 0;
      end 
      if(_myram_3_cond_0_1) begin
        myram_3_0_wenable <= 0;
      end 
      if(_myram_3_cond_1_1) begin
        myram_3_0_wenable <= 0;
      end 
      if(_myram_3_cond_2_1) begin
        myram_3_0_wenable <= 0;
        _tmp_135 <= 0;
      end 
      if(_myram_3_cond_3_1) begin
        _tmp_142 <= 1;
      end 
      _myram_3_cond_4_2 <= _myram_3_cond_4_1;
      if(_myram_3_cond_5_1) begin
        myram_3_0_wenable <= 0;
        _tmp_162 <= 0;
      end 
      if(_myram_3_cond_6_1) begin
        _tmp_169 <= 1;
      end 
      _myram_3_cond_7_2 <= _myram_3_cond_7_1;
      if((th_blink == 12) && (_th_blink_bank_5 == 3)) begin
        myram_3_0_addr <= _th_blink_i_6;
        myram_3_0_wdata <= _th_blink_wdata_7;
        myram_3_0_wenable <= 1;
      end 
      _myram_3_cond_0_1 <= (th_blink == 12) && (_th_blink_bank_5 == 3);
      __tmp_48_1 <= _tmp_48;
      __tmp_49_1 <= _tmp_49;
      if((_tmp_45 || !_tmp_43) && (_tmp_46 || !_tmp_44) && _tmp_51) begin
        _tmp_53 <= 0;
        _tmp_43 <= 0;
        _tmp_44 <= 0;
        _tmp_51 <= 0;
      end 
      if((_tmp_45 || !_tmp_43) && (_tmp_46 || !_tmp_44) && _tmp_50) begin
        _tmp_43 <= 1;
        _tmp_44 <= 1;
        _tmp_53 <= _tmp_52;
        _tmp_52 <= 0;
        _tmp_50 <= 0;
        _tmp_51 <= 1;
      end 
      if((_tmp_fsm_0 == 1) && (_tmp_54 == 0) && !_tmp_52 && !_tmp_53) begin
        myram_3_0_addr <= _tmp_1;
        _tmp_54 <= _tmp_3 - 1;
        _tmp_50 <= 1;
        _tmp_52 <= _tmp_3 == 1;
      end 
      if((_tmp_45 || !_tmp_43) && (_tmp_46 || !_tmp_44) && (_tmp_54 > 0)) begin
        myram_3_0_addr <= myram_3_0_addr + 1;
        _tmp_54 <= _tmp_54 - 1;
        _tmp_50 <= 1;
        _tmp_52 <= 0;
      end 
      if((_tmp_45 || !_tmp_43) && (_tmp_46 || !_tmp_44) && (_tmp_54 == 1)) begin
        _tmp_52 <= 1;
      end 
      if((th_blink == 25) && (_th_blink_bank_5 == 3)) begin
        myram_3_0_addr <= _th_blink_i_6;
        myram_3_0_wdata <= _th_blink_wdata_7;
        myram_3_0_wenable <= 1;
      end 
      _myram_3_cond_1_1 <= (th_blink == 25) && (_th_blink_bank_5 == 3);
      __tmp_106_1 <= _tmp_106;
      __tmp_107_1 <= _tmp_107;
      if((_tmp_103 || !_tmp_101) && (_tmp_104 || !_tmp_102) && _tmp_109) begin
        _tmp_111 <= 0;
        _tmp_101 <= 0;
        _tmp_102 <= 0;
        _tmp_109 <= 0;
      end 
      if((_tmp_103 || !_tmp_101) && (_tmp_104 || !_tmp_102) && _tmp_108) begin
        _tmp_101 <= 1;
        _tmp_102 <= 1;
        _tmp_111 <= _tmp_110;
        _tmp_110 <= 0;
        _tmp_108 <= 0;
        _tmp_109 <= 1;
      end 
      if((_tmp_fsm_1 == 1) && (_tmp_112 == 0) && !_tmp_110 && !_tmp_111) begin
        myram_3_0_addr <= _tmp_59;
        _tmp_112 <= _tmp_61 - 1;
        _tmp_108 <= 1;
        _tmp_110 <= _tmp_61 == 1;
      end 
      if((_tmp_103 || !_tmp_101) && (_tmp_104 || !_tmp_102) && (_tmp_112 > 0)) begin
        myram_3_0_addr <= myram_3_0_addr + 1;
        _tmp_112 <= _tmp_112 - 1;
        _tmp_108 <= 1;
        _tmp_110 <= 0;
      end 
      if((_tmp_103 || !_tmp_101) && (_tmp_104 || !_tmp_102) && (_tmp_112 == 1)) begin
        _tmp_110 <= 1;
      end 
      if((_tmp_fsm_2 == 1) && (_tmp_134 == 0)) begin
        myram_3_0_addr <= _tmp_117 - 1;
        _tmp_134 <= _tmp_119;
      end 
      if(_slice_valid_136 && ((_tmp_134 > 0) && !_tmp_135) && (_tmp_134 > 0)) begin
        myram_3_0_addr <= myram_3_0_addr + 1;
        myram_3_0_wdata <= _slice_data_136;
        myram_3_0_wenable <= 1;
        _tmp_134 <= _tmp_134 - 1;
      end 
      if(_slice_valid_136 && ((_tmp_134 > 0) && !_tmp_135) && (_tmp_134 == 1)) begin
        _tmp_135 <= 1;
      end 
      _myram_3_cond_2_1 <= 1;
      if(th_blink == 42) begin
        myram_3_0_addr <= _th_blink_i_6;
      end 
      _myram_3_cond_3_1 <= th_blink == 42;
      _myram_3_cond_4_1 <= th_blink == 42;
      if((_tmp_fsm_3 == 1) && (_tmp_161 == 0)) begin
        myram_3_0_addr <= _tmp_144 - 1;
        _tmp_161 <= _tmp_146;
      end 
      if(_slice_valid_163 && ((_tmp_161 > 0) && !_tmp_162) && (_tmp_161 > 0)) begin
        myram_3_0_addr <= myram_3_0_addr + 1;
        myram_3_0_wdata <= _slice_data_163;
        myram_3_0_wenable <= 1;
        _tmp_161 <= _tmp_161 - 1;
      end 
      if(_slice_valid_163 && ((_tmp_161 > 0) && !_tmp_162) && (_tmp_161 == 1)) begin
        _tmp_162 <= 1;
      end 
      _myram_3_cond_5_1 <= 1;
      if(th_blink == 58) begin
        myram_3_0_addr <= _th_blink_i_6;
      end 
      _myram_3_cond_6_1 <= th_blink == 58;
      _myram_3_cond_7_1 <= th_blink == 58;
    end
  end

  localparam th_blink_1 = 1;
  localparam th_blink_2 = 2;
  localparam th_blink_3 = 3;
  localparam th_blink_4 = 4;
  localparam th_blink_5 = 5;
  localparam th_blink_6 = 6;
  localparam th_blink_7 = 7;
  localparam th_blink_8 = 8;
  localparam th_blink_9 = 9;
  localparam th_blink_10 = 10;
  localparam th_blink_11 = 11;
  localparam th_blink_12 = 12;
  localparam th_blink_13 = 13;
  localparam th_blink_14 = 14;
  localparam th_blink_15 = 15;
  localparam th_blink_16 = 16;
  localparam th_blink_17 = 17;
  localparam th_blink_18 = 18;
  localparam th_blink_19 = 19;
  localparam th_blink_20 = 20;
  localparam th_blink_21 = 21;
  localparam th_blink_22 = 22;
  localparam th_blink_23 = 23;
  localparam th_blink_24 = 24;
  localparam th_blink_25 = 25;
  localparam th_blink_26 = 26;
  localparam th_blink_27 = 27;
  localparam th_blink_28 = 28;
  localparam th_blink_29 = 29;
  localparam th_blink_30 = 30;
  localparam th_blink_31 = 31;
  localparam th_blink_32 = 32;
  localparam th_blink_33 = 33;
  localparam th_blink_34 = 34;
  localparam th_blink_35 = 35;
  localparam th_blink_36 = 36;
  localparam th_blink_37 = 37;
  localparam th_blink_38 = 38;
  localparam th_blink_39 = 39;
  localparam th_blink_40 = 40;
  localparam th_blink_41 = 41;
  localparam th_blink_42 = 42;
  localparam th_blink_43 = 43;
  localparam th_blink_44 = 44;
  localparam th_blink_45 = 45;
  localparam th_blink_46 = 46;
  localparam th_blink_47 = 47;
  localparam th_blink_48 = 48;
  localparam th_blink_49 = 49;
  localparam th_blink_50 = 50;
  localparam th_blink_51 = 51;
  localparam th_blink_52 = 52;
  localparam th_blink_53 = 53;
  localparam th_blink_54 = 54;
  localparam th_blink_55 = 55;
  localparam th_blink_56 = 56;
  localparam th_blink_57 = 57;
  localparam th_blink_58 = 58;
  localparam th_blink_59 = 59;
  localparam th_blink_60 = 60;
  localparam th_blink_61 = 61;
  localparam th_blink_62 = 62;
  localparam th_blink_63 = 63;
  localparam th_blink_64 = 64;
  localparam th_blink_65 = 65;
  localparam th_blink_66 = 66;
  localparam th_blink_67 = 67;
  localparam th_blink_68 = 68;
  localparam th_blink_69 = 69;

  always @(posedge CLK) begin
    if(RST) begin
      th_blink <= th_blink_init;
      _th_blink_size_0 <= 0;
      _tmp_0 <= 0;
      _th_blink_i_1 <= 0;
      _th_blink_offset_2 <= 0;
      _th_blink_size_3 <= 0;
      _th_blink_offset_4 <= 0;
      _th_blink_bank_5 <= 0;
      _th_blink_i_6 <= 0;
      _th_blink_wdata_7 <= 0;
      _th_blink_laddr_8 <= 0;
      _th_blink_gaddr_9 <= 0;
      _tmp_1 <= 0;
      _tmp_2 <= 0;
      _tmp_3 <= 0;
      _tmp_59 <= 0;
      _tmp_60 <= 0;
      _tmp_61 <= 0;
      _tmp_117 <= 0;
      _tmp_118 <= 0;
      _tmp_119 <= 0;
      _tmp_143 <= 0;
      _th_blink_rdata_10 <= 0;
      _tmp_144 <= 0;
      _tmp_145 <= 0;
      _tmp_146 <= 0;
      _tmp_170 <= 0;
    end else begin
      case(th_blink)
        th_blink_init: begin
          _th_blink_size_0 <= 16;
          th_blink <= th_blink_1;
        end
        th_blink_1: begin
          _tmp_0 <= 1;
          th_blink <= th_blink_2;
        end
        th_blink_2: begin
          _th_blink_i_1 <= 0;
          th_blink <= th_blink_3;
        end
        th_blink_3: begin
          if(_th_blink_i_1 < 4) begin
            th_blink <= th_blink_4;
          end else begin
            th_blink <= th_blink_67;
          end
        end
        th_blink_4: begin
          $display("# iter %d start", _th_blink_i_1);
          th_blink <= th_blink_5;
        end
        th_blink_5: begin
          _th_blink_offset_2 <= ((_th_blink_i_1 << 10) << 4) + 4092;
          th_blink <= th_blink_6;
        end
        th_blink_6: begin
          _th_blink_size_3 <= _th_blink_size_0;
          _th_blink_offset_4 <= _th_blink_offset_2;
          th_blink <= th_blink_7;
        end
        th_blink_7: begin
          _th_blink_bank_5 <= 0;
          th_blink <= th_blink_8;
        end
        th_blink_8: begin
          if(_th_blink_bank_5 < 4) begin
            th_blink <= th_blink_9;
          end else begin
            th_blink <= th_blink_15;
          end
        end
        th_blink_9: begin
          _th_blink_i_6 <= 0;
          th_blink <= th_blink_10;
        end
        th_blink_10: begin
          if(_th_blink_i_6 < _th_blink_size_3) begin
            th_blink <= th_blink_11;
          end else begin
            th_blink <= th_blink_14;
          end
        end
        th_blink_11: begin
          _th_blink_wdata_7 <= _th_blink_i_6 + 100 + _th_blink_bank_5;
          th_blink <= th_blink_12;
        end
        th_blink_12: begin
          th_blink <= th_blink_13;
        end
        th_blink_13: begin
          _th_blink_i_6 <= _th_blink_i_6 + 1;
          th_blink <= th_blink_10;
        end
        th_blink_14: begin
          _th_blink_bank_5 <= _th_blink_bank_5 + 1;
          th_blink <= th_blink_8;
        end
        th_blink_15: begin
          _th_blink_laddr_8 <= 0;
          th_blink <= th_blink_16;
        end
        th_blink_16: begin
          _th_blink_gaddr_9 <= _th_blink_offset_4;
          th_blink <= th_blink_17;
        end
        th_blink_17: begin
          _tmp_1 <= _th_blink_laddr_8;
          _tmp_2 <= _th_blink_gaddr_9;
          _tmp_3 <= _th_blink_size_3;
          th_blink <= th_blink_18;
        end
        th_blink_18: begin
          if(_tmp_58) begin
            th_blink <= th_blink_19;
          end 
        end
        th_blink_19: begin
          $display("dma_write: [%d] -> [%d]", _th_blink_laddr_8, _th_blink_gaddr_9);
          th_blink <= th_blink_20;
        end
        th_blink_20: begin
          _th_blink_bank_5 <= 0;
          th_blink <= th_blink_21;
        end
        th_blink_21: begin
          if(_th_blink_bank_5 < 4) begin
            th_blink <= th_blink_22;
          end else begin
            th_blink <= th_blink_28;
          end
        end
        th_blink_22: begin
          _th_blink_i_6 <= 0;
          th_blink <= th_blink_23;
        end
        th_blink_23: begin
          if(_th_blink_i_6 < _th_blink_size_3) begin
            th_blink <= th_blink_24;
          end else begin
            th_blink <= th_blink_27;
          end
        end
        th_blink_24: begin
          _th_blink_wdata_7 <= _th_blink_i_6 + 1000 + _th_blink_bank_5;
          th_blink <= th_blink_25;
        end
        th_blink_25: begin
          th_blink <= th_blink_26;
        end
        th_blink_26: begin
          _th_blink_i_6 <= _th_blink_i_6 + 1;
          th_blink <= th_blink_23;
        end
        th_blink_27: begin
          _th_blink_bank_5 <= _th_blink_bank_5 + 1;
          th_blink <= th_blink_21;
        end
        th_blink_28: begin
          _th_blink_laddr_8 <= 0;
          th_blink <= th_blink_29;
        end
        th_blink_29: begin
          _th_blink_gaddr_9 <= 512 + _th_blink_offset_4;
          th_blink <= th_blink_30;
        end
        th_blink_30: begin
          _tmp_59 <= _th_blink_laddr_8;
          _tmp_60 <= _th_blink_gaddr_9;
          _tmp_61 <= _th_blink_size_3;
          th_blink <= th_blink_31;
        end
        th_blink_31: begin
          if(_tmp_116) begin
            th_blink <= th_blink_32;
          end 
        end
        th_blink_32: begin
          $display("dma_write: [%d] -> [%d]", _th_blink_laddr_8, _th_blink_gaddr_9);
          th_blink <= th_blink_33;
        end
        th_blink_33: begin
          _th_blink_laddr_8 <= 0;
          th_blink <= th_blink_34;
        end
        th_blink_34: begin
          _th_blink_gaddr_9 <= _th_blink_offset_4;
          th_blink <= th_blink_35;
        end
        th_blink_35: begin
          _tmp_117 <= _th_blink_laddr_8;
          _tmp_118 <= _th_blink_gaddr_9;
          _tmp_119 <= _th_blink_size_3;
          th_blink <= th_blink_36;
        end
        th_blink_36: begin
          if(_tmp_138) begin
            th_blink <= th_blink_37;
          end 
        end
        th_blink_37: begin
          $display("dma_read:  [%d] <- [%d]", _th_blink_laddr_8, _th_blink_gaddr_9);
          th_blink <= th_blink_38;
        end
        th_blink_38: begin
          _th_blink_bank_5 <= 0;
          th_blink <= th_blink_39;
        end
        th_blink_39: begin
          if(_th_blink_bank_5 < 4) begin
            th_blink <= th_blink_40;
          end else begin
            th_blink <= th_blink_49;
          end
        end
        th_blink_40: begin
          _th_blink_i_6 <= 0;
          th_blink <= th_blink_41;
        end
        th_blink_41: begin
          if(_th_blink_i_6 < _th_blink_size_3) begin
            th_blink <= th_blink_42;
          end else begin
            th_blink <= th_blink_48;
          end
        end
        th_blink_42: begin
          if(_tmp_139 && (_th_blink_bank_5 == 0)) begin
            _tmp_143 <= myram_0_0_rdata;
          end 
          if(_tmp_140 && (_th_blink_bank_5 == 1)) begin
            _tmp_143 <= myram_1_0_rdata;
          end 
          if(_tmp_141 && (_th_blink_bank_5 == 2)) begin
            _tmp_143 <= myram_2_0_rdata;
          end 
          if(_tmp_142 && (_th_blink_bank_5 == 3)) begin
            _tmp_143 <= myram_3_0_rdata;
          end 
          if(_tmp_139) begin
            th_blink <= th_blink_43;
          end 
        end
        th_blink_43: begin
          _th_blink_rdata_10 <= _tmp_143;
          th_blink <= th_blink_44;
        end
        th_blink_44: begin
          if(_th_blink_rdata_10 !== _th_blink_i_6 + 100 + _th_blink_bank_5) begin
            th_blink <= th_blink_45;
          end else begin
            th_blink <= th_blink_47;
          end
        end
        th_blink_45: begin
          $display("rdata[%d] = %d", _th_blink_i_6, _th_blink_rdata_10);
          th_blink <= th_blink_46;
        end
        th_blink_46: begin
          _tmp_0 <= 0;
          th_blink <= th_blink_47;
        end
        th_blink_47: begin
          _th_blink_i_6 <= _th_blink_i_6 + 1;
          th_blink <= th_blink_41;
        end
        th_blink_48: begin
          _th_blink_bank_5 <= _th_blink_bank_5 + 1;
          th_blink <= th_blink_39;
        end
        th_blink_49: begin
          _th_blink_laddr_8 <= 0;
          th_blink <= th_blink_50;
        end
        th_blink_50: begin
          _th_blink_gaddr_9 <= 512 + _th_blink_offset_4;
          th_blink <= th_blink_51;
        end
        th_blink_51: begin
          _tmp_144 <= _th_blink_laddr_8;
          _tmp_145 <= _th_blink_gaddr_9;
          _tmp_146 <= _th_blink_size_3;
          th_blink <= th_blink_52;
        end
        th_blink_52: begin
          if(_tmp_165) begin
            th_blink <= th_blink_53;
          end 
        end
        th_blink_53: begin
          $display("dma_read:  [%d] <- [%d]", _th_blink_laddr_8, _th_blink_gaddr_9);
          th_blink <= th_blink_54;
        end
        th_blink_54: begin
          _th_blink_bank_5 <= 0;
          th_blink <= th_blink_55;
        end
        th_blink_55: begin
          if(_th_blink_bank_5 < 4) begin
            th_blink <= th_blink_56;
          end else begin
            th_blink <= th_blink_65;
          end
        end
        th_blink_56: begin
          _th_blink_i_6 <= 0;
          th_blink <= th_blink_57;
        end
        th_blink_57: begin
          if(_th_blink_i_6 < _th_blink_size_3) begin
            th_blink <= th_blink_58;
          end else begin
            th_blink <= th_blink_64;
          end
        end
        th_blink_58: begin
          if(_tmp_166 && (_th_blink_bank_5 == 0)) begin
            _tmp_170 <= myram_0_0_rdata;
          end 
          if(_tmp_167 && (_th_blink_bank_5 == 1)) begin
            _tmp_170 <= myram_1_0_rdata;
          end 
          if(_tmp_168 && (_th_blink_bank_5 == 2)) begin
            _tmp_170 <= myram_2_0_rdata;
          end 
          if(_tmp_169 && (_th_blink_bank_5 == 3)) begin
            _tmp_170 <= myram_3_0_rdata;
          end 
          if(_tmp_166) begin
            th_blink <= th_blink_59;
          end 
        end
        th_blink_59: begin
          _th_blink_rdata_10 <= _tmp_170;
          th_blink <= th_blink_60;
        end
        th_blink_60: begin
          if(_th_blink_rdata_10 !== _th_blink_i_6 + 1000 + _th_blink_bank_5) begin
            th_blink <= th_blink_61;
          end else begin
            th_blink <= th_blink_63;
          end
        end
        th_blink_61: begin
          $display("rdata[%d] = %d", _th_blink_i_6, _th_blink_rdata_10);
          th_blink <= th_blink_62;
        end
        th_blink_62: begin
          _tmp_0 <= 0;
          th_blink <= th_blink_63;
        end
        th_blink_63: begin
          _th_blink_i_6 <= _th_blink_i_6 + 1;
          th_blink <= th_blink_57;
        end
        th_blink_64: begin
          _th_blink_bank_5 <= _th_blink_bank_5 + 1;
          th_blink <= th_blink_55;
        end
        th_blink_65: begin
          $display("# iter %d end", _th_blink_i_1);
          th_blink <= th_blink_66;
        end
        th_blink_66: begin
          _th_blink_i_1 <= _th_blink_i_1 + 1;
          th_blink <= th_blink_3;
        end
        th_blink_67: begin
          if(_tmp_0) begin
            th_blink <= th_blink_68;
          end else begin
            th_blink <= th_blink_69;
          end
        end
        th_blink_68: begin
          $display("ALL OK");
          th_blink <= th_blink_69;
        end
      endcase
    end
  end

  localparam _tmp_fsm_0_1 = 1;
  localparam _tmp_fsm_0_2 = 2;
  localparam _tmp_fsm_0_3 = 3;
  localparam _tmp_fsm_0_4 = 4;
  localparam _tmp_fsm_0_5 = 5;
  localparam _tmp_fsm_0_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_0 <= _tmp_fsm_0_init;
      _d1__tmp_fsm_0 <= _tmp_fsm_0_init;
      _tmp_4 <= 0;
      _tmp_6 <= 0;
      _tmp_5 <= 0;
      _tmp_58 <= 0;
      __tmp_fsm_0_cond_5_0_1 <= 0;
    end else begin
      _d1__tmp_fsm_0 <= _tmp_fsm_0;
      case(_d1__tmp_fsm_0)
        _tmp_fsm_0_5: begin
          if(__tmp_fsm_0_cond_5_0_1) begin
            _tmp_58 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_0)
        _tmp_fsm_0_init: begin
          if(th_blink == 18) begin
            _tmp_fsm_0 <= _tmp_fsm_0_1;
          end 
        end
        _tmp_fsm_0_1: begin
          _tmp_4 <= (_tmp_2 >> 4) << 4;
          _tmp_6 <= _tmp_3;
          _tmp_fsm_0 <= _tmp_fsm_0_2;
        end
        _tmp_fsm_0_2: begin
          if((_tmp_6 <= 256) && ((_tmp_4 & 4095) + (_tmp_6 << 4) >= 4096)) begin
            _tmp_5 <= 4096 - (_tmp_4 & 4095) >> 4;
            _tmp_6 <= _tmp_6 - (4096 - (_tmp_4 & 4095) >> 4);
          end else if(_tmp_6 <= 256) begin
            _tmp_5 <= _tmp_6;
            _tmp_6 <= 0;
          end else if((_tmp_4 & 4095) + 4096 >= 4096) begin
            _tmp_5 <= 4096 - (_tmp_4 & 4095) >> 4;
            _tmp_6 <= _tmp_6 - (4096 - (_tmp_4 & 4095) >> 4);
          end else begin
            _tmp_5 <= 256;
            _tmp_6 <= _tmp_6 - 256;
          end
          _tmp_fsm_0 <= _tmp_fsm_0_3;
        end
        _tmp_fsm_0_3: begin
          if(myaxi_awready || !myaxi_awvalid) begin
            _tmp_fsm_0 <= _tmp_fsm_0_4;
          end 
        end
        _tmp_fsm_0_4: begin
          if(_tmp_56 && myaxi_wvalid && myaxi_wready) begin
            _tmp_4 <= _tmp_4 + (_tmp_5 << 4);
          end 
          if(_tmp_56 && myaxi_wvalid && myaxi_wready && (_tmp_6 > 0)) begin
            _tmp_fsm_0 <= _tmp_fsm_0_2;
          end 
          if(_tmp_56 && myaxi_wvalid && myaxi_wready && (_tmp_6 == 0)) begin
            _tmp_fsm_0 <= _tmp_fsm_0_5;
          end 
        end
        _tmp_fsm_0_5: begin
          _tmp_58 <= 1;
          __tmp_fsm_0_cond_5_0_1 <= 1;
          _tmp_fsm_0 <= _tmp_fsm_0_6;
        end
        _tmp_fsm_0_6: begin
          _tmp_fsm_0 <= _tmp_fsm_0_init;
        end
      endcase
    end
  end

  localparam _tmp_fsm_1_1 = 1;
  localparam _tmp_fsm_1_2 = 2;
  localparam _tmp_fsm_1_3 = 3;
  localparam _tmp_fsm_1_4 = 4;
  localparam _tmp_fsm_1_5 = 5;
  localparam _tmp_fsm_1_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_1 <= _tmp_fsm_1_init;
      _d1__tmp_fsm_1 <= _tmp_fsm_1_init;
      _tmp_62 <= 0;
      _tmp_64 <= 0;
      _tmp_63 <= 0;
      _tmp_116 <= 0;
      __tmp_fsm_1_cond_5_0_1 <= 0;
    end else begin
      _d1__tmp_fsm_1 <= _tmp_fsm_1;
      case(_d1__tmp_fsm_1)
        _tmp_fsm_1_5: begin
          if(__tmp_fsm_1_cond_5_0_1) begin
            _tmp_116 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_1)
        _tmp_fsm_1_init: begin
          if(th_blink == 31) begin
            _tmp_fsm_1 <= _tmp_fsm_1_1;
          end 
        end
        _tmp_fsm_1_1: begin
          _tmp_62 <= (_tmp_60 >> 4) << 4;
          _tmp_64 <= _tmp_61;
          _tmp_fsm_1 <= _tmp_fsm_1_2;
        end
        _tmp_fsm_1_2: begin
          if((_tmp_64 <= 256) && ((_tmp_62 & 4095) + (_tmp_64 << 4) >= 4096)) begin
            _tmp_63 <= 4096 - (_tmp_62 & 4095) >> 4;
            _tmp_64 <= _tmp_64 - (4096 - (_tmp_62 & 4095) >> 4);
          end else if(_tmp_64 <= 256) begin
            _tmp_63 <= _tmp_64;
            _tmp_64 <= 0;
          end else if((_tmp_62 & 4095) + 4096 >= 4096) begin
            _tmp_63 <= 4096 - (_tmp_62 & 4095) >> 4;
            _tmp_64 <= _tmp_64 - (4096 - (_tmp_62 & 4095) >> 4);
          end else begin
            _tmp_63 <= 256;
            _tmp_64 <= _tmp_64 - 256;
          end
          _tmp_fsm_1 <= _tmp_fsm_1_3;
        end
        _tmp_fsm_1_3: begin
          if(myaxi_awready || !myaxi_awvalid) begin
            _tmp_fsm_1 <= _tmp_fsm_1_4;
          end 
        end
        _tmp_fsm_1_4: begin
          if(_tmp_114 && myaxi_wvalid && myaxi_wready) begin
            _tmp_62 <= _tmp_62 + (_tmp_63 << 4);
          end 
          if(_tmp_114 && myaxi_wvalid && myaxi_wready && (_tmp_64 > 0)) begin
            _tmp_fsm_1 <= _tmp_fsm_1_2;
          end 
          if(_tmp_114 && myaxi_wvalid && myaxi_wready && (_tmp_64 == 0)) begin
            _tmp_fsm_1 <= _tmp_fsm_1_5;
          end 
        end
        _tmp_fsm_1_5: begin
          _tmp_116 <= 1;
          __tmp_fsm_1_cond_5_0_1 <= 1;
          _tmp_fsm_1 <= _tmp_fsm_1_6;
        end
        _tmp_fsm_1_6: begin
          _tmp_fsm_1 <= _tmp_fsm_1_init;
        end
      endcase
    end
  end

  localparam _tmp_fsm_2_1 = 1;
  localparam _tmp_fsm_2_2 = 2;
  localparam _tmp_fsm_2_3 = 3;
  localparam _tmp_fsm_2_4 = 4;
  localparam _tmp_fsm_2_5 = 5;
  localparam _tmp_fsm_2_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_2 <= _tmp_fsm_2_init;
      _d1__tmp_fsm_2 <= _tmp_fsm_2_init;
      _tmp_120 <= 0;
      _tmp_122 <= 0;
      _tmp_121 <= 0;
      __tmp_fsm_2_cond_4_0_1 <= 0;
      _tmp_124 <= 0;
      _tmp_123 <= 0;
      _tmp_138 <= 0;
      __tmp_fsm_2_cond_5_1_1 <= 0;
    end else begin
      _d1__tmp_fsm_2 <= _tmp_fsm_2;
      case(_d1__tmp_fsm_2)
        _tmp_fsm_2_4: begin
          if(__tmp_fsm_2_cond_4_0_1) begin
            _tmp_124 <= 0;
          end 
        end
        _tmp_fsm_2_5: begin
          if(__tmp_fsm_2_cond_5_1_1) begin
            _tmp_138 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_2)
        _tmp_fsm_2_init: begin
          if(th_blink == 36) begin
            _tmp_fsm_2 <= _tmp_fsm_2_1;
          end 
        end
        _tmp_fsm_2_1: begin
          _tmp_120 <= (_tmp_118 >> 4) << 4;
          _tmp_122 <= _tmp_119;
          _tmp_fsm_2 <= _tmp_fsm_2_2;
        end
        _tmp_fsm_2_2: begin
          if((_tmp_122 <= 256) && ((_tmp_120 & 4095) + (_tmp_122 << 4) >= 4096)) begin
            _tmp_121 <= 4096 - (_tmp_120 & 4095) >> 4;
            _tmp_122 <= _tmp_122 - (4096 - (_tmp_120 & 4095) >> 4);
          end else if(_tmp_122 <= 256) begin
            _tmp_121 <= _tmp_122;
            _tmp_122 <= 0;
          end else if((_tmp_120 & 4095) + 4096 >= 4096) begin
            _tmp_121 <= 4096 - (_tmp_120 & 4095) >> 4;
            _tmp_122 <= _tmp_122 - (4096 - (_tmp_120 & 4095) >> 4);
          end else begin
            _tmp_121 <= 256;
            _tmp_122 <= _tmp_122 - 256;
          end
          _tmp_fsm_2 <= _tmp_fsm_2_3;
        end
        _tmp_fsm_2_3: begin
          if(myaxi_arready || !myaxi_arvalid) begin
            _tmp_fsm_2 <= _tmp_fsm_2_4;
          end 
        end
        _tmp_fsm_2_4: begin
          __tmp_fsm_2_cond_4_0_1 <= 1;
          if(myaxi_rready && myaxi_rvalid) begin
            _tmp_123 <= myaxi_rdata;
            _tmp_124 <= 1;
          end 
          if(myaxi_rready && myaxi_rvalid && myaxi_rlast) begin
            _tmp_120 <= _tmp_120 + (_tmp_121 << 4);
          end 
          if(myaxi_rready && myaxi_rvalid && myaxi_rlast && (_tmp_122 > 0)) begin
            _tmp_fsm_2 <= _tmp_fsm_2_2;
          end 
          if(myaxi_rready && myaxi_rvalid && myaxi_rlast && (_tmp_122 == 0)) begin
            _tmp_fsm_2 <= _tmp_fsm_2_5;
          end 
        end
        _tmp_fsm_2_5: begin
          _tmp_138 <= 1;
          __tmp_fsm_2_cond_5_1_1 <= 1;
          _tmp_fsm_2 <= _tmp_fsm_2_6;
        end
        _tmp_fsm_2_6: begin
          _tmp_fsm_2 <= _tmp_fsm_2_init;
        end
      endcase
    end
  end

  localparam _tmp_fsm_3_1 = 1;
  localparam _tmp_fsm_3_2 = 2;
  localparam _tmp_fsm_3_3 = 3;
  localparam _tmp_fsm_3_4 = 4;
  localparam _tmp_fsm_3_5 = 5;
  localparam _tmp_fsm_3_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_3 <= _tmp_fsm_3_init;
      _d1__tmp_fsm_3 <= _tmp_fsm_3_init;
      _tmp_147 <= 0;
      _tmp_149 <= 0;
      _tmp_148 <= 0;
      __tmp_fsm_3_cond_4_0_1 <= 0;
      _tmp_151 <= 0;
      _tmp_150 <= 0;
      _tmp_165 <= 0;
      __tmp_fsm_3_cond_5_1_1 <= 0;
    end else begin
      _d1__tmp_fsm_3 <= _tmp_fsm_3;
      case(_d1__tmp_fsm_3)
        _tmp_fsm_3_4: begin
          if(__tmp_fsm_3_cond_4_0_1) begin
            _tmp_151 <= 0;
          end 
        end
        _tmp_fsm_3_5: begin
          if(__tmp_fsm_3_cond_5_1_1) begin
            _tmp_165 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_3)
        _tmp_fsm_3_init: begin
          if(th_blink == 52) begin
            _tmp_fsm_3 <= _tmp_fsm_3_1;
          end 
        end
        _tmp_fsm_3_1: begin
          _tmp_147 <= (_tmp_145 >> 4) << 4;
          _tmp_149 <= _tmp_146;
          _tmp_fsm_3 <= _tmp_fsm_3_2;
        end
        _tmp_fsm_3_2: begin
          if((_tmp_149 <= 256) && ((_tmp_147 & 4095) + (_tmp_149 << 4) >= 4096)) begin
            _tmp_148 <= 4096 - (_tmp_147 & 4095) >> 4;
            _tmp_149 <= _tmp_149 - (4096 - (_tmp_147 & 4095) >> 4);
          end else if(_tmp_149 <= 256) begin
            _tmp_148 <= _tmp_149;
            _tmp_149 <= 0;
          end else if((_tmp_147 & 4095) + 4096 >= 4096) begin
            _tmp_148 <= 4096 - (_tmp_147 & 4095) >> 4;
            _tmp_149 <= _tmp_149 - (4096 - (_tmp_147 & 4095) >> 4);
          end else begin
            _tmp_148 <= 256;
            _tmp_149 <= _tmp_149 - 256;
          end
          _tmp_fsm_3 <= _tmp_fsm_3_3;
        end
        _tmp_fsm_3_3: begin
          if(myaxi_arready || !myaxi_arvalid) begin
            _tmp_fsm_3 <= _tmp_fsm_3_4;
          end 
        end
        _tmp_fsm_3_4: begin
          __tmp_fsm_3_cond_4_0_1 <= 1;
          if(myaxi_rready && myaxi_rvalid) begin
            _tmp_150 <= myaxi_rdata;
            _tmp_151 <= 1;
          end 
          if(myaxi_rready && myaxi_rvalid && myaxi_rlast) begin
            _tmp_147 <= _tmp_147 + (_tmp_148 << 4);
          end 
          if(myaxi_rready && myaxi_rvalid && myaxi_rlast && (_tmp_149 > 0)) begin
            _tmp_fsm_3 <= _tmp_fsm_3_2;
          end 
          if(myaxi_rready && myaxi_rvalid && myaxi_rlast && (_tmp_149 == 0)) begin
            _tmp_fsm_3 <= _tmp_fsm_3_5;
          end 
        end
        _tmp_fsm_3_5: begin
          _tmp_165 <= 1;
          __tmp_fsm_3_cond_5_1_1 <= 1;
          _tmp_fsm_3 <= _tmp_fsm_3_6;
        end
        _tmp_fsm_3_6: begin
          _tmp_fsm_3 <= _tmp_fsm_3_init;
        end
      endcase
    end
  end


endmodule



module myram_0
(
  input CLK,
  input [10-1:0] myram_0_0_addr,
  output [32-1:0] myram_0_0_rdata,
  input [32-1:0] myram_0_0_wdata,
  input myram_0_0_wenable
);

  reg [10-1:0] myram_0_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(myram_0_0_wenable) begin
      mem[myram_0_0_addr] <= myram_0_0_wdata;
    end 
    myram_0_0_daddr <= myram_0_0_addr;
  end

  assign myram_0_0_rdata = mem[myram_0_0_daddr];

endmodule



module myram_1
(
  input CLK,
  input [10-1:0] myram_1_0_addr,
  output [32-1:0] myram_1_0_rdata,
  input [32-1:0] myram_1_0_wdata,
  input myram_1_0_wenable
);

  reg [10-1:0] myram_1_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(myram_1_0_wenable) begin
      mem[myram_1_0_addr] <= myram_1_0_wdata;
    end 
    myram_1_0_daddr <= myram_1_0_addr;
  end

  assign myram_1_0_rdata = mem[myram_1_0_daddr];

endmodule



module myram_2
(
  input CLK,
  input [10-1:0] myram_2_0_addr,
  output [32-1:0] myram_2_0_rdata,
  input [32-1:0] myram_2_0_wdata,
  input myram_2_0_wenable
);

  reg [10-1:0] myram_2_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(myram_2_0_wenable) begin
      mem[myram_2_0_addr] <= myram_2_0_wdata;
    end 
    myram_2_0_daddr <= myram_2_0_addr;
  end

  assign myram_2_0_rdata = mem[myram_2_0_daddr];

endmodule



module myram_3
(
  input CLK,
  input [10-1:0] myram_3_0_addr,
  output [32-1:0] myram_3_0_rdata,
  input [32-1:0] myram_3_0_wdata,
  input myram_3_0_wenable
);

  reg [10-1:0] myram_3_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(myram_3_0_wenable) begin
      mem[myram_3_0_addr] <= myram_3_0_wdata;
    end 
    myram_3_0_daddr <= myram_3_0_addr;
  end

  assign myram_3_0_rdata = mem[myram_3_0_daddr];

endmodule
"""


def test():
    veriloggen.reset()
    test_module = thread_multibank_ram_dma.mkTest()
    code = test_module.to_verilog()

    from pyverilog.vparser.parser import VerilogParser
    from pyverilog.ast_code_generator.codegen import ASTCodeGenerator
    parser = VerilogParser()
    expected_ast = parser.parse(expected_verilog)
    codegen = ASTCodeGenerator()
    expected_code = codegen.visit(expected_ast)

    assert(expected_code == code)
