from __future__ import absolute_import
from __future__ import print_function
import veriloggen
import thread_stream_multibank

expected_verilog = """
module test;

  reg CLK;
  reg RST;
  wire [32-1:0] myaxi_awaddr;
  wire [8-1:0] myaxi_awlen;
  wire myaxi_awvalid;
  reg myaxi_awready;
  wire [128-1:0] myaxi_wdata;
  wire [16-1:0] myaxi_wstrb;
  wire myaxi_wlast;
  wire myaxi_wvalid;
  reg myaxi_wready;
  wire [32-1:0] myaxi_araddr;
  wire [8-1:0] myaxi_arlen;
  wire myaxi_arvalid;
  reg myaxi_arready;
  reg [128-1:0] myaxi_rdata;
  reg myaxi_rlast;
  reg myaxi_rvalid;
  wire myaxi_rready;
  wire [32-1:0] memory_awaddr;
  wire [8-1:0] memory_awlen;
  wire memory_awvalid;
  reg memory_awready;
  wire [128-1:0] memory_wdata;
  wire [16-1:0] memory_wstrb;
  wire memory_wlast;
  wire memory_wvalid;
  reg memory_wready;
  wire [32-1:0] memory_araddr;
  wire [8-1:0] memory_arlen;
  wire memory_arvalid;
  reg memory_arready;
  reg [128-1:0] memory_rdata;
  reg memory_rlast;
  reg memory_rvalid;
  wire memory_rready;
  reg [8-1:0] _memory_mem [0:2**20-1];

  initial begin
    $readmemh("_memory_memimg_.out", _memory_mem);
  end

  reg [32-1:0] _memory_fsm;
  localparam _memory_fsm_init = 0;
  reg [33-1:0] _write_count;
  reg [32-1:0] _write_addr;
  reg [33-1:0] _read_count;
  reg [32-1:0] _read_addr;
  reg [33-1:0] _sleep_count;
  reg [32-1:0] _d1__memory_fsm;
  reg __memory_fsm_cond_100_0_1;
  reg __memory_fsm_cond_200_1_1;
  reg __memory_fsm_cond_211_2_1;
  assign memory_awaddr = myaxi_awaddr;
  assign memory_awlen = myaxi_awlen;
  assign memory_awvalid = myaxi_awvalid;
  wire _tmp_0;
  assign _tmp_0 = memory_awready;

  always @(*) begin
    myaxi_awready = _tmp_0;
  end

  assign memory_wdata = myaxi_wdata;
  assign memory_wstrb = myaxi_wstrb;
  assign memory_wlast = myaxi_wlast;
  assign memory_wvalid = myaxi_wvalid;
  wire _tmp_1;
  assign _tmp_1 = memory_wready;

  always @(*) begin
    myaxi_wready = _tmp_1;
  end

  assign memory_araddr = myaxi_araddr;
  assign memory_arlen = myaxi_arlen;
  assign memory_arvalid = myaxi_arvalid;
  wire _tmp_2;
  assign _tmp_2 = memory_arready;

  always @(*) begin
    myaxi_arready = _tmp_2;
  end


  always @(*) begin
    myaxi_rdata <= memory_rdata;
  end

  wire _tmp_3;
  assign _tmp_3 = memory_rlast;

  always @(*) begin
    myaxi_rlast = _tmp_3;
  end

  wire _tmp_4;
  assign _tmp_4 = memory_rvalid;

  always @(*) begin
    myaxi_rvalid = _tmp_4;
  end

  assign memory_rready = myaxi_rready;

  blinkled
  uut
  (
    .CLK(CLK),
    .RST(RST),
    .myaxi_awaddr(myaxi_awaddr),
    .myaxi_awlen(myaxi_awlen),
    .myaxi_awvalid(myaxi_awvalid),
    .myaxi_awready(myaxi_awready),
    .myaxi_wdata(myaxi_wdata),
    .myaxi_wstrb(myaxi_wstrb),
    .myaxi_wlast(myaxi_wlast),
    .myaxi_wvalid(myaxi_wvalid),
    .myaxi_wready(myaxi_wready),
    .myaxi_araddr(myaxi_araddr),
    .myaxi_arlen(myaxi_arlen),
    .myaxi_arvalid(myaxi_arvalid),
    .myaxi_arready(myaxi_arready),
    .myaxi_rdata(myaxi_rdata),
    .myaxi_rlast(myaxi_rlast),
    .myaxi_rvalid(myaxi_rvalid),
    .myaxi_rready(myaxi_rready)
  );


  initial begin
    $dumpfile("uut.vcd");
    $dumpvars(0, uut);
  end


  initial begin
    CLK = 0;
    forever begin
      #5 CLK = !CLK;
    end
  end


  initial begin
    RST = 0;
    memory_awready = 0;
    memory_wready = 0;
    memory_arready = 0;
    memory_rdata = 0;
    memory_rlast = 0;
    memory_rvalid = 0;
    _memory_fsm = _memory_fsm_init;
    _write_count = 0;
    _write_addr = 0;
    _read_count = 0;
    _read_addr = 0;
    _sleep_count = 0;
    _d1__memory_fsm = _memory_fsm_init;
    __memory_fsm_cond_100_0_1 = 0;
    __memory_fsm_cond_200_1_1 = 0;
    __memory_fsm_cond_211_2_1 = 0;
    #100;
    RST = 1;
    #100;
    RST = 0;
    #100000;
    $finish;
  end

  localparam _memory_fsm_200 = 200;
  localparam _memory_fsm_201 = 201;
  localparam _memory_fsm_202 = 202;
  localparam _memory_fsm_203 = 203;
  localparam _memory_fsm_204 = 204;
  localparam _memory_fsm_205 = 205;
  localparam _memory_fsm_206 = 206;
  localparam _memory_fsm_207 = 207;
  localparam _memory_fsm_208 = 208;
  localparam _memory_fsm_209 = 209;
  localparam _memory_fsm_210 = 210;
  localparam _memory_fsm_211 = 211;
  localparam _memory_fsm_100 = 100;
  localparam _memory_fsm_101 = 101;
  localparam _memory_fsm_102 = 102;
  localparam _memory_fsm_103 = 103;
  localparam _memory_fsm_104 = 104;
  localparam _memory_fsm_105 = 105;
  localparam _memory_fsm_106 = 106;
  localparam _memory_fsm_107 = 107;
  localparam _memory_fsm_108 = 108;
  localparam _memory_fsm_109 = 109;
  localparam _memory_fsm_110 = 110;
  localparam _memory_fsm_111 = 111;
  localparam _memory_fsm_112 = 112;

  always @(posedge CLK) begin
    if(RST) begin
      _memory_fsm <= _memory_fsm_init;
      _d1__memory_fsm <= _memory_fsm_init;
      memory_awready <= 0;
      _write_addr <= 0;
      _write_count <= 0;
      __memory_fsm_cond_100_0_1 <= 0;
      memory_wready <= 0;
      memory_arready <= 0;
      _read_addr <= 0;
      _read_count <= 0;
      __memory_fsm_cond_200_1_1 <= 0;
      memory_rdata[7:0] <= (0 >> 0) & { 8{ 1'd1 } };
      memory_rdata[15:8] <= (0 >> 8) & { 8{ 1'd1 } };
      memory_rdata[23:16] <= (0 >> 16) & { 8{ 1'd1 } };
      memory_rdata[31:24] <= (0 >> 24) & { 8{ 1'd1 } };
      memory_rdata[39:32] <= (0 >> 32) & { 8{ 1'd1 } };
      memory_rdata[47:40] <= (0 >> 40) & { 8{ 1'd1 } };
      memory_rdata[55:48] <= (0 >> 48) & { 8{ 1'd1 } };
      memory_rdata[63:56] <= (0 >> 56) & { 8{ 1'd1 } };
      memory_rdata[71:64] <= (0 >> 64) & { 8{ 1'd1 } };
      memory_rdata[79:72] <= (0 >> 72) & { 8{ 1'd1 } };
      memory_rdata[87:80] <= (0 >> 80) & { 8{ 1'd1 } };
      memory_rdata[95:88] <= (0 >> 88) & { 8{ 1'd1 } };
      memory_rdata[103:96] <= (0 >> 96) & { 8{ 1'd1 } };
      memory_rdata[111:104] <= (0 >> 104) & { 8{ 1'd1 } };
      memory_rdata[119:112] <= (0 >> 112) & { 8{ 1'd1 } };
      memory_rdata[127:120] <= (0 >> 120) & { 8{ 1'd1 } };
      memory_rvalid <= 0;
      memory_rlast <= 0;
      __memory_fsm_cond_211_2_1 <= 0;
      memory_rdata <= 0;
      _sleep_count <= 0;
    end else begin
      _sleep_count <= _sleep_count + 1;
      if(_sleep_count == 3) begin
        _sleep_count <= 0;
      end 
      _d1__memory_fsm <= _memory_fsm;
      case(_d1__memory_fsm)
        _memory_fsm_100: begin
          if(__memory_fsm_cond_100_0_1) begin
            memory_awready <= 0;
          end 
        end
        _memory_fsm_200: begin
          if(__memory_fsm_cond_200_1_1) begin
            memory_arready <= 0;
          end 
        end
        _memory_fsm_211: begin
          if(__memory_fsm_cond_211_2_1) begin
            memory_rvalid <= 0;
            memory_rlast <= 0;
          end 
        end
      endcase
      case(_memory_fsm)
        _memory_fsm_init: begin
          if(memory_awvalid) begin
            _memory_fsm <= _memory_fsm_100;
          end 
          if(memory_arvalid) begin
            _memory_fsm <= _memory_fsm_200;
          end 
        end
        _memory_fsm_100: begin
          if(memory_awvalid) begin
            memory_awready <= 1;
            _write_addr <= memory_awaddr;
            _write_count <= memory_awlen + 1;
          end 
          __memory_fsm_cond_100_0_1 <= 1;
          if(!memory_awvalid) begin
            _memory_fsm <= _memory_fsm_init;
          end 
          if(memory_awvalid) begin
            _memory_fsm <= _memory_fsm_101;
          end 
        end
        _memory_fsm_101: begin
          _memory_fsm <= _memory_fsm_102;
        end
        _memory_fsm_102: begin
          _memory_fsm <= _memory_fsm_103;
        end
        _memory_fsm_103: begin
          _memory_fsm <= _memory_fsm_104;
        end
        _memory_fsm_104: begin
          _memory_fsm <= _memory_fsm_105;
        end
        _memory_fsm_105: begin
          _memory_fsm <= _memory_fsm_106;
        end
        _memory_fsm_106: begin
          _memory_fsm <= _memory_fsm_107;
        end
        _memory_fsm_107: begin
          _memory_fsm <= _memory_fsm_108;
        end
        _memory_fsm_108: begin
          _memory_fsm <= _memory_fsm_109;
        end
        _memory_fsm_109: begin
          _memory_fsm <= _memory_fsm_110;
        end
        _memory_fsm_110: begin
          _memory_fsm <= _memory_fsm_111;
        end
        _memory_fsm_111: begin
          memory_wready <= 1;
          _memory_fsm <= _memory_fsm_112;
        end
        _memory_fsm_112: begin
          if(memory_wvalid && memory_wstrb[0]) begin
            _memory_mem[_write_addr + 0] <= memory_wdata[7:0];
          end 
          if(memory_wvalid && memory_wstrb[1]) begin
            _memory_mem[_write_addr + 1] <= memory_wdata[15:8];
          end 
          if(memory_wvalid && memory_wstrb[2]) begin
            _memory_mem[_write_addr + 2] <= memory_wdata[23:16];
          end 
          if(memory_wvalid && memory_wstrb[3]) begin
            _memory_mem[_write_addr + 3] <= memory_wdata[31:24];
          end 
          if(memory_wvalid && memory_wstrb[4]) begin
            _memory_mem[_write_addr + 4] <= memory_wdata[39:32];
          end 
          if(memory_wvalid && memory_wstrb[5]) begin
            _memory_mem[_write_addr + 5] <= memory_wdata[47:40];
          end 
          if(memory_wvalid && memory_wstrb[6]) begin
            _memory_mem[_write_addr + 6] <= memory_wdata[55:48];
          end 
          if(memory_wvalid && memory_wstrb[7]) begin
            _memory_mem[_write_addr + 7] <= memory_wdata[63:56];
          end 
          if(memory_wvalid && memory_wstrb[8]) begin
            _memory_mem[_write_addr + 8] <= memory_wdata[71:64];
          end 
          if(memory_wvalid && memory_wstrb[9]) begin
            _memory_mem[_write_addr + 9] <= memory_wdata[79:72];
          end 
          if(memory_wvalid && memory_wstrb[10]) begin
            _memory_mem[_write_addr + 10] <= memory_wdata[87:80];
          end 
          if(memory_wvalid && memory_wstrb[11]) begin
            _memory_mem[_write_addr + 11] <= memory_wdata[95:88];
          end 
          if(memory_wvalid && memory_wstrb[12]) begin
            _memory_mem[_write_addr + 12] <= memory_wdata[103:96];
          end 
          if(memory_wvalid && memory_wstrb[13]) begin
            _memory_mem[_write_addr + 13] <= memory_wdata[111:104];
          end 
          if(memory_wvalid && memory_wstrb[14]) begin
            _memory_mem[_write_addr + 14] <= memory_wdata[119:112];
          end 
          if(memory_wvalid && memory_wstrb[15]) begin
            _memory_mem[_write_addr + 15] <= memory_wdata[127:120];
          end 
          if(memory_wvalid && memory_wready) begin
            _write_addr <= _write_addr + 16;
            _write_count <= _write_count - 1;
          end 
          if(_sleep_count == 3) begin
            memory_wready <= 0;
          end else begin
            memory_wready <= 1;
          end
          if(memory_wvalid && memory_wready && (_write_count == 1)) begin
            memory_wready <= 0;
          end 
          if(memory_wvalid && memory_wready && (_write_count == 1)) begin
            _memory_fsm <= _memory_fsm_init;
          end 
        end
        _memory_fsm_200: begin
          if(memory_arvalid) begin
            memory_arready <= 1;
            _read_addr <= memory_araddr;
            _read_count <= memory_arlen + 1;
          end 
          __memory_fsm_cond_200_1_1 <= 1;
          if(!memory_arvalid) begin
            _memory_fsm <= _memory_fsm_init;
          end 
          if(memory_arvalid) begin
            _memory_fsm <= _memory_fsm_201;
          end 
        end
        _memory_fsm_201: begin
          _memory_fsm <= _memory_fsm_202;
        end
        _memory_fsm_202: begin
          _memory_fsm <= _memory_fsm_203;
        end
        _memory_fsm_203: begin
          _memory_fsm <= _memory_fsm_204;
        end
        _memory_fsm_204: begin
          _memory_fsm <= _memory_fsm_205;
        end
        _memory_fsm_205: begin
          _memory_fsm <= _memory_fsm_206;
        end
        _memory_fsm_206: begin
          _memory_fsm <= _memory_fsm_207;
        end
        _memory_fsm_207: begin
          _memory_fsm <= _memory_fsm_208;
        end
        _memory_fsm_208: begin
          _memory_fsm <= _memory_fsm_209;
        end
        _memory_fsm_209: begin
          _memory_fsm <= _memory_fsm_210;
        end
        _memory_fsm_210: begin
          _memory_fsm <= _memory_fsm_211;
        end
        _memory_fsm_211: begin
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[7:0] <= _memory_mem[_read_addr + 0];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[15:8] <= _memory_mem[_read_addr + 1];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[23:16] <= _memory_mem[_read_addr + 2];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[31:24] <= _memory_mem[_read_addr + 3];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[39:32] <= _memory_mem[_read_addr + 4];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[47:40] <= _memory_mem[_read_addr + 5];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[55:48] <= _memory_mem[_read_addr + 6];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[63:56] <= _memory_mem[_read_addr + 7];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[71:64] <= _memory_mem[_read_addr + 8];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[79:72] <= _memory_mem[_read_addr + 9];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[87:80] <= _memory_mem[_read_addr + 10];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[95:88] <= _memory_mem[_read_addr + 11];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[103:96] <= _memory_mem[_read_addr + 12];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[111:104] <= _memory_mem[_read_addr + 13];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[119:112] <= _memory_mem[_read_addr + 14];
          end 
          if(memory_rready | !memory_rvalid) begin
            memory_rdata[127:120] <= _memory_mem[_read_addr + 15];
          end 
          if((_sleep_count < 3) && (_read_count > 0) && memory_rready | !memory_rvalid) begin
            memory_rvalid <= 1;
            _read_addr <= _read_addr + 16;
            _read_count <= _read_count - 1;
          end 
          if((_sleep_count < 3) && (_read_count == 1) && memory_rready | !memory_rvalid) begin
            memory_rlast <= 1;
          end 
          __memory_fsm_cond_211_2_1 <= 1;
          if(memory_rvalid && !memory_rready) begin
            memory_rvalid <= memory_rvalid;
            memory_rdata <= memory_rdata;
            memory_rlast <= memory_rlast;
          end 
          if(memory_rvalid && memory_rready && (_read_count == 0)) begin
            _memory_fsm <= _memory_fsm_init;
          end 
        end
      endcase
    end
  end


endmodule



module blinkled
(
  input CLK,
  input RST,
  output reg [32-1:0] myaxi_awaddr,
  output reg [8-1:0] myaxi_awlen,
  output reg myaxi_awvalid,
  input myaxi_awready,
  output reg [128-1:0] myaxi_wdata,
  output reg [16-1:0] myaxi_wstrb,
  output reg myaxi_wlast,
  output reg myaxi_wvalid,
  input myaxi_wready,
  output reg [32-1:0] myaxi_araddr,
  output reg [8-1:0] myaxi_arlen,
  output reg myaxi_arvalid,
  input myaxi_arready,
  input [128-1:0] myaxi_rdata,
  input myaxi_rlast,
  input myaxi_rvalid,
  output myaxi_rready
);

  reg [10-1:0] ram_a_0_0_addr;
  wire [32-1:0] ram_a_0_0_rdata;
  reg [32-1:0] ram_a_0_0_wdata;
  reg ram_a_0_0_wenable;

  ram_a_0
  inst_ram_a_0
  (
    .CLK(CLK),
    .ram_a_0_0_addr(ram_a_0_0_addr),
    .ram_a_0_0_rdata(ram_a_0_0_rdata),
    .ram_a_0_0_wdata(ram_a_0_0_wdata),
    .ram_a_0_0_wenable(ram_a_0_0_wenable)
  );

  reg [10-1:0] ram_a_1_0_addr;
  wire [32-1:0] ram_a_1_0_rdata;
  reg [32-1:0] ram_a_1_0_wdata;
  reg ram_a_1_0_wenable;

  ram_a_1
  inst_ram_a_1
  (
    .CLK(CLK),
    .ram_a_1_0_addr(ram_a_1_0_addr),
    .ram_a_1_0_rdata(ram_a_1_0_rdata),
    .ram_a_1_0_wdata(ram_a_1_0_wdata),
    .ram_a_1_0_wenable(ram_a_1_0_wenable)
  );

  reg [10-1:0] ram_b_0_0_addr;
  wire [32-1:0] ram_b_0_0_rdata;
  reg [32-1:0] ram_b_0_0_wdata;
  reg ram_b_0_0_wenable;

  ram_b_0
  inst_ram_b_0
  (
    .CLK(CLK),
    .ram_b_0_0_addr(ram_b_0_0_addr),
    .ram_b_0_0_rdata(ram_b_0_0_rdata),
    .ram_b_0_0_wdata(ram_b_0_0_wdata),
    .ram_b_0_0_wenable(ram_b_0_0_wenable)
  );

  reg [10-1:0] ram_b_1_0_addr;
  wire [32-1:0] ram_b_1_0_rdata;
  reg [32-1:0] ram_b_1_0_wdata;
  reg ram_b_1_0_wenable;

  ram_b_1
  inst_ram_b_1
  (
    .CLK(CLK),
    .ram_b_1_0_addr(ram_b_1_0_addr),
    .ram_b_1_0_rdata(ram_b_1_0_rdata),
    .ram_b_1_0_wdata(ram_b_1_0_wdata),
    .ram_b_1_0_wenable(ram_b_1_0_wenable)
  );

  reg [10-1:0] ram_c_0_0_addr;
  wire [32-1:0] ram_c_0_0_rdata;
  reg [32-1:0] ram_c_0_0_wdata;
  reg ram_c_0_0_wenable;

  ram_c_0
  inst_ram_c_0
  (
    .CLK(CLK),
    .ram_c_0_0_addr(ram_c_0_0_addr),
    .ram_c_0_0_rdata(ram_c_0_0_rdata),
    .ram_c_0_0_wdata(ram_c_0_0_wdata),
    .ram_c_0_0_wenable(ram_c_0_0_wenable)
  );

  reg [10-1:0] ram_c_1_0_addr;
  wire [32-1:0] ram_c_1_0_rdata;
  reg [32-1:0] ram_c_1_0_wdata;
  reg ram_c_1_0_wenable;

  ram_c_1
  inst_ram_c_1
  (
    .CLK(CLK),
    .ram_c_1_0_addr(ram_c_1_0_addr),
    .ram_c_1_0_rdata(ram_c_1_0_rdata),
    .ram_c_1_0_wdata(ram_c_1_0_wdata),
    .ram_c_1_0_wenable(ram_c_1_0_wenable)
  );

  reg [32-1:0] th_comp;
  localparam th_comp_init = 0;
  reg signed [32-1:0] _th_comp_size_0;
  reg signed [32-1:0] _th_comp_dma_size_1;
  reg signed [32-1:0] _th_comp_comp_size_2;
  reg signed [32-1:0] _th_comp_dma_offset_3;
  reg signed [32-1:0] _th_comp_comp_offset_4;
  reg [10-1:0] _tmp_0;
  reg [32-1:0] _tmp_1;
  reg [32-1:0] _tmp_2;
  reg [32-1:0] _tmp_fsm_0;
  localparam _tmp_fsm_0_init = 0;
  reg [32-1:0] _tmp_3;
  reg [33-1:0] _tmp_4;
  reg [33-1:0] _tmp_5;
  reg [128-1:0] _tmp_6;
  wire [64-1:0] _tmp_7;
  assign _tmp_7 = _tmp_6;
  reg _tmp_8;
  reg [33-1:0] _tmp_9;
  reg _tmp_10;
  wire [33-1:0] _slice_data_11;
  wire _slice_valid_11;
  wire _slice_ready_11;
  assign _slice_ready_11 = (_tmp_9 > 0) && !_tmp_10;
  reg _ram_a_0_cond_0_1;
  reg [33-1:0] _tmp_12;
  reg _tmp_13;
  wire [33-1:0] _slice_data_14;
  wire _slice_valid_14;
  wire _slice_ready_14;
  assign _slice_ready_14 = (_tmp_12 > 0) && !_tmp_13;
  reg _ram_a_1_cond_0_1;
  reg _tmp_15;
  reg [9-1:0] _tmp_16;
  reg _myaxi_cond_0_1;
  reg [2-1:0] _tmp_17;
  reg [32-1:0] _d1__tmp_fsm_0;
  reg __tmp_fsm_0_cond_4_0_1;
  reg _tmp_18;
  reg __tmp_fsm_0_cond_5_1_1;
  reg [10-1:0] _tmp_19;
  reg [32-1:0] _tmp_20;
  reg [32-1:0] _tmp_21;
  reg [32-1:0] _tmp_fsm_1;
  localparam _tmp_fsm_1_init = 0;
  reg [32-1:0] _tmp_22;
  reg [33-1:0] _tmp_23;
  reg [33-1:0] _tmp_24;
  reg [128-1:0] _tmp_25;
  wire [64-1:0] _tmp_26;
  assign _tmp_26 = _tmp_25;
  reg _tmp_27;
  reg [33-1:0] _tmp_28;
  reg _tmp_29;
  wire [33-1:0] _slice_data_30;
  wire _slice_valid_30;
  wire _slice_ready_30;
  assign _slice_ready_30 = (_tmp_28 > 0) && !_tmp_29;
  reg _ram_b_0_cond_0_1;
  reg [33-1:0] _tmp_31;
  reg _tmp_32;
  wire [33-1:0] _slice_data_33;
  wire _slice_valid_33;
  wire _slice_ready_33;
  assign _slice_ready_33 = (_tmp_31 > 0) && !_tmp_32;
  reg _ram_b_1_cond_0_1;
  reg _tmp_34;
  reg [9-1:0] _tmp_35;
  reg _myaxi_cond_1_1;
  reg [2-1:0] _tmp_36;
  reg [32-1:0] _d1__tmp_fsm_1;
  reg __tmp_fsm_1_cond_4_0_1;
  reg _tmp_37;
  reg __tmp_fsm_1_cond_5_1_1;
  reg [32-1:0] mystream;
  localparam mystream_init = 0;
  reg _mystream_start_cond;
  reg _mystream_running_reg;
  wire _mystream_running;
  reg signed [32-1:0] _mystream_size_5;
  reg signed [32-1:0] _mystream_offset_6;
  reg _mystream_done_flag_7;
  reg [32-1:0] _mystream_fsm_8;
  localparam _mystream_fsm_8_init = 0;
  reg _tmp_38;
  reg _tmp_39;
  wire _tmp_40;
  wire _tmp_41;
  assign _tmp_41 = 1;
  localparam _tmp_42 = 1;
  wire [_tmp_42-1:0] _tmp_43;
  assign _tmp_43 = (_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39);
  reg [_tmp_42-1:0] __tmp_43_1;
  wire [32-1:0] _tmp_44;
  wire [32-1:0] _tmp_45;
  reg [32-1:0] __tmp_44_1;
  reg [32-1:0] __tmp_45_1;
  assign _tmp_44 = (__tmp_43_1)? ram_a_0_0_rdata : __tmp_44_1;
  assign _tmp_45 = (__tmp_43_1)? ram_a_1_0_rdata : __tmp_45_1;
  reg [11-1:0] _tmp_46;
  wire [11-1:0] _tmp_47;
  assign _tmp_47 = _tmp_46 + 1;
  wire [10-1:0] _tmp_48;
  wire [10-1:0] _tmp_49;
  assign _tmp_48 = _tmp_47 >> 1;
  assign _tmp_49 = _tmp_47 >> 1;
  wire [1-1:0] _tmp_50;
  assign _tmp_50 = _tmp_46[0:0];
  reg [1-1:0] _tmp_51;
  reg [1-1:0] __tmp_51_1;
  wire [32-1:0] _tmp_52;
  assign _tmp_52 = (__tmp_43_1)? (_tmp_51 == 0)? _tmp_44 : 
                   (_tmp_51 == 1)? _tmp_45 : 0 : 
                   (__tmp_51_1 == 0)? __tmp_44_1 : 
                   (__tmp_51_1 == 1)? __tmp_45_1 : 0;
  reg _tmp_53;
  reg _tmp_54;
  reg _tmp_55;
  reg _tmp_56;
  reg [33-1:0] _tmp_57;
  reg _mystream_done_flag_9;
  reg [32-1:0] _mystream_fsm_10;
  localparam _mystream_fsm_10_init = 0;
  reg _tmp_58;
  reg _tmp_59;
  wire _tmp_60;
  wire _tmp_61;
  assign _tmp_61 = 1;
  localparam _tmp_62 = 1;
  wire [_tmp_62-1:0] _tmp_63;
  assign _tmp_63 = (_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59);
  reg [_tmp_62-1:0] __tmp_63_1;
  wire [32-1:0] _tmp_64;
  wire [32-1:0] _tmp_65;
  reg [32-1:0] __tmp_64_1;
  reg [32-1:0] __tmp_65_1;
  assign _tmp_64 = (__tmp_63_1)? ram_b_0_0_rdata : __tmp_64_1;
  assign _tmp_65 = (__tmp_63_1)? ram_b_1_0_rdata : __tmp_65_1;
  reg [11-1:0] _tmp_66;
  wire [11-1:0] _tmp_67;
  assign _tmp_67 = _tmp_66 + 1;
  wire [10-1:0] _tmp_68;
  wire [10-1:0] _tmp_69;
  assign _tmp_68 = _tmp_67 >> 1;
  assign _tmp_69 = _tmp_67 >> 1;
  wire [1-1:0] _tmp_70;
  assign _tmp_70 = _tmp_66[0:0];
  reg [1-1:0] _tmp_71;
  reg [1-1:0] __tmp_71_1;
  wire [32-1:0] _tmp_72;
  assign _tmp_72 = (__tmp_63_1)? (_tmp_71 == 0)? _tmp_64 : 
                   (_tmp_71 == 1)? _tmp_65 : 0 : 
                   (__tmp_71_1 == 0)? __tmp_64_1 : 
                   (__tmp_71_1 == 1)? __tmp_65_1 : 0;
  reg _tmp_73;
  reg _tmp_74;
  reg _tmp_75;
  reg _tmp_76;
  reg [33-1:0] _tmp_77;
  reg _mystream_done_flag_11;
  reg [32-1:0] _mystream_fsm_12;
  localparam _mystream_fsm_12_init = 0;
  reg [33-1:0] _tmp_78;
  reg _tmp_79;
  wire signed [32-1:0] _plus_data_80;
  wire _plus_valid_80;
  wire _plus_ready_80;
  assign _plus_ready_80 = (_tmp_78 > 0) && !_tmp_79;
  reg [11-1:0] _tmp_81;
  wire [11-1:0] _tmp_82;
  assign _tmp_82 = _tmp_81 + 1;
  wire [10-1:0] _tmp_83;
  wire [10-1:0] _tmp_84;
  assign _tmp_83 = _tmp_82 >> 1;
  assign _tmp_84 = _tmp_82 >> 1;
  wire [1-1:0] _tmp_85;
  assign _tmp_85 = _tmp_82;
  reg _ram_c_cond_0_1;
  reg _ram_c_0_cond_0_1;
  reg _ram_c_1_cond_0_1;
  assign _mystream_running = _mystream_running_reg && !(_mystream_done_flag_7 && _mystream_done_flag_9 && _mystream_done_flag_11);
  reg [10-1:0] _tmp_86;
  reg [32-1:0] _tmp_87;
  reg [32-1:0] _tmp_88;
  reg [32-1:0] _tmp_fsm_2;
  localparam _tmp_fsm_2_init = 0;
  reg [32-1:0] _tmp_89;
  reg [33-1:0] _tmp_90;
  reg [33-1:0] _tmp_91;
  reg _tmp_92;
  reg _tmp_93;
  wire _tmp_94;
  wire _tmp_95;
  assign _tmp_95 = 1;
  localparam _tmp_96 = 1;
  wire [_tmp_96-1:0] _tmp_97;
  assign _tmp_97 = (_tmp_94 || !_tmp_92) && (_tmp_95 || !_tmp_93);
  reg [_tmp_96-1:0] __tmp_97_1;
  wire [32-1:0] _tmp_98;
  reg [32-1:0] __tmp_98_1;
  assign _tmp_98 = (__tmp_97_1)? ram_c_0_0_rdata : __tmp_98_1;
  reg _tmp_99;
  reg _tmp_100;
  reg _tmp_101;
  reg _tmp_102;
  reg [33-1:0] _tmp_103;
  reg _tmp_104;
  reg _tmp_105;
  wire _tmp_106;
  wire _tmp_107;
  assign _tmp_107 = 1;
  localparam _tmp_108 = 1;
  wire [_tmp_108-1:0] _tmp_109;
  assign _tmp_109 = (_tmp_106 || !_tmp_104) && (_tmp_107 || !_tmp_105);
  reg [_tmp_108-1:0] __tmp_109_1;
  wire [32-1:0] _tmp_110;
  reg [32-1:0] __tmp_110_1;
  assign _tmp_110 = (__tmp_109_1)? ram_c_1_0_rdata : __tmp_110_1;
  reg _tmp_111;
  reg _tmp_112;
  reg _tmp_113;
  reg _tmp_114;
  reg [33-1:0] _tmp_115;
  reg [9-1:0] _tmp_116;
  reg _myaxi_cond_2_1;
  reg [128-1:0] _tmp_117;
  reg _tmp_118;
  wire _tmp_119;
  reg [2-1:0] _tmp_120;
  wire [64-1:0] _cat_data_121;
  wire _cat_valid_121;
  wire _cat_ready_121;
  assign _cat_ready_121 = (_tmp_fsm_2 == 4) && (_tmp_119 || !_tmp_118);
  reg _tmp_122;
  wire [128-1:0] __variable_data_123;
  wire __variable_valid_123;
  wire __variable_ready_123;
  assign __variable_ready_123 = (_tmp_fsm_2 == 4) && ((_tmp_116 > 0) && (myaxi_wready || !myaxi_wvalid));
  reg _myaxi_cond_3_1;
  reg _tmp_124;
  reg [32-1:0] _d1__tmp_fsm_2;
  reg __tmp_fsm_2_cond_5_0_1;
  reg [10-1:0] _tmp_125;
  reg [32-1:0] _tmp_126;
  reg [32-1:0] _tmp_127;
  reg [32-1:0] _tmp_fsm_3;
  localparam _tmp_fsm_3_init = 0;
  reg [32-1:0] _tmp_128;
  reg [33-1:0] _tmp_129;
  reg [33-1:0] _tmp_130;
  reg [128-1:0] _tmp_131;
  wire [64-1:0] _tmp_132;
  assign _tmp_132 = _tmp_131;
  reg _tmp_133;
  reg [33-1:0] _tmp_134;
  reg _tmp_135;
  wire [33-1:0] _slice_data_136;
  wire _slice_valid_136;
  wire _slice_ready_136;
  assign _slice_ready_136 = (_tmp_134 > 0) && !_tmp_135;
  reg _ram_a_0_cond_1_1;
  reg [33-1:0] _tmp_137;
  reg _tmp_138;
  wire [33-1:0] _slice_data_139;
  wire _slice_valid_139;
  wire _slice_ready_139;
  assign _slice_ready_139 = (_tmp_137 > 0) && !_tmp_138;
  reg _ram_a_1_cond_1_1;
  reg _tmp_140;
  reg [9-1:0] _tmp_141;
  reg _myaxi_cond_4_1;
  reg [2-1:0] _tmp_142;
  reg [32-1:0] _d1__tmp_fsm_3;
  reg __tmp_fsm_3_cond_4_0_1;
  reg _tmp_143;
  reg __tmp_fsm_3_cond_5_1_1;
  reg [10-1:0] _tmp_144;
  reg [32-1:0] _tmp_145;
  reg [32-1:0] _tmp_146;
  reg [32-1:0] _tmp_fsm_4;
  localparam _tmp_fsm_4_init = 0;
  reg [32-1:0] _tmp_147;
  reg [33-1:0] _tmp_148;
  reg [33-1:0] _tmp_149;
  reg [128-1:0] _tmp_150;
  wire [64-1:0] _tmp_151;
  assign _tmp_151 = _tmp_150;
  reg _tmp_152;
  reg [33-1:0] _tmp_153;
  reg _tmp_154;
  wire [33-1:0] _slice_data_155;
  wire _slice_valid_155;
  wire _slice_ready_155;
  assign _slice_ready_155 = (_tmp_153 > 0) && !_tmp_154;
  reg _ram_b_0_cond_1_1;
  reg [33-1:0] _tmp_156;
  reg _tmp_157;
  wire [33-1:0] _slice_data_158;
  wire _slice_valid_158;
  wire _slice_ready_158;
  assign _slice_ready_158 = (_tmp_156 > 0) && !_tmp_157;
  reg _ram_b_1_cond_1_1;
  reg _tmp_159;
  reg [9-1:0] _tmp_160;
  reg _myaxi_cond_5_1;
  reg [2-1:0] _tmp_161;
  assign myaxi_rready = (_tmp_fsm_0 == 4) && (_tmp_17 == 0) || (_tmp_fsm_1 == 4) && (_tmp_36 == 0) || (_tmp_fsm_3 == 4) && (_tmp_142 == 0) || (_tmp_fsm_4 == 4) && (_tmp_161 == 0);
  reg [32-1:0] _d1__tmp_fsm_4;
  reg __tmp_fsm_4_cond_4_0_1;
  reg _tmp_162;
  reg __tmp_fsm_4_cond_5_1_1;
  reg [32-1:0] th_sequential;
  localparam th_sequential_init = 0;
  reg _th_sequential_called;
  reg signed [32-1:0] _th_sequential_size_13;
  reg signed [32-1:0] _th_sequential_offset_14;
  reg signed [32-1:0] _th_sequential_size_15;
  reg signed [32-1:0] _th_sequential_offset_16;
  reg signed [32-1:0] _th_sequential_sum_17;
  reg signed [32-1:0] _th_sequential_i_18;
  wire [1-1:0] _tmp_163;
  assign _tmp_163 = _th_sequential_i_18 + _th_sequential_offset_16;
  reg _tmp_164;
  reg _ram_a_0_cond_2_1;
  reg _ram_a_0_cond_3_1;
  reg _ram_a_0_cond_3_2;
  reg _tmp_165;
  reg _ram_a_1_cond_2_1;
  reg _ram_a_1_cond_3_1;
  reg _ram_a_1_cond_3_2;
  reg signed [32-1:0] _tmp_166;
  reg signed [32-1:0] _th_sequential_a_19;
  wire [1-1:0] _tmp_167;
  assign _tmp_167 = _th_sequential_i_18 + _th_sequential_offset_16;
  reg _tmp_168;
  reg _ram_b_0_cond_2_1;
  reg _ram_b_0_cond_3_1;
  reg _ram_b_0_cond_3_2;
  reg _tmp_169;
  reg _ram_b_1_cond_2_1;
  reg _ram_b_1_cond_3_1;
  reg _ram_b_1_cond_3_2;
  reg signed [32-1:0] _tmp_170;
  reg signed [32-1:0] _th_sequential_b_20;
  wire [1-1:0] _tmp_171;
  assign _tmp_171 = _th_sequential_i_18 + _th_sequential_offset_16;
  reg _ram_c_0_cond_1_1;
  reg _ram_c_1_cond_1_1;
  reg [10-1:0] _tmp_172;
  reg [32-1:0] _tmp_173;
  reg [32-1:0] _tmp_174;
  reg [32-1:0] _tmp_fsm_5;
  localparam _tmp_fsm_5_init = 0;
  reg [32-1:0] _tmp_175;
  reg [33-1:0] _tmp_176;
  reg [33-1:0] _tmp_177;
  reg _tmp_178;
  reg _tmp_179;
  wire _tmp_180;
  wire _tmp_181;
  assign _tmp_181 = 1;
  localparam _tmp_182 = 1;
  wire [_tmp_182-1:0] _tmp_183;
  assign _tmp_183 = (_tmp_180 || !_tmp_178) && (_tmp_181 || !_tmp_179);
  reg [_tmp_182-1:0] __tmp_183_1;
  wire [32-1:0] _tmp_184;
  reg [32-1:0] __tmp_184_1;
  assign _tmp_184 = (__tmp_183_1)? ram_c_0_0_rdata : __tmp_184_1;
  reg _tmp_185;
  reg _tmp_186;
  reg _tmp_187;
  reg _tmp_188;
  reg [33-1:0] _tmp_189;
  reg _tmp_190;
  reg _tmp_191;
  wire _tmp_192;
  wire _tmp_193;
  assign _tmp_193 = 1;
  localparam _tmp_194 = 1;
  wire [_tmp_194-1:0] _tmp_195;
  assign _tmp_195 = (_tmp_192 || !_tmp_190) && (_tmp_193 || !_tmp_191);
  reg [_tmp_194-1:0] __tmp_195_1;
  wire [32-1:0] _tmp_196;
  reg [32-1:0] __tmp_196_1;
  assign _tmp_196 = (__tmp_195_1)? ram_c_1_0_rdata : __tmp_196_1;
  reg _tmp_197;
  reg _tmp_198;
  reg _tmp_199;
  reg _tmp_200;
  reg [33-1:0] _tmp_201;
  reg [9-1:0] _tmp_202;
  reg _myaxi_cond_6_1;
  reg [128-1:0] _tmp_203;
  reg _tmp_204;
  wire _tmp_205;
  reg [2-1:0] _tmp_206;
  wire [64-1:0] _cat_data_207;
  wire _cat_valid_207;
  wire _cat_ready_207;
  assign _cat_ready_207 = (_tmp_fsm_5 == 4) && (_tmp_205 || !_tmp_204);
  reg _tmp_208;
  wire [128-1:0] __variable_data_209;
  wire __variable_valid_209;
  wire __variable_ready_209;
  assign __variable_ready_209 = (_tmp_fsm_5 == 4) && ((_tmp_202 > 0) && (myaxi_wready || !myaxi_wvalid));
  reg _myaxi_cond_7_1;
  reg _tmp_210;
  reg [32-1:0] _d1__tmp_fsm_5;
  reg __tmp_fsm_5_cond_5_0_1;
  reg signed [32-1:0] _th_comp_size_21;
  reg signed [32-1:0] _th_comp_offset_stream_22;
  reg signed [32-1:0] _th_comp_offset_seq_23;
  reg signed [32-1:0] _th_comp_all_ok_24;
  reg signed [32-1:0] _th_comp_i_25;
  wire [1-1:0] _tmp_211;
  assign _tmp_211 = _th_comp_i_25 + _th_comp_offset_stream_22;
  reg _tmp_212;
  reg _ram_c_0_cond_2_1;
  reg _ram_c_0_cond_3_1;
  reg _ram_c_0_cond_3_2;
  reg _tmp_213;
  reg _ram_c_1_cond_2_1;
  reg _ram_c_1_cond_3_1;
  reg _ram_c_1_cond_3_2;
  reg signed [32-1:0] _tmp_214;
  reg signed [32-1:0] _th_comp_st_26;
  wire [1-1:0] _tmp_215;
  assign _tmp_215 = _th_comp_i_25 + _th_comp_offset_seq_23;
  reg _tmp_216;
  reg _ram_c_0_cond_4_1;
  reg _ram_c_0_cond_5_1;
  reg _ram_c_0_cond_5_2;
  reg _tmp_217;
  reg _ram_c_1_cond_4_1;
  reg _ram_c_1_cond_5_1;
  reg _ram_c_1_cond_5_2;
  reg signed [32-1:0] _tmp_218;
  reg signed [32-1:0] _th_comp_sq_27;

  always @(posedge CLK) begin
    if(RST) begin
      myaxi_araddr <= 0;
      myaxi_arlen <= 0;
      myaxi_arvalid <= 0;
      _tmp_16 <= 0;
      _myaxi_cond_0_1 <= 0;
      _tmp_35 <= 0;
      _myaxi_cond_1_1 <= 0;
      myaxi_awaddr <= 0;
      myaxi_awlen <= 0;
      myaxi_awvalid <= 0;
      _tmp_116 <= 0;
      _myaxi_cond_2_1 <= 0;
      myaxi_wdata <= 0;
      myaxi_wvalid <= 0;
      myaxi_wlast <= 0;
      myaxi_wstrb <= 0;
      _tmp_122 <= 0;
      _myaxi_cond_3_1 <= 0;
      _tmp_141 <= 0;
      _myaxi_cond_4_1 <= 0;
      _tmp_160 <= 0;
      _myaxi_cond_5_1 <= 0;
      _tmp_202 <= 0;
      _myaxi_cond_6_1 <= 0;
      _tmp_208 <= 0;
      _myaxi_cond_7_1 <= 0;
    end else begin
      if(_myaxi_cond_0_1) begin
        myaxi_arvalid <= 0;
      end 
      if(_myaxi_cond_1_1) begin
        myaxi_arvalid <= 0;
      end 
      if(_myaxi_cond_2_1) begin
        myaxi_awvalid <= 0;
      end 
      if(_myaxi_cond_3_1) begin
        myaxi_wvalid <= 0;
        myaxi_wlast <= 0;
        _tmp_122 <= 0;
      end 
      if(_myaxi_cond_4_1) begin
        myaxi_arvalid <= 0;
      end 
      if(_myaxi_cond_5_1) begin
        myaxi_arvalid <= 0;
      end 
      if(_myaxi_cond_6_1) begin
        myaxi_awvalid <= 0;
      end 
      if(_myaxi_cond_7_1) begin
        myaxi_wvalid <= 0;
        myaxi_wlast <= 0;
        _tmp_208 <= 0;
      end 
      if((_tmp_fsm_0 == 3) && ((myaxi_arready || !myaxi_arvalid) && (_tmp_16 == 0))) begin
        myaxi_araddr <= _tmp_3;
        myaxi_arlen <= _tmp_4 - 1;
        myaxi_arvalid <= 1;
        _tmp_16 <= _tmp_4;
      end 
      _myaxi_cond_0_1 <= 1;
      if(myaxi_arvalid && !myaxi_arready) begin
        myaxi_arvalid <= myaxi_arvalid;
      end 
      if(myaxi_rready && myaxi_rvalid && (_tmp_16 > 0)) begin
        _tmp_16 <= _tmp_16 - 1;
      end 
      if((_tmp_fsm_1 == 3) && ((myaxi_arready || !myaxi_arvalid) && (_tmp_35 == 0))) begin
        myaxi_araddr <= _tmp_22;
        myaxi_arlen <= _tmp_23 - 1;
        myaxi_arvalid <= 1;
        _tmp_35 <= _tmp_23;
      end 
      _myaxi_cond_1_1 <= 1;
      if(myaxi_arvalid && !myaxi_arready) begin
        myaxi_arvalid <= myaxi_arvalid;
      end 
      if(myaxi_rready && myaxi_rvalid && (_tmp_35 > 0)) begin
        _tmp_35 <= _tmp_35 - 1;
      end 
      if((_tmp_fsm_2 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_116 == 0))) begin
        myaxi_awaddr <= _tmp_89;
        myaxi_awlen <= _tmp_90 - 1;
        myaxi_awvalid <= 1;
        _tmp_116 <= _tmp_90;
      end 
      if((_tmp_fsm_2 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_116 == 0)) && (_tmp_90 == 0)) begin
        myaxi_awvalid <= 0;
      end 
      _myaxi_cond_2_1 <= 1;
      if(myaxi_awvalid && !myaxi_awready) begin
        myaxi_awvalid <= myaxi_awvalid;
      end 
      if(__variable_valid_123 && ((_tmp_fsm_2 == 4) && ((_tmp_116 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_116 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_116 > 0))) begin
        myaxi_wdata <= __variable_data_123;
        myaxi_wvalid <= 1;
        myaxi_wlast <= 0;
        myaxi_wstrb <= { 16{ 1'd1 } };
        _tmp_116 <= _tmp_116 - 1;
      end 
      if(__variable_valid_123 && ((_tmp_fsm_2 == 4) && ((_tmp_116 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_116 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_116 > 0)) && (_tmp_116 == 1)) begin
        myaxi_wlast <= 1;
        _tmp_122 <= 1;
      end 
      _myaxi_cond_3_1 <= 1;
      if(myaxi_wvalid && !myaxi_wready) begin
        myaxi_wvalid <= myaxi_wvalid;
        myaxi_wlast <= myaxi_wlast;
        _tmp_122 <= _tmp_122;
      end 
      if((_tmp_fsm_3 == 3) && ((myaxi_arready || !myaxi_arvalid) && (_tmp_141 == 0))) begin
        myaxi_araddr <= _tmp_128;
        myaxi_arlen <= _tmp_129 - 1;
        myaxi_arvalid <= 1;
        _tmp_141 <= _tmp_129;
      end 
      _myaxi_cond_4_1 <= 1;
      if(myaxi_arvalid && !myaxi_arready) begin
        myaxi_arvalid <= myaxi_arvalid;
      end 
      if(myaxi_rready && myaxi_rvalid && (_tmp_141 > 0)) begin
        _tmp_141 <= _tmp_141 - 1;
      end 
      if((_tmp_fsm_4 == 3) && ((myaxi_arready || !myaxi_arvalid) && (_tmp_160 == 0))) begin
        myaxi_araddr <= _tmp_147;
        myaxi_arlen <= _tmp_148 - 1;
        myaxi_arvalid <= 1;
        _tmp_160 <= _tmp_148;
      end 
      _myaxi_cond_5_1 <= 1;
      if(myaxi_arvalid && !myaxi_arready) begin
        myaxi_arvalid <= myaxi_arvalid;
      end 
      if(myaxi_rready && myaxi_rvalid && (_tmp_160 > 0)) begin
        _tmp_160 <= _tmp_160 - 1;
      end 
      if((_tmp_fsm_5 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_202 == 0))) begin
        myaxi_awaddr <= _tmp_175;
        myaxi_awlen <= _tmp_176 - 1;
        myaxi_awvalid <= 1;
        _tmp_202 <= _tmp_176;
      end 
      if((_tmp_fsm_5 == 3) && ((myaxi_awready || !myaxi_awvalid) && (_tmp_202 == 0)) && (_tmp_176 == 0)) begin
        myaxi_awvalid <= 0;
      end 
      _myaxi_cond_6_1 <= 1;
      if(myaxi_awvalid && !myaxi_awready) begin
        myaxi_awvalid <= myaxi_awvalid;
      end 
      if(__variable_valid_209 && ((_tmp_fsm_5 == 4) && ((_tmp_202 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_202 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_202 > 0))) begin
        myaxi_wdata <= __variable_data_209;
        myaxi_wvalid <= 1;
        myaxi_wlast <= 0;
        myaxi_wstrb <= { 16{ 1'd1 } };
        _tmp_202 <= _tmp_202 - 1;
      end 
      if(__variable_valid_209 && ((_tmp_fsm_5 == 4) && ((_tmp_202 > 0) && (myaxi_wready || !myaxi_wvalid))) && ((_tmp_202 > 0) && (myaxi_wready || !myaxi_wvalid) && (_tmp_202 > 0)) && (_tmp_202 == 1)) begin
        myaxi_wlast <= 1;
        _tmp_208 <= 1;
      end 
      _myaxi_cond_7_1 <= 1;
      if(myaxi_wvalid && !myaxi_wready) begin
        myaxi_wvalid <= myaxi_wvalid;
        myaxi_wlast <= myaxi_wlast;
        _tmp_208 <= _tmp_208;
      end 
    end
  end

  reg [33-1:0] _slice_data_219;
  reg _slice_valid_219;
  wire _slice_ready_219;
  reg [33-1:0] _slice_data_220;
  reg _slice_valid_220;
  wire _slice_ready_220;
  reg [33-1:0] _slice_data_221;
  reg _slice_valid_221;
  wire _slice_ready_221;
  reg [33-1:0] _slice_data_222;
  reg _slice_valid_222;
  wire _slice_ready_222;
  reg [33-1:0] _slice_data_223;
  reg _slice_valid_223;
  wire _slice_ready_223;
  reg [33-1:0] _slice_data_224;
  reg _slice_valid_224;
  wire _slice_ready_224;
  reg [33-1:0] _slice_data_225;
  reg _slice_valid_225;
  wire _slice_ready_225;
  reg [33-1:0] _slice_data_226;
  reg _slice_valid_226;
  wire _slice_ready_226;
  reg [128-1:0] __delay_data_227;
  reg __delay_valid_227;
  wire __delay_ready_227;
  assign _tmp_119 = (__delay_ready_227 || !__delay_valid_227) && _tmp_118;
  reg [128-1:0] __delay_data_228;
  reg __delay_valid_228;
  wire __delay_ready_228;
  assign _tmp_205 = (__delay_ready_228 || !__delay_valid_228) && _tmp_204;
  assign _slice_data_11 = _slice_data_219;
  assign _slice_valid_11 = _slice_valid_219;
  assign _slice_ready_219 = _slice_ready_11;
  assign _slice_data_14 = _slice_data_220;
  assign _slice_valid_14 = _slice_valid_220;
  assign _slice_ready_220 = _slice_ready_14;
  assign _slice_data_30 = _slice_data_221;
  assign _slice_valid_30 = _slice_valid_221;
  assign _slice_ready_221 = _slice_ready_30;
  assign _slice_data_33 = _slice_data_222;
  assign _slice_valid_33 = _slice_valid_222;
  assign _slice_ready_222 = _slice_ready_33;
  assign _slice_data_136 = _slice_data_223;
  assign _slice_valid_136 = _slice_valid_223;
  assign _slice_ready_223 = _slice_ready_136;
  assign _slice_data_139 = _slice_data_224;
  assign _slice_valid_139 = _slice_valid_224;
  assign _slice_ready_224 = _slice_ready_139;
  assign _slice_data_155 = _slice_data_225;
  assign _slice_valid_155 = _slice_valid_225;
  assign _slice_ready_225 = _slice_ready_155;
  assign _slice_data_158 = _slice_data_226;
  assign _slice_valid_158 = _slice_valid_226;
  assign _slice_ready_226 = _slice_ready_158;
  assign __variable_data_123 = __delay_data_227;
  assign __variable_valid_123 = __delay_valid_227;
  assign __delay_ready_227 = __variable_ready_123;
  assign __variable_data_209 = __delay_data_228;
  assign __variable_valid_209 = __delay_valid_228;
  assign __delay_ready_228 = __variable_ready_209;

  always @(posedge CLK) begin
    if(RST) begin
      _slice_data_219 <= 0;
      _slice_valid_219 <= 0;
      _slice_data_220 <= 0;
      _slice_valid_220 <= 0;
      _slice_data_221 <= 0;
      _slice_valid_221 <= 0;
      _slice_data_222 <= 0;
      _slice_valid_222 <= 0;
      _slice_data_223 <= 0;
      _slice_valid_223 <= 0;
      _slice_data_224 <= 0;
      _slice_valid_224 <= 0;
      _slice_data_225 <= 0;
      _slice_valid_225 <= 0;
      _slice_data_226 <= 0;
      _slice_valid_226 <= 0;
      __delay_data_227 <= 0;
      __delay_valid_227 <= 0;
      __delay_data_228 <= 0;
      __delay_valid_228 <= 0;
    end else begin
      if((_slice_ready_219 || !_slice_valid_219) && 1 && _tmp_8) begin
        _slice_data_219 <= _tmp_7[7'sd32:1'sd0];
      end 
      if(_slice_valid_219 && _slice_ready_219) begin
        _slice_valid_219 <= 0;
      end 
      if((_slice_ready_219 || !_slice_valid_219) && 1) begin
        _slice_valid_219 <= _tmp_8;
      end 
      if((_slice_ready_220 || !_slice_valid_220) && 1 && _tmp_8) begin
        _slice_data_220 <= _tmp_7[8'sd64:7'sd32];
      end 
      if(_slice_valid_220 && _slice_ready_220) begin
        _slice_valid_220 <= 0;
      end 
      if((_slice_ready_220 || !_slice_valid_220) && 1) begin
        _slice_valid_220 <= _tmp_8;
      end 
      if((_slice_ready_221 || !_slice_valid_221) && 1 && _tmp_27) begin
        _slice_data_221 <= _tmp_26[7'sd32:1'sd0];
      end 
      if(_slice_valid_221 && _slice_ready_221) begin
        _slice_valid_221 <= 0;
      end 
      if((_slice_ready_221 || !_slice_valid_221) && 1) begin
        _slice_valid_221 <= _tmp_27;
      end 
      if((_slice_ready_222 || !_slice_valid_222) && 1 && _tmp_27) begin
        _slice_data_222 <= _tmp_26[8'sd64:7'sd32];
      end 
      if(_slice_valid_222 && _slice_ready_222) begin
        _slice_valid_222 <= 0;
      end 
      if((_slice_ready_222 || !_slice_valid_222) && 1) begin
        _slice_valid_222 <= _tmp_27;
      end 
      if((_slice_ready_223 || !_slice_valid_223) && 1 && _tmp_133) begin
        _slice_data_223 <= _tmp_132[7'sd32:1'sd0];
      end 
      if(_slice_valid_223 && _slice_ready_223) begin
        _slice_valid_223 <= 0;
      end 
      if((_slice_ready_223 || !_slice_valid_223) && 1) begin
        _slice_valid_223 <= _tmp_133;
      end 
      if((_slice_ready_224 || !_slice_valid_224) && 1 && _tmp_133) begin
        _slice_data_224 <= _tmp_132[8'sd64:7'sd32];
      end 
      if(_slice_valid_224 && _slice_ready_224) begin
        _slice_valid_224 <= 0;
      end 
      if((_slice_ready_224 || !_slice_valid_224) && 1) begin
        _slice_valid_224 <= _tmp_133;
      end 
      if((_slice_ready_225 || !_slice_valid_225) && 1 && _tmp_152) begin
        _slice_data_225 <= _tmp_151[7'sd32:1'sd0];
      end 
      if(_slice_valid_225 && _slice_ready_225) begin
        _slice_valid_225 <= 0;
      end 
      if((_slice_ready_225 || !_slice_valid_225) && 1) begin
        _slice_valid_225 <= _tmp_152;
      end 
      if((_slice_ready_226 || !_slice_valid_226) && 1 && _tmp_152) begin
        _slice_data_226 <= _tmp_151[8'sd64:7'sd32];
      end 
      if(_slice_valid_226 && _slice_ready_226) begin
        _slice_valid_226 <= 0;
      end 
      if((_slice_ready_226 || !_slice_valid_226) && 1) begin
        _slice_valid_226 <= _tmp_152;
      end 
      if((__delay_ready_227 || !__delay_valid_227) && _tmp_119 && _tmp_118) begin
        __delay_data_227 <= _tmp_117;
      end 
      if(__delay_valid_227 && __delay_ready_227) begin
        __delay_valid_227 <= 0;
      end 
      if((__delay_ready_227 || !__delay_valid_227) && _tmp_119) begin
        __delay_valid_227 <= _tmp_118;
      end 
      if((__delay_ready_228 || !__delay_valid_228) && _tmp_205 && _tmp_204) begin
        __delay_data_228 <= _tmp_203;
      end 
      if(__delay_valid_228 && __delay_ready_228) begin
        __delay_valid_228 <= 0;
      end 
      if((__delay_ready_228 || !__delay_valid_228) && _tmp_205) begin
        __delay_valid_228 <= _tmp_204;
      end 
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      ram_a_0_0_addr <= 0;
      _tmp_9 <= 0;
      ram_a_0_0_wdata <= 0;
      ram_a_0_0_wenable <= 0;
      _tmp_10 <= 0;
      _ram_a_0_cond_0_1 <= 0;
      _tmp_134 <= 0;
      _tmp_135 <= 0;
      _ram_a_0_cond_1_1 <= 0;
      _ram_a_0_cond_2_1 <= 0;
      _tmp_164 <= 0;
      _ram_a_0_cond_3_1 <= 0;
      _ram_a_0_cond_3_2 <= 0;
    end else begin
      if(_ram_a_0_cond_3_2) begin
        _tmp_164 <= 0;
      end 
      if(_ram_a_0_cond_0_1) begin
        ram_a_0_0_wenable <= 0;
        _tmp_10 <= 0;
      end 
      if(_ram_a_0_cond_1_1) begin
        ram_a_0_0_wenable <= 0;
        _tmp_135 <= 0;
      end 
      if(_ram_a_0_cond_2_1) begin
        _tmp_164 <= 1;
      end 
      _ram_a_0_cond_3_2 <= _ram_a_0_cond_3_1;
      if((_tmp_fsm_0 == 1) && (_tmp_9 == 0)) begin
        ram_a_0_0_addr <= _tmp_0 - 1;
        _tmp_9 <= _tmp_2;
      end 
      if(_slice_valid_11 && ((_tmp_9 > 0) && !_tmp_10) && (_tmp_9 > 0)) begin
        ram_a_0_0_addr <= ram_a_0_0_addr + 1;
        ram_a_0_0_wdata <= _slice_data_11;
        ram_a_0_0_wenable <= 1;
        _tmp_9 <= _tmp_9 - 1;
      end 
      if(_slice_valid_11 && ((_tmp_9 > 0) && !_tmp_10) && (_tmp_9 == 1)) begin
        _tmp_10 <= 1;
      end 
      _ram_a_0_cond_0_1 <= 1;
      if((_mystream_fsm_8 == 1) && (_tmp_57 == 0) && !_tmp_55 && !_tmp_56) begin
        ram_a_0_0_addr <= _mystream_offset_6 >> 1;
      end 
      if((_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39) && (_tmp_57 > 0)) begin
        ram_a_0_0_addr <= _tmp_48;
      end 
      if((_tmp_fsm_3 == 1) && (_tmp_134 == 0)) begin
        ram_a_0_0_addr <= _tmp_125 - 1;
        _tmp_134 <= _tmp_127;
      end 
      if(_slice_valid_136 && ((_tmp_134 > 0) && !_tmp_135) && (_tmp_134 > 0)) begin
        ram_a_0_0_addr <= ram_a_0_0_addr + 1;
        ram_a_0_0_wdata <= _slice_data_136;
        ram_a_0_0_wenable <= 1;
        _tmp_134 <= _tmp_134 - 1;
      end 
      if(_slice_valid_136 && ((_tmp_134 > 0) && !_tmp_135) && (_tmp_134 == 1)) begin
        _tmp_135 <= 1;
      end 
      _ram_a_0_cond_1_1 <= 1;
      if(th_sequential == 5) begin
        ram_a_0_0_addr <= _th_sequential_i_18 + _th_sequential_offset_16 >> 1;
      end 
      _ram_a_0_cond_2_1 <= th_sequential == 5;
      _ram_a_0_cond_3_1 <= th_sequential == 5;
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      ram_a_1_0_addr <= 0;
      _tmp_12 <= 0;
      ram_a_1_0_wdata <= 0;
      ram_a_1_0_wenable <= 0;
      _tmp_13 <= 0;
      _ram_a_1_cond_0_1 <= 0;
      _tmp_137 <= 0;
      _tmp_138 <= 0;
      _ram_a_1_cond_1_1 <= 0;
      _ram_a_1_cond_2_1 <= 0;
      _tmp_165 <= 0;
      _ram_a_1_cond_3_1 <= 0;
      _ram_a_1_cond_3_2 <= 0;
    end else begin
      if(_ram_a_1_cond_3_2) begin
        _tmp_165 <= 0;
      end 
      if(_ram_a_1_cond_0_1) begin
        ram_a_1_0_wenable <= 0;
        _tmp_13 <= 0;
      end 
      if(_ram_a_1_cond_1_1) begin
        ram_a_1_0_wenable <= 0;
        _tmp_138 <= 0;
      end 
      if(_ram_a_1_cond_2_1) begin
        _tmp_165 <= 1;
      end 
      _ram_a_1_cond_3_2 <= _ram_a_1_cond_3_1;
      if((_tmp_fsm_0 == 1) && (_tmp_12 == 0)) begin
        ram_a_1_0_addr <= _tmp_0 - 1;
        _tmp_12 <= _tmp_2;
      end 
      if(_slice_valid_14 && ((_tmp_12 > 0) && !_tmp_13) && (_tmp_12 > 0)) begin
        ram_a_1_0_addr <= ram_a_1_0_addr + 1;
        ram_a_1_0_wdata <= _slice_data_14;
        ram_a_1_0_wenable <= 1;
        _tmp_12 <= _tmp_12 - 1;
      end 
      if(_slice_valid_14 && ((_tmp_12 > 0) && !_tmp_13) && (_tmp_12 == 1)) begin
        _tmp_13 <= 1;
      end 
      _ram_a_1_cond_0_1 <= 1;
      if((_mystream_fsm_8 == 1) && (_tmp_57 == 0) && !_tmp_55 && !_tmp_56) begin
        ram_a_1_0_addr <= _mystream_offset_6 >> 1;
      end 
      if((_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39) && (_tmp_57 > 0)) begin
        ram_a_1_0_addr <= _tmp_49;
      end 
      if((_tmp_fsm_3 == 1) && (_tmp_137 == 0)) begin
        ram_a_1_0_addr <= _tmp_125 - 1;
        _tmp_137 <= _tmp_127;
      end 
      if(_slice_valid_139 && ((_tmp_137 > 0) && !_tmp_138) && (_tmp_137 > 0)) begin
        ram_a_1_0_addr <= ram_a_1_0_addr + 1;
        ram_a_1_0_wdata <= _slice_data_139;
        ram_a_1_0_wenable <= 1;
        _tmp_137 <= _tmp_137 - 1;
      end 
      if(_slice_valid_139 && ((_tmp_137 > 0) && !_tmp_138) && (_tmp_137 == 1)) begin
        _tmp_138 <= 1;
      end 
      _ram_a_1_cond_1_1 <= 1;
      if(th_sequential == 5) begin
        ram_a_1_0_addr <= _th_sequential_i_18 + _th_sequential_offset_16 >> 1;
      end 
      _ram_a_1_cond_2_1 <= th_sequential == 5;
      _ram_a_1_cond_3_1 <= th_sequential == 5;
    end
  end

  reg signed [32-1:0] _plus_data_229;
  reg _plus_valid_229;
  wire _plus_ready_229;
  assign _tmp_40 = 1 && ((_plus_ready_229 || !_plus_valid_229) && (_tmp_38 && _tmp_58));
  assign _tmp_60 = 1 && ((_plus_ready_229 || !_plus_valid_229) && (_tmp_38 && _tmp_58));
  assign _plus_data_80 = _plus_data_229;
  assign _plus_valid_80 = _plus_valid_229;
  assign _plus_ready_229 = _plus_ready_80;

  always @(posedge CLK) begin
    if(RST) begin
      _plus_data_229 <= 0;
      _plus_valid_229 <= 0;
    end else begin
      if((_plus_ready_229 || !_plus_valid_229) && (_tmp_40 && _tmp_60) && (_tmp_38 && _tmp_58)) begin
        _plus_data_229 <= _tmp_52 + _tmp_72;
      end 
      if(_plus_valid_229 && _plus_ready_229) begin
        _plus_valid_229 <= 0;
      end 
      if((_plus_ready_229 || !_plus_valid_229) && (_tmp_40 && _tmp_60)) begin
        _plus_valid_229 <= _tmp_38 && _tmp_58;
      end 
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      ram_b_0_0_addr <= 0;
      _tmp_28 <= 0;
      ram_b_0_0_wdata <= 0;
      ram_b_0_0_wenable <= 0;
      _tmp_29 <= 0;
      _ram_b_0_cond_0_1 <= 0;
      _tmp_153 <= 0;
      _tmp_154 <= 0;
      _ram_b_0_cond_1_1 <= 0;
      _ram_b_0_cond_2_1 <= 0;
      _tmp_168 <= 0;
      _ram_b_0_cond_3_1 <= 0;
      _ram_b_0_cond_3_2 <= 0;
    end else begin
      if(_ram_b_0_cond_3_2) begin
        _tmp_168 <= 0;
      end 
      if(_ram_b_0_cond_0_1) begin
        ram_b_0_0_wenable <= 0;
        _tmp_29 <= 0;
      end 
      if(_ram_b_0_cond_1_1) begin
        ram_b_0_0_wenable <= 0;
        _tmp_154 <= 0;
      end 
      if(_ram_b_0_cond_2_1) begin
        _tmp_168 <= 1;
      end 
      _ram_b_0_cond_3_2 <= _ram_b_0_cond_3_1;
      if((_tmp_fsm_1 == 1) && (_tmp_28 == 0)) begin
        ram_b_0_0_addr <= _tmp_19 - 1;
        _tmp_28 <= _tmp_21;
      end 
      if(_slice_valid_30 && ((_tmp_28 > 0) && !_tmp_29) && (_tmp_28 > 0)) begin
        ram_b_0_0_addr <= ram_b_0_0_addr + 1;
        ram_b_0_0_wdata <= _slice_data_30;
        ram_b_0_0_wenable <= 1;
        _tmp_28 <= _tmp_28 - 1;
      end 
      if(_slice_valid_30 && ((_tmp_28 > 0) && !_tmp_29) && (_tmp_28 == 1)) begin
        _tmp_29 <= 1;
      end 
      _ram_b_0_cond_0_1 <= 1;
      if((_mystream_fsm_10 == 1) && (_tmp_77 == 0) && !_tmp_75 && !_tmp_76) begin
        ram_b_0_0_addr <= _mystream_offset_6 >> 1;
      end 
      if((_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59) && (_tmp_77 > 0)) begin
        ram_b_0_0_addr <= _tmp_68;
      end 
      if((_tmp_fsm_4 == 1) && (_tmp_153 == 0)) begin
        ram_b_0_0_addr <= _tmp_144 - 1;
        _tmp_153 <= _tmp_146;
      end 
      if(_slice_valid_155 && ((_tmp_153 > 0) && !_tmp_154) && (_tmp_153 > 0)) begin
        ram_b_0_0_addr <= ram_b_0_0_addr + 1;
        ram_b_0_0_wdata <= _slice_data_155;
        ram_b_0_0_wenable <= 1;
        _tmp_153 <= _tmp_153 - 1;
      end 
      if(_slice_valid_155 && ((_tmp_153 > 0) && !_tmp_154) && (_tmp_153 == 1)) begin
        _tmp_154 <= 1;
      end 
      _ram_b_0_cond_1_1 <= 1;
      if(th_sequential == 7) begin
        ram_b_0_0_addr <= _th_sequential_i_18 + _th_sequential_offset_16 >> 1;
      end 
      _ram_b_0_cond_2_1 <= th_sequential == 7;
      _ram_b_0_cond_3_1 <= th_sequential == 7;
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      ram_b_1_0_addr <= 0;
      _tmp_31 <= 0;
      ram_b_1_0_wdata <= 0;
      ram_b_1_0_wenable <= 0;
      _tmp_32 <= 0;
      _ram_b_1_cond_0_1 <= 0;
      _tmp_156 <= 0;
      _tmp_157 <= 0;
      _ram_b_1_cond_1_1 <= 0;
      _ram_b_1_cond_2_1 <= 0;
      _tmp_169 <= 0;
      _ram_b_1_cond_3_1 <= 0;
      _ram_b_1_cond_3_2 <= 0;
    end else begin
      if(_ram_b_1_cond_3_2) begin
        _tmp_169 <= 0;
      end 
      if(_ram_b_1_cond_0_1) begin
        ram_b_1_0_wenable <= 0;
        _tmp_32 <= 0;
      end 
      if(_ram_b_1_cond_1_1) begin
        ram_b_1_0_wenable <= 0;
        _tmp_157 <= 0;
      end 
      if(_ram_b_1_cond_2_1) begin
        _tmp_169 <= 1;
      end 
      _ram_b_1_cond_3_2 <= _ram_b_1_cond_3_1;
      if((_tmp_fsm_1 == 1) && (_tmp_31 == 0)) begin
        ram_b_1_0_addr <= _tmp_19 - 1;
        _tmp_31 <= _tmp_21;
      end 
      if(_slice_valid_33 && ((_tmp_31 > 0) && !_tmp_32) && (_tmp_31 > 0)) begin
        ram_b_1_0_addr <= ram_b_1_0_addr + 1;
        ram_b_1_0_wdata <= _slice_data_33;
        ram_b_1_0_wenable <= 1;
        _tmp_31 <= _tmp_31 - 1;
      end 
      if(_slice_valid_33 && ((_tmp_31 > 0) && !_tmp_32) && (_tmp_31 == 1)) begin
        _tmp_32 <= 1;
      end 
      _ram_b_1_cond_0_1 <= 1;
      if((_mystream_fsm_10 == 1) && (_tmp_77 == 0) && !_tmp_75 && !_tmp_76) begin
        ram_b_1_0_addr <= _mystream_offset_6 >> 1;
      end 
      if((_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59) && (_tmp_77 > 0)) begin
        ram_b_1_0_addr <= _tmp_69;
      end 
      if((_tmp_fsm_4 == 1) && (_tmp_156 == 0)) begin
        ram_b_1_0_addr <= _tmp_144 - 1;
        _tmp_156 <= _tmp_146;
      end 
      if(_slice_valid_158 && ((_tmp_156 > 0) && !_tmp_157) && (_tmp_156 > 0)) begin
        ram_b_1_0_addr <= ram_b_1_0_addr + 1;
        ram_b_1_0_wdata <= _slice_data_158;
        ram_b_1_0_wenable <= 1;
        _tmp_156 <= _tmp_156 - 1;
      end 
      if(_slice_valid_158 && ((_tmp_156 > 0) && !_tmp_157) && (_tmp_156 == 1)) begin
        _tmp_157 <= 1;
      end 
      _ram_b_1_cond_1_1 <= 1;
      if(th_sequential == 7) begin
        ram_b_1_0_addr <= _th_sequential_i_18 + _th_sequential_offset_16 >> 1;
      end 
      _ram_b_1_cond_2_1 <= th_sequential == 7;
      _ram_b_1_cond_3_1 <= th_sequential == 7;
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      ram_c_0_0_addr <= 0;
      ram_c_0_0_wdata <= 0;
      ram_c_0_0_wenable <= 0;
      _ram_c_0_cond_0_1 <= 0;
      __tmp_97_1 <= 0;
      __tmp_98_1 <= 0;
      _tmp_102 <= 0;
      _tmp_92 <= 0;
      _tmp_93 <= 0;
      _tmp_100 <= 0;
      _tmp_101 <= 0;
      _tmp_99 <= 0;
      _tmp_103 <= 0;
      _ram_c_0_cond_1_1 <= 0;
      __tmp_183_1 <= 0;
      __tmp_184_1 <= 0;
      _tmp_188 <= 0;
      _tmp_178 <= 0;
      _tmp_179 <= 0;
      _tmp_186 <= 0;
      _tmp_187 <= 0;
      _tmp_185 <= 0;
      _tmp_189 <= 0;
      _ram_c_0_cond_2_1 <= 0;
      _tmp_212 <= 0;
      _ram_c_0_cond_3_1 <= 0;
      _ram_c_0_cond_3_2 <= 0;
      _ram_c_0_cond_4_1 <= 0;
      _tmp_216 <= 0;
      _ram_c_0_cond_5_1 <= 0;
      _ram_c_0_cond_5_2 <= 0;
    end else begin
      if(_ram_c_0_cond_3_2) begin
        _tmp_212 <= 0;
      end 
      if(_ram_c_0_cond_5_2) begin
        _tmp_216 <= 0;
      end 
      if(_ram_c_0_cond_0_1) begin
        ram_c_0_0_wenable <= 0;
      end 
      if(_ram_c_0_cond_1_1) begin
        ram_c_0_0_wenable <= 0;
      end 
      if(_ram_c_0_cond_2_1) begin
        _tmp_212 <= 1;
      end 
      _ram_c_0_cond_3_2 <= _ram_c_0_cond_3_1;
      if(_ram_c_0_cond_4_1) begin
        _tmp_216 <= 1;
      end 
      _ram_c_0_cond_5_2 <= _ram_c_0_cond_5_1;
      if(_plus_valid_80 && ((_tmp_78 > 0) && !_tmp_79) && (_tmp_78 > 0)) begin
        ram_c_0_0_addr <= _tmp_83;
        ram_c_0_0_wdata <= _plus_data_80;
        ram_c_0_0_wenable <= _tmp_85 == 0;
      end 
      _ram_c_0_cond_0_1 <= 1;
      __tmp_97_1 <= _tmp_97;
      __tmp_98_1 <= _tmp_98;
      if((_tmp_94 || !_tmp_92) && (_tmp_95 || !_tmp_93) && _tmp_100) begin
        _tmp_102 <= 0;
        _tmp_92 <= 0;
        _tmp_93 <= 0;
        _tmp_100 <= 0;
      end 
      if((_tmp_94 || !_tmp_92) && (_tmp_95 || !_tmp_93) && _tmp_99) begin
        _tmp_92 <= 1;
        _tmp_93 <= 1;
        _tmp_102 <= _tmp_101;
        _tmp_101 <= 0;
        _tmp_99 <= 0;
        _tmp_100 <= 1;
      end 
      if((_tmp_fsm_2 == 1) && (_tmp_103 == 0) && !_tmp_101 && !_tmp_102) begin
        ram_c_0_0_addr <= _tmp_86;
        _tmp_103 <= _tmp_88 - 1;
        _tmp_99 <= 1;
        _tmp_101 <= _tmp_88 == 1;
      end 
      if((_tmp_94 || !_tmp_92) && (_tmp_95 || !_tmp_93) && (_tmp_103 > 0)) begin
        ram_c_0_0_addr <= ram_c_0_0_addr + 1;
        _tmp_103 <= _tmp_103 - 1;
        _tmp_99 <= 1;
        _tmp_101 <= 0;
      end 
      if((_tmp_94 || !_tmp_92) && (_tmp_95 || !_tmp_93) && (_tmp_103 == 1)) begin
        _tmp_101 <= 1;
      end 
      if((th_sequential == 10) && (_tmp_171 == 0)) begin
        ram_c_0_0_addr <= _th_sequential_i_18 + _th_sequential_offset_16 >> 1;
        ram_c_0_0_wdata <= _th_sequential_sum_17;
        ram_c_0_0_wenable <= 1;
      end 
      _ram_c_0_cond_1_1 <= (th_sequential == 10) && (_tmp_171 == 0);
      __tmp_183_1 <= _tmp_183;
      __tmp_184_1 <= _tmp_184;
      if((_tmp_180 || !_tmp_178) && (_tmp_181 || !_tmp_179) && _tmp_186) begin
        _tmp_188 <= 0;
        _tmp_178 <= 0;
        _tmp_179 <= 0;
        _tmp_186 <= 0;
      end 
      if((_tmp_180 || !_tmp_178) && (_tmp_181 || !_tmp_179) && _tmp_185) begin
        _tmp_178 <= 1;
        _tmp_179 <= 1;
        _tmp_188 <= _tmp_187;
        _tmp_187 <= 0;
        _tmp_185 <= 0;
        _tmp_186 <= 1;
      end 
      if((_tmp_fsm_5 == 1) && (_tmp_189 == 0) && !_tmp_187 && !_tmp_188) begin
        ram_c_0_0_addr <= _tmp_172;
        _tmp_189 <= _tmp_174 - 1;
        _tmp_185 <= 1;
        _tmp_187 <= _tmp_174 == 1;
      end 
      if((_tmp_180 || !_tmp_178) && (_tmp_181 || !_tmp_179) && (_tmp_189 > 0)) begin
        ram_c_0_0_addr <= ram_c_0_0_addr + 1;
        _tmp_189 <= _tmp_189 - 1;
        _tmp_185 <= 1;
        _tmp_187 <= 0;
      end 
      if((_tmp_180 || !_tmp_178) && (_tmp_181 || !_tmp_179) && (_tmp_189 == 1)) begin
        _tmp_187 <= 1;
      end 
      if(th_comp == 29) begin
        ram_c_0_0_addr <= _th_comp_i_25 + _th_comp_offset_stream_22 >> 1;
      end 
      _ram_c_0_cond_2_1 <= th_comp == 29;
      _ram_c_0_cond_3_1 <= th_comp == 29;
      if(th_comp == 31) begin
        ram_c_0_0_addr <= _th_comp_i_25 + _th_comp_offset_seq_23 >> 1;
      end 
      _ram_c_0_cond_4_1 <= th_comp == 31;
      _ram_c_0_cond_5_1 <= th_comp == 31;
    end
  end

  reg [64-1:0] _cat_data_230;
  reg _cat_valid_230;
  wire _cat_ready_230;
  assign _tmp_106 = 1 && ((_cat_ready_230 || !_cat_valid_230) && (_tmp_104 && _tmp_92));
  assign _tmp_94 = 1 && ((_cat_ready_230 || !_cat_valid_230) && (_tmp_104 && _tmp_92));
  reg [64-1:0] _cat_data_231;
  reg _cat_valid_231;
  wire _cat_ready_231;
  assign _tmp_192 = 1 && ((_cat_ready_231 || !_cat_valid_231) && (_tmp_190 && _tmp_178));
  assign _tmp_180 = 1 && ((_cat_ready_231 || !_cat_valid_231) && (_tmp_190 && _tmp_178));
  assign _cat_data_121 = _cat_data_230;
  assign _cat_valid_121 = _cat_valid_230;
  assign _cat_ready_230 = _cat_ready_121;
  assign _cat_data_207 = _cat_data_231;
  assign _cat_valid_207 = _cat_valid_231;
  assign _cat_ready_231 = _cat_ready_207;

  always @(posedge CLK) begin
    if(RST) begin
      _cat_data_230 <= 0;
      _cat_valid_230 <= 0;
      _cat_data_231 <= 0;
      _cat_valid_231 <= 0;
    end else begin
      if((_cat_ready_230 || !_cat_valid_230) && (_tmp_106 && _tmp_94) && (_tmp_104 && _tmp_92)) begin
        _cat_data_230 <= { _tmp_110, _tmp_98 };
      end 
      if(_cat_valid_230 && _cat_ready_230) begin
        _cat_valid_230 <= 0;
      end 
      if((_cat_ready_230 || !_cat_valid_230) && (_tmp_106 && _tmp_94)) begin
        _cat_valid_230 <= _tmp_104 && _tmp_92;
      end 
      if((_cat_ready_231 || !_cat_valid_231) && (_tmp_192 && _tmp_180) && (_tmp_190 && _tmp_178)) begin
        _cat_data_231 <= { _tmp_196, _tmp_184 };
      end 
      if(_cat_valid_231 && _cat_ready_231) begin
        _cat_valid_231 <= 0;
      end 
      if((_cat_ready_231 || !_cat_valid_231) && (_tmp_192 && _tmp_180)) begin
        _cat_valid_231 <= _tmp_190 && _tmp_178;
      end 
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      ram_c_1_0_addr <= 0;
      ram_c_1_0_wdata <= 0;
      ram_c_1_0_wenable <= 0;
      _ram_c_1_cond_0_1 <= 0;
      __tmp_109_1 <= 0;
      __tmp_110_1 <= 0;
      _tmp_114 <= 0;
      _tmp_104 <= 0;
      _tmp_105 <= 0;
      _tmp_112 <= 0;
      _tmp_113 <= 0;
      _tmp_111 <= 0;
      _tmp_115 <= 0;
      _ram_c_1_cond_1_1 <= 0;
      __tmp_195_1 <= 0;
      __tmp_196_1 <= 0;
      _tmp_200 <= 0;
      _tmp_190 <= 0;
      _tmp_191 <= 0;
      _tmp_198 <= 0;
      _tmp_199 <= 0;
      _tmp_197 <= 0;
      _tmp_201 <= 0;
      _ram_c_1_cond_2_1 <= 0;
      _tmp_213 <= 0;
      _ram_c_1_cond_3_1 <= 0;
      _ram_c_1_cond_3_2 <= 0;
      _ram_c_1_cond_4_1 <= 0;
      _tmp_217 <= 0;
      _ram_c_1_cond_5_1 <= 0;
      _ram_c_1_cond_5_2 <= 0;
    end else begin
      if(_ram_c_1_cond_3_2) begin
        _tmp_213 <= 0;
      end 
      if(_ram_c_1_cond_5_2) begin
        _tmp_217 <= 0;
      end 
      if(_ram_c_1_cond_0_1) begin
        ram_c_1_0_wenable <= 0;
      end 
      if(_ram_c_1_cond_1_1) begin
        ram_c_1_0_wenable <= 0;
      end 
      if(_ram_c_1_cond_2_1) begin
        _tmp_213 <= 1;
      end 
      _ram_c_1_cond_3_2 <= _ram_c_1_cond_3_1;
      if(_ram_c_1_cond_4_1) begin
        _tmp_217 <= 1;
      end 
      _ram_c_1_cond_5_2 <= _ram_c_1_cond_5_1;
      if(_plus_valid_80 && ((_tmp_78 > 0) && !_tmp_79) && (_tmp_78 > 0)) begin
        ram_c_1_0_addr <= _tmp_84;
        ram_c_1_0_wdata <= _plus_data_80;
        ram_c_1_0_wenable <= _tmp_85 == 1;
      end 
      _ram_c_1_cond_0_1 <= 1;
      __tmp_109_1 <= _tmp_109;
      __tmp_110_1 <= _tmp_110;
      if((_tmp_106 || !_tmp_104) && (_tmp_107 || !_tmp_105) && _tmp_112) begin
        _tmp_114 <= 0;
        _tmp_104 <= 0;
        _tmp_105 <= 0;
        _tmp_112 <= 0;
      end 
      if((_tmp_106 || !_tmp_104) && (_tmp_107 || !_tmp_105) && _tmp_111) begin
        _tmp_104 <= 1;
        _tmp_105 <= 1;
        _tmp_114 <= _tmp_113;
        _tmp_113 <= 0;
        _tmp_111 <= 0;
        _tmp_112 <= 1;
      end 
      if((_tmp_fsm_2 == 1) && (_tmp_115 == 0) && !_tmp_113 && !_tmp_114) begin
        ram_c_1_0_addr <= _tmp_86;
        _tmp_115 <= _tmp_88 - 1;
        _tmp_111 <= 1;
        _tmp_113 <= _tmp_88 == 1;
      end 
      if((_tmp_106 || !_tmp_104) && (_tmp_107 || !_tmp_105) && (_tmp_115 > 0)) begin
        ram_c_1_0_addr <= ram_c_1_0_addr + 1;
        _tmp_115 <= _tmp_115 - 1;
        _tmp_111 <= 1;
        _tmp_113 <= 0;
      end 
      if((_tmp_106 || !_tmp_104) && (_tmp_107 || !_tmp_105) && (_tmp_115 == 1)) begin
        _tmp_113 <= 1;
      end 
      if((th_sequential == 10) && (_tmp_171 == 1)) begin
        ram_c_1_0_addr <= _th_sequential_i_18 + _th_sequential_offset_16 >> 1;
        ram_c_1_0_wdata <= _th_sequential_sum_17;
        ram_c_1_0_wenable <= 1;
      end 
      _ram_c_1_cond_1_1 <= (th_sequential == 10) && (_tmp_171 == 1);
      __tmp_195_1 <= _tmp_195;
      __tmp_196_1 <= _tmp_196;
      if((_tmp_192 || !_tmp_190) && (_tmp_193 || !_tmp_191) && _tmp_198) begin
        _tmp_200 <= 0;
        _tmp_190 <= 0;
        _tmp_191 <= 0;
        _tmp_198 <= 0;
      end 
      if((_tmp_192 || !_tmp_190) && (_tmp_193 || !_tmp_191) && _tmp_197) begin
        _tmp_190 <= 1;
        _tmp_191 <= 1;
        _tmp_200 <= _tmp_199;
        _tmp_199 <= 0;
        _tmp_197 <= 0;
        _tmp_198 <= 1;
      end 
      if((_tmp_fsm_5 == 1) && (_tmp_201 == 0) && !_tmp_199 && !_tmp_200) begin
        ram_c_1_0_addr <= _tmp_172;
        _tmp_201 <= _tmp_174 - 1;
        _tmp_197 <= 1;
        _tmp_199 <= _tmp_174 == 1;
      end 
      if((_tmp_192 || !_tmp_190) && (_tmp_193 || !_tmp_191) && (_tmp_201 > 0)) begin
        ram_c_1_0_addr <= ram_c_1_0_addr + 1;
        _tmp_201 <= _tmp_201 - 1;
        _tmp_197 <= 1;
        _tmp_199 <= 0;
      end 
      if((_tmp_192 || !_tmp_190) && (_tmp_193 || !_tmp_191) && (_tmp_201 == 1)) begin
        _tmp_199 <= 1;
      end 
      if(th_comp == 29) begin
        ram_c_1_0_addr <= _th_comp_i_25 + _th_comp_offset_stream_22 >> 1;
      end 
      _ram_c_1_cond_2_1 <= th_comp == 29;
      _ram_c_1_cond_3_1 <= th_comp == 29;
      if(th_comp == 31) begin
        ram_c_1_0_addr <= _th_comp_i_25 + _th_comp_offset_seq_23 >> 1;
      end 
      _ram_c_1_cond_4_1 <= th_comp == 31;
      _ram_c_1_cond_5_1 <= th_comp == 31;
    end
  end

  localparam th_comp_1 = 1;
  localparam th_comp_2 = 2;
  localparam th_comp_3 = 3;
  localparam th_comp_4 = 4;
  localparam th_comp_5 = 5;
  localparam th_comp_6 = 6;
  localparam th_comp_7 = 7;
  localparam th_comp_8 = 8;
  localparam th_comp_9 = 9;
  localparam th_comp_10 = 10;
  localparam th_comp_11 = 11;
  localparam th_comp_12 = 12;
  localparam th_comp_13 = 13;
  localparam th_comp_14 = 14;
  localparam th_comp_15 = 15;
  localparam th_comp_16 = 16;
  localparam th_comp_17 = 17;
  localparam th_comp_18 = 18;
  localparam th_comp_19 = 19;
  localparam th_comp_20 = 20;
  localparam th_comp_21 = 21;
  localparam th_comp_22 = 22;
  localparam th_comp_23 = 23;
  localparam th_comp_24 = 24;
  localparam th_comp_25 = 25;
  localparam th_comp_26 = 26;
  localparam th_comp_27 = 27;
  localparam th_comp_28 = 28;
  localparam th_comp_29 = 29;
  localparam th_comp_30 = 30;
  localparam th_comp_31 = 31;
  localparam th_comp_32 = 32;
  localparam th_comp_33 = 33;
  localparam th_comp_34 = 34;
  localparam th_comp_35 = 35;
  localparam th_comp_36 = 36;
  localparam th_comp_37 = 37;
  localparam th_comp_38 = 38;
  localparam th_comp_39 = 39;
  localparam th_comp_40 = 40;

  always @(posedge CLK) begin
    if(RST) begin
      th_comp <= th_comp_init;
      _th_comp_size_0 <= 0;
      _th_comp_dma_size_1 <= 0;
      _th_comp_comp_size_2 <= 0;
      _th_comp_dma_offset_3 <= 0;
      _th_comp_comp_offset_4 <= 0;
      _tmp_0 <= 0;
      _tmp_1 <= 0;
      _tmp_2 <= 0;
      _tmp_19 <= 0;
      _tmp_20 <= 0;
      _tmp_21 <= 0;
      _tmp_86 <= 0;
      _tmp_87 <= 0;
      _tmp_88 <= 0;
      _tmp_125 <= 0;
      _tmp_126 <= 0;
      _tmp_127 <= 0;
      _tmp_144 <= 0;
      _tmp_145 <= 0;
      _tmp_146 <= 0;
      _tmp_172 <= 0;
      _tmp_173 <= 0;
      _tmp_174 <= 0;
      _th_comp_size_21 <= 0;
      _th_comp_offset_stream_22 <= 0;
      _th_comp_offset_seq_23 <= 0;
      _th_comp_all_ok_24 <= 0;
      _th_comp_i_25 <= 0;
      _tmp_214 <= 0;
      _th_comp_st_26 <= 0;
      _tmp_218 <= 0;
      _th_comp_sq_27 <= 0;
    end else begin
      case(th_comp)
        th_comp_init: begin
          _th_comp_size_0 <= 32;
          th_comp <= th_comp_1;
        end
        th_comp_1: begin
          _th_comp_dma_size_1 <= _th_comp_size_0;
          th_comp <= th_comp_2;
        end
        th_comp_2: begin
          _th_comp_comp_size_2 <= _th_comp_size_0 << 1;
          th_comp <= th_comp_3;
        end
        th_comp_3: begin
          _th_comp_dma_offset_3 <= 0;
          th_comp <= th_comp_4;
        end
        th_comp_4: begin
          _th_comp_comp_offset_4 <= 0;
          th_comp <= th_comp_5;
        end
        th_comp_5: begin
          _tmp_0 <= _th_comp_dma_offset_3;
          _tmp_1 <= 0;
          _tmp_2 <= _th_comp_dma_size_1;
          th_comp <= th_comp_6;
        end
        th_comp_6: begin
          if(_tmp_18) begin
            th_comp <= th_comp_7;
          end 
        end
        th_comp_7: begin
          _tmp_19 <= _th_comp_dma_offset_3;
          _tmp_20 <= 0;
          _tmp_21 <= _th_comp_dma_size_1;
          th_comp <= th_comp_8;
        end
        th_comp_8: begin
          if(_tmp_37) begin
            th_comp <= th_comp_9;
          end 
        end
        th_comp_9: begin
          th_comp <= th_comp_10;
        end
        th_comp_10: begin
          th_comp <= th_comp_11;
        end
        th_comp_11: begin
          th_comp <= th_comp_12;
        end
        th_comp_12: begin
          if(!_mystream_running) begin
            th_comp <= th_comp_13;
          end 
        end
        th_comp_13: begin
          _tmp_86 <= _th_comp_dma_offset_3;
          _tmp_87 <= 1024;
          _tmp_88 <= _th_comp_dma_size_1;
          th_comp <= th_comp_14;
        end
        th_comp_14: begin
          if(_tmp_124) begin
            th_comp <= th_comp_15;
          end 
        end
        th_comp_15: begin
          _th_comp_dma_offset_3 <= _th_comp_size_0;
          th_comp <= th_comp_16;
        end
        th_comp_16: begin
          _th_comp_comp_offset_4 <= _th_comp_comp_size_2;
          th_comp <= th_comp_17;
        end
        th_comp_17: begin
          _tmp_125 <= _th_comp_dma_offset_3;
          _tmp_126 <= 0;
          _tmp_127 <= _th_comp_dma_size_1;
          th_comp <= th_comp_18;
        end
        th_comp_18: begin
          if(_tmp_143) begin
            th_comp <= th_comp_19;
          end 
        end
        th_comp_19: begin
          _tmp_144 <= _th_comp_dma_offset_3;
          _tmp_145 <= 0;
          _tmp_146 <= _th_comp_dma_size_1;
          th_comp <= th_comp_20;
        end
        th_comp_20: begin
          if(_tmp_162) begin
            th_comp <= th_comp_21;
          end 
        end
        th_comp_21: begin
          th_comp <= th_comp_22;
        end
        th_comp_22: begin
          if(th_sequential == 12) begin
            th_comp <= th_comp_23;
          end 
        end
        th_comp_23: begin
          _tmp_172 <= _th_comp_dma_offset_3;
          _tmp_173 <= 2048;
          _tmp_174 <= _th_comp_dma_size_1;
          th_comp <= th_comp_24;
        end
        th_comp_24: begin
          if(_tmp_210) begin
            th_comp <= th_comp_25;
          end 
        end
        th_comp_25: begin
          _th_comp_size_21 <= _th_comp_comp_size_2;
          _th_comp_offset_stream_22 <= 0;
          _th_comp_offset_seq_23 <= _th_comp_comp_offset_4;
          th_comp <= th_comp_26;
        end
        th_comp_26: begin
          _th_comp_all_ok_24 <= 1;
          th_comp <= th_comp_27;
        end
        th_comp_27: begin
          _th_comp_i_25 <= 0;
          th_comp <= th_comp_28;
        end
        th_comp_28: begin
          if(_th_comp_i_25 < _th_comp_size_21) begin
            th_comp <= th_comp_29;
          end else begin
            th_comp <= th_comp_36;
          end
        end
        th_comp_29: begin
          if(_tmp_212 && (_tmp_211 == 0)) begin
            _tmp_214 <= ram_c_0_0_rdata;
          end 
          if(_tmp_213 && (_tmp_211 == 1)) begin
            _tmp_214 <= ram_c_1_0_rdata;
          end 
          if(_tmp_212) begin
            th_comp <= th_comp_30;
          end 
        end
        th_comp_30: begin
          _th_comp_st_26 <= _tmp_214;
          th_comp <= th_comp_31;
        end
        th_comp_31: begin
          if(_tmp_216 && (_tmp_215 == 0)) begin
            _tmp_218 <= ram_c_0_0_rdata;
          end 
          if(_tmp_217 && (_tmp_215 == 1)) begin
            _tmp_218 <= ram_c_1_0_rdata;
          end 
          if(_tmp_216) begin
            th_comp <= th_comp_32;
          end 
        end
        th_comp_32: begin
          _th_comp_sq_27 <= _tmp_218;
          th_comp <= th_comp_33;
        end
        th_comp_33: begin
          if(_th_comp_st_26 !== _th_comp_sq_27) begin
            th_comp <= th_comp_34;
          end else begin
            th_comp <= th_comp_35;
          end
        end
        th_comp_34: begin
          _th_comp_all_ok_24 <= 0;
          th_comp <= th_comp_35;
        end
        th_comp_35: begin
          _th_comp_i_25 <= _th_comp_i_25 + 1;
          th_comp <= th_comp_28;
        end
        th_comp_36: begin
          if(_th_comp_all_ok_24) begin
            th_comp <= th_comp_37;
          end else begin
            th_comp <= th_comp_39;
          end
        end
        th_comp_37: begin
          $display("OK");
          th_comp <= th_comp_38;
        end
        th_comp_38: begin
          th_comp <= th_comp_40;
        end
        th_comp_39: begin
          $display("NG");
          th_comp <= th_comp_40;
        end
      endcase
    end
  end

  localparam _tmp_fsm_0_1 = 1;
  localparam _tmp_fsm_0_2 = 2;
  localparam _tmp_fsm_0_3 = 3;
  localparam _tmp_fsm_0_4 = 4;
  localparam _tmp_fsm_0_5 = 5;
  localparam _tmp_fsm_0_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_0 <= _tmp_fsm_0_init;
      _d1__tmp_fsm_0 <= _tmp_fsm_0_init;
      _tmp_3 <= 0;
      _tmp_5 <= 0;
      _tmp_15 <= 0;
      _tmp_4 <= 0;
      __tmp_fsm_0_cond_4_0_1 <= 0;
      _tmp_8 <= 0;
      _tmp_6 <= 0;
      _tmp_17 <= 0;
      _tmp_18 <= 0;
      __tmp_fsm_0_cond_5_1_1 <= 0;
    end else begin
      _d1__tmp_fsm_0 <= _tmp_fsm_0;
      case(_d1__tmp_fsm_0)
        _tmp_fsm_0_4: begin
          if(__tmp_fsm_0_cond_4_0_1) begin
            _tmp_8 <= 0;
          end 
        end
        _tmp_fsm_0_5: begin
          if(__tmp_fsm_0_cond_5_1_1) begin
            _tmp_18 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_0)
        _tmp_fsm_0_init: begin
          if(th_comp == 6) begin
            _tmp_fsm_0 <= _tmp_fsm_0_1;
          end 
        end
        _tmp_fsm_0_1: begin
          _tmp_3 <= (_tmp_1 >> 4) << 4;
          _tmp_5 <= _tmp_2 >> 1;
          _tmp_fsm_0 <= _tmp_fsm_0_2;
        end
        _tmp_fsm_0_2: begin
          _tmp_15 <= 0;
          if((_tmp_5 <= 256) && ((_tmp_3 & 4095) + (_tmp_5 << 4) >= 4096)) begin
            _tmp_4 <= 4096 - (_tmp_3 & 4095) >> 4;
            _tmp_5 <= _tmp_5 - (4096 - (_tmp_3 & 4095) >> 4);
          end else if(_tmp_5 <= 256) begin
            _tmp_4 <= _tmp_5;
            _tmp_5 <= 0;
          end else if((_tmp_3 & 4095) + 4096 >= 4096) begin
            _tmp_4 <= 4096 - (_tmp_3 & 4095) >> 4;
            _tmp_5 <= _tmp_5 - (4096 - (_tmp_3 & 4095) >> 4);
          end else begin
            _tmp_4 <= 256;
            _tmp_5 <= _tmp_5 - 256;
          end
          _tmp_fsm_0 <= _tmp_fsm_0_3;
        end
        _tmp_fsm_0_3: begin
          if(myaxi_arready || !myaxi_arvalid) begin
            _tmp_fsm_0 <= _tmp_fsm_0_4;
          end 
        end
        _tmp_fsm_0_4: begin
          __tmp_fsm_0_cond_4_0_1 <= 1;
          if((_tmp_17 == 0) && (myaxi_rready && myaxi_rvalid) && myaxi_rlast) begin
            _tmp_15 <= 1;
          end 
          if((_tmp_17 == 0) && (myaxi_rready && myaxi_rvalid)) begin
            _tmp_6 <= myaxi_rdata;
            _tmp_8 <= 1;
            _tmp_17 <= _tmp_17 + 1;
          end 
          if(_tmp_17 > 0) begin
            _tmp_6 <= _tmp_6 >> 64;
            _tmp_8 <= 1;
            _tmp_17 <= _tmp_17 + 1;
          end 
          if(_tmp_17 == 1) begin
            _tmp_17 <= 0;
          end 
          if(_tmp_15 && (_tmp_17 == 1)) begin
            _tmp_3 <= _tmp_3 + (_tmp_4 << 4);
          end 
          if(_tmp_15 && (_tmp_17 == 1) && (_tmp_5 > 0)) begin
            _tmp_fsm_0 <= _tmp_fsm_0_2;
          end 
          if(_tmp_15 && (_tmp_17 == 1) && (_tmp_5 == 0)) begin
            _tmp_fsm_0 <= _tmp_fsm_0_5;
          end 
        end
        _tmp_fsm_0_5: begin
          _tmp_18 <= 1;
          __tmp_fsm_0_cond_5_1_1 <= 1;
          _tmp_fsm_0 <= _tmp_fsm_0_6;
        end
        _tmp_fsm_0_6: begin
          _tmp_fsm_0 <= _tmp_fsm_0_init;
        end
      endcase
    end
  end

  localparam _tmp_fsm_1_1 = 1;
  localparam _tmp_fsm_1_2 = 2;
  localparam _tmp_fsm_1_3 = 3;
  localparam _tmp_fsm_1_4 = 4;
  localparam _tmp_fsm_1_5 = 5;
  localparam _tmp_fsm_1_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_1 <= _tmp_fsm_1_init;
      _d1__tmp_fsm_1 <= _tmp_fsm_1_init;
      _tmp_22 <= 0;
      _tmp_24 <= 0;
      _tmp_34 <= 0;
      _tmp_23 <= 0;
      __tmp_fsm_1_cond_4_0_1 <= 0;
      _tmp_27 <= 0;
      _tmp_25 <= 0;
      _tmp_36 <= 0;
      _tmp_37 <= 0;
      __tmp_fsm_1_cond_5_1_1 <= 0;
    end else begin
      _d1__tmp_fsm_1 <= _tmp_fsm_1;
      case(_d1__tmp_fsm_1)
        _tmp_fsm_1_4: begin
          if(__tmp_fsm_1_cond_4_0_1) begin
            _tmp_27 <= 0;
          end 
        end
        _tmp_fsm_1_5: begin
          if(__tmp_fsm_1_cond_5_1_1) begin
            _tmp_37 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_1)
        _tmp_fsm_1_init: begin
          if(th_comp == 8) begin
            _tmp_fsm_1 <= _tmp_fsm_1_1;
          end 
        end
        _tmp_fsm_1_1: begin
          _tmp_22 <= (_tmp_20 >> 4) << 4;
          _tmp_24 <= _tmp_21 >> 1;
          _tmp_fsm_1 <= _tmp_fsm_1_2;
        end
        _tmp_fsm_1_2: begin
          _tmp_34 <= 0;
          if((_tmp_24 <= 256) && ((_tmp_22 & 4095) + (_tmp_24 << 4) >= 4096)) begin
            _tmp_23 <= 4096 - (_tmp_22 & 4095) >> 4;
            _tmp_24 <= _tmp_24 - (4096 - (_tmp_22 & 4095) >> 4);
          end else if(_tmp_24 <= 256) begin
            _tmp_23 <= _tmp_24;
            _tmp_24 <= 0;
          end else if((_tmp_22 & 4095) + 4096 >= 4096) begin
            _tmp_23 <= 4096 - (_tmp_22 & 4095) >> 4;
            _tmp_24 <= _tmp_24 - (4096 - (_tmp_22 & 4095) >> 4);
          end else begin
            _tmp_23 <= 256;
            _tmp_24 <= _tmp_24 - 256;
          end
          _tmp_fsm_1 <= _tmp_fsm_1_3;
        end
        _tmp_fsm_1_3: begin
          if(myaxi_arready || !myaxi_arvalid) begin
            _tmp_fsm_1 <= _tmp_fsm_1_4;
          end 
        end
        _tmp_fsm_1_4: begin
          __tmp_fsm_1_cond_4_0_1 <= 1;
          if((_tmp_36 == 0) && (myaxi_rready && myaxi_rvalid) && myaxi_rlast) begin
            _tmp_34 <= 1;
          end 
          if((_tmp_36 == 0) && (myaxi_rready && myaxi_rvalid)) begin
            _tmp_25 <= myaxi_rdata;
            _tmp_27 <= 1;
            _tmp_36 <= _tmp_36 + 1;
          end 
          if(_tmp_36 > 0) begin
            _tmp_25 <= _tmp_25 >> 64;
            _tmp_27 <= 1;
            _tmp_36 <= _tmp_36 + 1;
          end 
          if(_tmp_36 == 1) begin
            _tmp_36 <= 0;
          end 
          if(_tmp_34 && (_tmp_36 == 1)) begin
            _tmp_22 <= _tmp_22 + (_tmp_23 << 4);
          end 
          if(_tmp_34 && (_tmp_36 == 1) && (_tmp_24 > 0)) begin
            _tmp_fsm_1 <= _tmp_fsm_1_2;
          end 
          if(_tmp_34 && (_tmp_36 == 1) && (_tmp_24 == 0)) begin
            _tmp_fsm_1 <= _tmp_fsm_1_5;
          end 
        end
        _tmp_fsm_1_5: begin
          _tmp_37 <= 1;
          __tmp_fsm_1_cond_5_1_1 <= 1;
          _tmp_fsm_1 <= _tmp_fsm_1_6;
        end
        _tmp_fsm_1_6: begin
          _tmp_fsm_1 <= _tmp_fsm_1_init;
        end
      endcase
    end
  end

  localparam mystream_1 = 1;
  localparam mystream_2 = 2;
  localparam mystream_3 = 3;

  always @(posedge CLK) begin
    if(RST) begin
      mystream <= mystream_init;
      _mystream_start_cond <= 0;
      _mystream_running_reg <= 0;
      _mystream_size_5 <= 0;
      _mystream_offset_6 <= 0;
    end else begin
      case(mystream)
        mystream_init: begin
          if(th_comp == 9) begin
            _mystream_start_cond <= 1;
          end 
          if(th_comp == 9) begin
            _mystream_running_reg <= 1;
          end 
          if(th_comp == 9) begin
            _mystream_size_5 <= _th_comp_comp_size_2;
          end 
          if(th_comp == 9) begin
            _mystream_offset_6 <= _th_comp_comp_offset_4;
          end 
          if(th_comp == 9) begin
            mystream <= mystream_1;
          end 
        end
        mystream_1: begin
          _mystream_start_cond <= 0;
          mystream <= mystream_2;
        end
        mystream_2: begin
          mystream <= mystream_3;
        end
        mystream_3: begin
          if(_mystream_done_flag_7 && _mystream_done_flag_9 && _mystream_done_flag_11) begin
            _mystream_running_reg <= 0;
          end 
          if(_mystream_done_flag_7 && _mystream_done_flag_9 && _mystream_done_flag_11) begin
            mystream <= mystream_init;
          end 
        end
      endcase
    end
  end

  localparam _mystream_fsm_8_1 = 1;
  localparam _mystream_fsm_8_2 = 2;
  localparam _mystream_fsm_8_3 = 3;

  always @(posedge CLK) begin
    if(RST) begin
      _mystream_fsm_8 <= _mystream_fsm_8_init;
      _mystream_done_flag_7 <= 0;
    end else begin
      case(_mystream_fsm_8)
        _mystream_fsm_8_init: begin
          if(_mystream_start_cond) begin
            _mystream_fsm_8 <= _mystream_fsm_8_1;
          end 
        end
        _mystream_fsm_8_1: begin
          _mystream_fsm_8 <= _mystream_fsm_8_2;
        end
        _mystream_fsm_8_2: begin
          if(_tmp_56) begin
            _mystream_done_flag_7 <= 1;
          end 
          if(_tmp_56) begin
            _mystream_fsm_8 <= _mystream_fsm_8_3;
          end 
        end
        _mystream_fsm_8_3: begin
          if(!_mystream_running) begin
            _mystream_done_flag_7 <= 0;
          end 
          if(!_mystream_running) begin
            _mystream_fsm_8 <= _mystream_fsm_8_init;
          end 
        end
      endcase
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      __tmp_43_1 <= 0;
      __tmp_44_1 <= 0;
      __tmp_45_1 <= 0;
      __tmp_51_1 <= 0;
      _tmp_51 <= 0;
      _tmp_56 <= 0;
      _tmp_38 <= 0;
      _tmp_39 <= 0;
      _tmp_54 <= 0;
      _tmp_55 <= 0;
      _tmp_53 <= 0;
      _tmp_46 <= 0;
      _tmp_57 <= 0;
    end else begin
      __tmp_43_1 <= _tmp_43;
      __tmp_44_1 <= _tmp_44;
      __tmp_45_1 <= _tmp_45;
      __tmp_51_1 <= _tmp_51;
      _tmp_51 <= _tmp_50;
      if((_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39) && _tmp_54) begin
        _tmp_56 <= 0;
        _tmp_38 <= 0;
        _tmp_39 <= 0;
        _tmp_54 <= 0;
      end 
      if((_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39) && _tmp_53) begin
        _tmp_38 <= 1;
        _tmp_39 <= 1;
        _tmp_56 <= _tmp_55;
        _tmp_55 <= 0;
        _tmp_53 <= 0;
        _tmp_54 <= 1;
      end 
      if((_mystream_fsm_8 == 1) && (_tmp_57 == 0) && !_tmp_55 && !_tmp_56) begin
        _tmp_46 <= _mystream_offset_6;
        _tmp_57 <= _mystream_size_5 - 1;
        _tmp_53 <= 1;
        _tmp_55 <= _mystream_size_5 == 1;
      end 
      if((_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39) && (_tmp_57 > 0)) begin
        _tmp_46 <= _tmp_46 + 1;
        _tmp_57 <= _tmp_57 - 1;
        _tmp_53 <= 1;
        _tmp_55 <= 0;
      end 
      if((_tmp_40 || !_tmp_38) && (_tmp_41 || !_tmp_39) && (_tmp_57 == 1)) begin
        _tmp_55 <= 1;
      end 
    end
  end

  localparam _mystream_fsm_10_1 = 1;
  localparam _mystream_fsm_10_2 = 2;
  localparam _mystream_fsm_10_3 = 3;

  always @(posedge CLK) begin
    if(RST) begin
      _mystream_fsm_10 <= _mystream_fsm_10_init;
      _mystream_done_flag_9 <= 0;
    end else begin
      case(_mystream_fsm_10)
        _mystream_fsm_10_init: begin
          if(_mystream_start_cond) begin
            _mystream_fsm_10 <= _mystream_fsm_10_1;
          end 
        end
        _mystream_fsm_10_1: begin
          _mystream_fsm_10 <= _mystream_fsm_10_2;
        end
        _mystream_fsm_10_2: begin
          if(_tmp_76) begin
            _mystream_done_flag_9 <= 1;
          end 
          if(_tmp_76) begin
            _mystream_fsm_10 <= _mystream_fsm_10_3;
          end 
        end
        _mystream_fsm_10_3: begin
          if(!_mystream_running) begin
            _mystream_done_flag_9 <= 0;
          end 
          if(!_mystream_running) begin
            _mystream_fsm_10 <= _mystream_fsm_10_init;
          end 
        end
      endcase
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      __tmp_63_1 <= 0;
      __tmp_64_1 <= 0;
      __tmp_65_1 <= 0;
      __tmp_71_1 <= 0;
      _tmp_71 <= 0;
      _tmp_76 <= 0;
      _tmp_58 <= 0;
      _tmp_59 <= 0;
      _tmp_74 <= 0;
      _tmp_75 <= 0;
      _tmp_73 <= 0;
      _tmp_66 <= 0;
      _tmp_77 <= 0;
    end else begin
      __tmp_63_1 <= _tmp_63;
      __tmp_64_1 <= _tmp_64;
      __tmp_65_1 <= _tmp_65;
      __tmp_71_1 <= _tmp_71;
      _tmp_71 <= _tmp_70;
      if((_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59) && _tmp_74) begin
        _tmp_76 <= 0;
        _tmp_58 <= 0;
        _tmp_59 <= 0;
        _tmp_74 <= 0;
      end 
      if((_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59) && _tmp_73) begin
        _tmp_58 <= 1;
        _tmp_59 <= 1;
        _tmp_76 <= _tmp_75;
        _tmp_75 <= 0;
        _tmp_73 <= 0;
        _tmp_74 <= 1;
      end 
      if((_mystream_fsm_10 == 1) && (_tmp_77 == 0) && !_tmp_75 && !_tmp_76) begin
        _tmp_66 <= _mystream_offset_6;
        _tmp_77 <= _mystream_size_5 - 1;
        _tmp_73 <= 1;
        _tmp_75 <= _mystream_size_5 == 1;
      end 
      if((_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59) && (_tmp_77 > 0)) begin
        _tmp_66 <= _tmp_66 + 1;
        _tmp_77 <= _tmp_77 - 1;
        _tmp_73 <= 1;
        _tmp_75 <= 0;
      end 
      if((_tmp_60 || !_tmp_58) && (_tmp_61 || !_tmp_59) && (_tmp_77 == 1)) begin
        _tmp_75 <= 1;
      end 
    end
  end

  localparam _mystream_fsm_12_1 = 1;
  localparam _mystream_fsm_12_2 = 2;
  localparam _mystream_fsm_12_3 = 3;

  always @(posedge CLK) begin
    if(RST) begin
      _mystream_fsm_12 <= _mystream_fsm_12_init;
      _mystream_done_flag_11 <= 0;
    end else begin
      case(_mystream_fsm_12)
        _mystream_fsm_12_init: begin
          if(_mystream_start_cond) begin
            _mystream_fsm_12 <= _mystream_fsm_12_1;
          end 
        end
        _mystream_fsm_12_1: begin
          _mystream_fsm_12 <= _mystream_fsm_12_2;
        end
        _mystream_fsm_12_2: begin
          if(_tmp_79) begin
            _mystream_done_flag_11 <= 1;
          end 
          if(_tmp_79) begin
            _mystream_fsm_12 <= _mystream_fsm_12_3;
          end 
        end
        _mystream_fsm_12_3: begin
          if(!_mystream_running) begin
            _mystream_done_flag_11 <= 0;
          end 
          if(!_mystream_running) begin
            _mystream_fsm_12 <= _mystream_fsm_12_init;
          end 
        end
      endcase
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      _tmp_81 <= 0;
      _tmp_78 <= 0;
      _tmp_79 <= 0;
      _ram_c_cond_0_1 <= 0;
    end else begin
      if(_ram_c_cond_0_1) begin
        _tmp_79 <= 0;
      end 
      if((_mystream_fsm_12 == 1) && (_tmp_78 == 0)) begin
        _tmp_81 <= _mystream_offset_6 - 1;
        _tmp_78 <= _mystream_size_5;
      end 
      if(_plus_valid_80 && ((_tmp_78 > 0) && !_tmp_79) && (_tmp_78 > 0)) begin
        _tmp_81 <= _tmp_82;
        _tmp_78 <= _tmp_78 - 1;
      end 
      if(_plus_valid_80 && ((_tmp_78 > 0) && !_tmp_79) && (_tmp_78 == 1)) begin
        _tmp_79 <= 1;
      end 
      _ram_c_cond_0_1 <= 1;
    end
  end

  localparam _tmp_fsm_2_1 = 1;
  localparam _tmp_fsm_2_2 = 2;
  localparam _tmp_fsm_2_3 = 3;
  localparam _tmp_fsm_2_4 = 4;
  localparam _tmp_fsm_2_5 = 5;
  localparam _tmp_fsm_2_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_2 <= _tmp_fsm_2_init;
      _d1__tmp_fsm_2 <= _tmp_fsm_2_init;
      _tmp_89 <= 0;
      _tmp_91 <= 0;
      _tmp_90 <= 0;
      _tmp_124 <= 0;
      __tmp_fsm_2_cond_5_0_1 <= 0;
    end else begin
      _d1__tmp_fsm_2 <= _tmp_fsm_2;
      case(_d1__tmp_fsm_2)
        _tmp_fsm_2_5: begin
          if(__tmp_fsm_2_cond_5_0_1) begin
            _tmp_124 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_2)
        _tmp_fsm_2_init: begin
          if(th_comp == 14) begin
            _tmp_fsm_2 <= _tmp_fsm_2_1;
          end 
        end
        _tmp_fsm_2_1: begin
          _tmp_89 <= (_tmp_87 >> 4) << 4;
          _tmp_91 <= _tmp_88 >> 1;
          _tmp_fsm_2 <= _tmp_fsm_2_2;
        end
        _tmp_fsm_2_2: begin
          if((_tmp_91 <= 256) && ((_tmp_89 & 4095) + (_tmp_91 << 4) >= 4096)) begin
            _tmp_90 <= 4096 - (_tmp_89 & 4095) >> 4;
            _tmp_91 <= _tmp_91 - (4096 - (_tmp_89 & 4095) >> 4);
          end else if(_tmp_91 <= 256) begin
            _tmp_90 <= _tmp_91;
            _tmp_91 <= 0;
          end else if((_tmp_89 & 4095) + 4096 >= 4096) begin
            _tmp_90 <= 4096 - (_tmp_89 & 4095) >> 4;
            _tmp_91 <= _tmp_91 - (4096 - (_tmp_89 & 4095) >> 4);
          end else begin
            _tmp_90 <= 256;
            _tmp_91 <= _tmp_91 - 256;
          end
          _tmp_fsm_2 <= _tmp_fsm_2_3;
        end
        _tmp_fsm_2_3: begin
          if(myaxi_awready || !myaxi_awvalid) begin
            _tmp_fsm_2 <= _tmp_fsm_2_4;
          end 
        end
        _tmp_fsm_2_4: begin
          if(_tmp_122 && myaxi_wvalid && myaxi_wready) begin
            _tmp_89 <= _tmp_89 + (_tmp_90 << 4);
          end 
          if(_tmp_122 && myaxi_wvalid && myaxi_wready && (_tmp_91 > 0)) begin
            _tmp_fsm_2 <= _tmp_fsm_2_2;
          end 
          if(_tmp_122 && myaxi_wvalid && myaxi_wready && (_tmp_91 == 0)) begin
            _tmp_fsm_2 <= _tmp_fsm_2_5;
          end 
        end
        _tmp_fsm_2_5: begin
          _tmp_124 <= 1;
          __tmp_fsm_2_cond_5_0_1 <= 1;
          _tmp_fsm_2 <= _tmp_fsm_2_6;
        end
        _tmp_fsm_2_6: begin
          _tmp_fsm_2 <= _tmp_fsm_2_init;
        end
      endcase
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      _tmp_118 <= 0;
      _tmp_117 <= 0;
      _tmp_120 <= 0;
    end else begin
      if(_tmp_119 || !_tmp_118) begin
        _tmp_118 <= 0;
      end 
      if(_cat_valid_121 && ((_tmp_fsm_2 == 4) && (_tmp_119 || !_tmp_118))) begin
        _tmp_117 <= { _cat_data_121, _tmp_117[127:64] };
        _tmp_118 <= 0;
        _tmp_120 <= _tmp_120 + 1;
      end 
      if(_cat_valid_121 && ((_tmp_fsm_2 == 4) && (_tmp_119 || !_tmp_118)) && (_tmp_120 == 1)) begin
        _tmp_117 <= { _cat_data_121, _tmp_117[127:64] };
        _tmp_118 <= 1;
        _tmp_120 <= 0;
      end 
    end
  end

  localparam _tmp_fsm_3_1 = 1;
  localparam _tmp_fsm_3_2 = 2;
  localparam _tmp_fsm_3_3 = 3;
  localparam _tmp_fsm_3_4 = 4;
  localparam _tmp_fsm_3_5 = 5;
  localparam _tmp_fsm_3_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_3 <= _tmp_fsm_3_init;
      _d1__tmp_fsm_3 <= _tmp_fsm_3_init;
      _tmp_128 <= 0;
      _tmp_130 <= 0;
      _tmp_140 <= 0;
      _tmp_129 <= 0;
      __tmp_fsm_3_cond_4_0_1 <= 0;
      _tmp_133 <= 0;
      _tmp_131 <= 0;
      _tmp_142 <= 0;
      _tmp_143 <= 0;
      __tmp_fsm_3_cond_5_1_1 <= 0;
    end else begin
      _d1__tmp_fsm_3 <= _tmp_fsm_3;
      case(_d1__tmp_fsm_3)
        _tmp_fsm_3_4: begin
          if(__tmp_fsm_3_cond_4_0_1) begin
            _tmp_133 <= 0;
          end 
        end
        _tmp_fsm_3_5: begin
          if(__tmp_fsm_3_cond_5_1_1) begin
            _tmp_143 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_3)
        _tmp_fsm_3_init: begin
          if(th_comp == 18) begin
            _tmp_fsm_3 <= _tmp_fsm_3_1;
          end 
        end
        _tmp_fsm_3_1: begin
          _tmp_128 <= (_tmp_126 >> 4) << 4;
          _tmp_130 <= _tmp_127 >> 1;
          _tmp_fsm_3 <= _tmp_fsm_3_2;
        end
        _tmp_fsm_3_2: begin
          _tmp_140 <= 0;
          if((_tmp_130 <= 256) && ((_tmp_128 & 4095) + (_tmp_130 << 4) >= 4096)) begin
            _tmp_129 <= 4096 - (_tmp_128 & 4095) >> 4;
            _tmp_130 <= _tmp_130 - (4096 - (_tmp_128 & 4095) >> 4);
          end else if(_tmp_130 <= 256) begin
            _tmp_129 <= _tmp_130;
            _tmp_130 <= 0;
          end else if((_tmp_128 & 4095) + 4096 >= 4096) begin
            _tmp_129 <= 4096 - (_tmp_128 & 4095) >> 4;
            _tmp_130 <= _tmp_130 - (4096 - (_tmp_128 & 4095) >> 4);
          end else begin
            _tmp_129 <= 256;
            _tmp_130 <= _tmp_130 - 256;
          end
          _tmp_fsm_3 <= _tmp_fsm_3_3;
        end
        _tmp_fsm_3_3: begin
          if(myaxi_arready || !myaxi_arvalid) begin
            _tmp_fsm_3 <= _tmp_fsm_3_4;
          end 
        end
        _tmp_fsm_3_4: begin
          __tmp_fsm_3_cond_4_0_1 <= 1;
          if((_tmp_142 == 0) && (myaxi_rready && myaxi_rvalid) && myaxi_rlast) begin
            _tmp_140 <= 1;
          end 
          if((_tmp_142 == 0) && (myaxi_rready && myaxi_rvalid)) begin
            _tmp_131 <= myaxi_rdata;
            _tmp_133 <= 1;
            _tmp_142 <= _tmp_142 + 1;
          end 
          if(_tmp_142 > 0) begin
            _tmp_131 <= _tmp_131 >> 64;
            _tmp_133 <= 1;
            _tmp_142 <= _tmp_142 + 1;
          end 
          if(_tmp_142 == 1) begin
            _tmp_142 <= 0;
          end 
          if(_tmp_140 && (_tmp_142 == 1)) begin
            _tmp_128 <= _tmp_128 + (_tmp_129 << 4);
          end 
          if(_tmp_140 && (_tmp_142 == 1) && (_tmp_130 > 0)) begin
            _tmp_fsm_3 <= _tmp_fsm_3_2;
          end 
          if(_tmp_140 && (_tmp_142 == 1) && (_tmp_130 == 0)) begin
            _tmp_fsm_3 <= _tmp_fsm_3_5;
          end 
        end
        _tmp_fsm_3_5: begin
          _tmp_143 <= 1;
          __tmp_fsm_3_cond_5_1_1 <= 1;
          _tmp_fsm_3 <= _tmp_fsm_3_6;
        end
        _tmp_fsm_3_6: begin
          _tmp_fsm_3 <= _tmp_fsm_3_init;
        end
      endcase
    end
  end

  localparam _tmp_fsm_4_1 = 1;
  localparam _tmp_fsm_4_2 = 2;
  localparam _tmp_fsm_4_3 = 3;
  localparam _tmp_fsm_4_4 = 4;
  localparam _tmp_fsm_4_5 = 5;
  localparam _tmp_fsm_4_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_4 <= _tmp_fsm_4_init;
      _d1__tmp_fsm_4 <= _tmp_fsm_4_init;
      _tmp_147 <= 0;
      _tmp_149 <= 0;
      _tmp_159 <= 0;
      _tmp_148 <= 0;
      __tmp_fsm_4_cond_4_0_1 <= 0;
      _tmp_152 <= 0;
      _tmp_150 <= 0;
      _tmp_161 <= 0;
      _tmp_162 <= 0;
      __tmp_fsm_4_cond_5_1_1 <= 0;
    end else begin
      _d1__tmp_fsm_4 <= _tmp_fsm_4;
      case(_d1__tmp_fsm_4)
        _tmp_fsm_4_4: begin
          if(__tmp_fsm_4_cond_4_0_1) begin
            _tmp_152 <= 0;
          end 
        end
        _tmp_fsm_4_5: begin
          if(__tmp_fsm_4_cond_5_1_1) begin
            _tmp_162 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_4)
        _tmp_fsm_4_init: begin
          if(th_comp == 20) begin
            _tmp_fsm_4 <= _tmp_fsm_4_1;
          end 
        end
        _tmp_fsm_4_1: begin
          _tmp_147 <= (_tmp_145 >> 4) << 4;
          _tmp_149 <= _tmp_146 >> 1;
          _tmp_fsm_4 <= _tmp_fsm_4_2;
        end
        _tmp_fsm_4_2: begin
          _tmp_159 <= 0;
          if((_tmp_149 <= 256) && ((_tmp_147 & 4095) + (_tmp_149 << 4) >= 4096)) begin
            _tmp_148 <= 4096 - (_tmp_147 & 4095) >> 4;
            _tmp_149 <= _tmp_149 - (4096 - (_tmp_147 & 4095) >> 4);
          end else if(_tmp_149 <= 256) begin
            _tmp_148 <= _tmp_149;
            _tmp_149 <= 0;
          end else if((_tmp_147 & 4095) + 4096 >= 4096) begin
            _tmp_148 <= 4096 - (_tmp_147 & 4095) >> 4;
            _tmp_149 <= _tmp_149 - (4096 - (_tmp_147 & 4095) >> 4);
          end else begin
            _tmp_148 <= 256;
            _tmp_149 <= _tmp_149 - 256;
          end
          _tmp_fsm_4 <= _tmp_fsm_4_3;
        end
        _tmp_fsm_4_3: begin
          if(myaxi_arready || !myaxi_arvalid) begin
            _tmp_fsm_4 <= _tmp_fsm_4_4;
          end 
        end
        _tmp_fsm_4_4: begin
          __tmp_fsm_4_cond_4_0_1 <= 1;
          if((_tmp_161 == 0) && (myaxi_rready && myaxi_rvalid) && myaxi_rlast) begin
            _tmp_159 <= 1;
          end 
          if((_tmp_161 == 0) && (myaxi_rready && myaxi_rvalid)) begin
            _tmp_150 <= myaxi_rdata;
            _tmp_152 <= 1;
            _tmp_161 <= _tmp_161 + 1;
          end 
          if(_tmp_161 > 0) begin
            _tmp_150 <= _tmp_150 >> 64;
            _tmp_152 <= 1;
            _tmp_161 <= _tmp_161 + 1;
          end 
          if(_tmp_161 == 1) begin
            _tmp_161 <= 0;
          end 
          if(_tmp_159 && (_tmp_161 == 1)) begin
            _tmp_147 <= _tmp_147 + (_tmp_148 << 4);
          end 
          if(_tmp_159 && (_tmp_161 == 1) && (_tmp_149 > 0)) begin
            _tmp_fsm_4 <= _tmp_fsm_4_2;
          end 
          if(_tmp_159 && (_tmp_161 == 1) && (_tmp_149 == 0)) begin
            _tmp_fsm_4 <= _tmp_fsm_4_5;
          end 
        end
        _tmp_fsm_4_5: begin
          _tmp_162 <= 1;
          __tmp_fsm_4_cond_5_1_1 <= 1;
          _tmp_fsm_4 <= _tmp_fsm_4_6;
        end
        _tmp_fsm_4_6: begin
          _tmp_fsm_4 <= _tmp_fsm_4_init;
        end
      endcase
    end
  end

  localparam th_sequential_1 = 1;
  localparam th_sequential_2 = 2;
  localparam th_sequential_3 = 3;
  localparam th_sequential_4 = 4;
  localparam th_sequential_5 = 5;
  localparam th_sequential_6 = 6;
  localparam th_sequential_7 = 7;
  localparam th_sequential_8 = 8;
  localparam th_sequential_9 = 9;
  localparam th_sequential_10 = 10;
  localparam th_sequential_11 = 11;
  localparam th_sequential_12 = 12;

  always @(posedge CLK) begin
    if(RST) begin
      th_sequential <= th_sequential_init;
      _th_sequential_called <= 0;
      _th_sequential_size_13 <= 0;
      _th_sequential_offset_14 <= 0;
      _th_sequential_size_15 <= 0;
      _th_sequential_offset_16 <= 0;
      _th_sequential_sum_17 <= 0;
      _th_sequential_i_18 <= 0;
      _tmp_166 <= 0;
      _th_sequential_a_19 <= 0;
      _tmp_170 <= 0;
      _th_sequential_b_20 <= 0;
    end else begin
      case(th_sequential)
        th_sequential_init: begin
          if(th_comp == 21) begin
            _th_sequential_called <= 1;
          end 
          if(th_comp == 21) begin
            _th_sequential_size_13 <= _th_comp_comp_size_2;
          end 
          if(th_comp == 21) begin
            _th_sequential_offset_14 <= _th_comp_comp_offset_4;
          end 
          if(th_comp == 21) begin
            th_sequential <= th_sequential_1;
          end 
        end
        th_sequential_1: begin
          _th_sequential_size_15 <= _th_sequential_size_13;
          _th_sequential_offset_16 <= _th_sequential_offset_14;
          th_sequential <= th_sequential_2;
        end
        th_sequential_2: begin
          _th_sequential_sum_17 <= 0;
          th_sequential <= th_sequential_3;
        end
        th_sequential_3: begin
          _th_sequential_i_18 <= 0;
          th_sequential <= th_sequential_4;
        end
        th_sequential_4: begin
          if(_th_sequential_i_18 < _th_sequential_size_15) begin
            th_sequential <= th_sequential_5;
          end else begin
            th_sequential <= th_sequential_12;
          end
        end
        th_sequential_5: begin
          if(_tmp_164 && (_tmp_163 == 0)) begin
            _tmp_166 <= ram_a_0_0_rdata;
          end 
          if(_tmp_165 && (_tmp_163 == 1)) begin
            _tmp_166 <= ram_a_1_0_rdata;
          end 
          if(_tmp_164) begin
            th_sequential <= th_sequential_6;
          end 
        end
        th_sequential_6: begin
          _th_sequential_a_19 <= _tmp_166;
          th_sequential <= th_sequential_7;
        end
        th_sequential_7: begin
          if(_tmp_168 && (_tmp_167 == 0)) begin
            _tmp_170 <= ram_b_0_0_rdata;
          end 
          if(_tmp_169 && (_tmp_167 == 1)) begin
            _tmp_170 <= ram_b_1_0_rdata;
          end 
          if(_tmp_168) begin
            th_sequential <= th_sequential_8;
          end 
        end
        th_sequential_8: begin
          _th_sequential_b_20 <= _tmp_170;
          th_sequential <= th_sequential_9;
        end
        th_sequential_9: begin
          _th_sequential_sum_17 <= _th_sequential_a_19 + _th_sequential_b_20;
          th_sequential <= th_sequential_10;
        end
        th_sequential_10: begin
          th_sequential <= th_sequential_11;
        end
        th_sequential_11: begin
          _th_sequential_i_18 <= _th_sequential_i_18 + 1;
          th_sequential <= th_sequential_4;
        end
      endcase
    end
  end

  localparam _tmp_fsm_5_1 = 1;
  localparam _tmp_fsm_5_2 = 2;
  localparam _tmp_fsm_5_3 = 3;
  localparam _tmp_fsm_5_4 = 4;
  localparam _tmp_fsm_5_5 = 5;
  localparam _tmp_fsm_5_6 = 6;

  always @(posedge CLK) begin
    if(RST) begin
      _tmp_fsm_5 <= _tmp_fsm_5_init;
      _d1__tmp_fsm_5 <= _tmp_fsm_5_init;
      _tmp_175 <= 0;
      _tmp_177 <= 0;
      _tmp_176 <= 0;
      _tmp_210 <= 0;
      __tmp_fsm_5_cond_5_0_1 <= 0;
    end else begin
      _d1__tmp_fsm_5 <= _tmp_fsm_5;
      case(_d1__tmp_fsm_5)
        _tmp_fsm_5_5: begin
          if(__tmp_fsm_5_cond_5_0_1) begin
            _tmp_210 <= 0;
          end 
        end
      endcase
      case(_tmp_fsm_5)
        _tmp_fsm_5_init: begin
          if(th_comp == 24) begin
            _tmp_fsm_5 <= _tmp_fsm_5_1;
          end 
        end
        _tmp_fsm_5_1: begin
          _tmp_175 <= (_tmp_173 >> 4) << 4;
          _tmp_177 <= _tmp_174 >> 1;
          _tmp_fsm_5 <= _tmp_fsm_5_2;
        end
        _tmp_fsm_5_2: begin
          if((_tmp_177 <= 256) && ((_tmp_175 & 4095) + (_tmp_177 << 4) >= 4096)) begin
            _tmp_176 <= 4096 - (_tmp_175 & 4095) >> 4;
            _tmp_177 <= _tmp_177 - (4096 - (_tmp_175 & 4095) >> 4);
          end else if(_tmp_177 <= 256) begin
            _tmp_176 <= _tmp_177;
            _tmp_177 <= 0;
          end else if((_tmp_175 & 4095) + 4096 >= 4096) begin
            _tmp_176 <= 4096 - (_tmp_175 & 4095) >> 4;
            _tmp_177 <= _tmp_177 - (4096 - (_tmp_175 & 4095) >> 4);
          end else begin
            _tmp_176 <= 256;
            _tmp_177 <= _tmp_177 - 256;
          end
          _tmp_fsm_5 <= _tmp_fsm_5_3;
        end
        _tmp_fsm_5_3: begin
          if(myaxi_awready || !myaxi_awvalid) begin
            _tmp_fsm_5 <= _tmp_fsm_5_4;
          end 
        end
        _tmp_fsm_5_4: begin
          if(_tmp_208 && myaxi_wvalid && myaxi_wready) begin
            _tmp_175 <= _tmp_175 + (_tmp_176 << 4);
          end 
          if(_tmp_208 && myaxi_wvalid && myaxi_wready && (_tmp_177 > 0)) begin
            _tmp_fsm_5 <= _tmp_fsm_5_2;
          end 
          if(_tmp_208 && myaxi_wvalid && myaxi_wready && (_tmp_177 == 0)) begin
            _tmp_fsm_5 <= _tmp_fsm_5_5;
          end 
        end
        _tmp_fsm_5_5: begin
          _tmp_210 <= 1;
          __tmp_fsm_5_cond_5_0_1 <= 1;
          _tmp_fsm_5 <= _tmp_fsm_5_6;
        end
        _tmp_fsm_5_6: begin
          _tmp_fsm_5 <= _tmp_fsm_5_init;
        end
      endcase
    end
  end


  always @(posedge CLK) begin
    if(RST) begin
      _tmp_204 <= 0;
      _tmp_203 <= 0;
      _tmp_206 <= 0;
    end else begin
      if(_tmp_205 || !_tmp_204) begin
        _tmp_204 <= 0;
      end 
      if(_cat_valid_207 && ((_tmp_fsm_5 == 4) && (_tmp_205 || !_tmp_204))) begin
        _tmp_203 <= { _cat_data_207, _tmp_203[127:64] };
        _tmp_204 <= 0;
        _tmp_206 <= _tmp_206 + 1;
      end 
      if(_cat_valid_207 && ((_tmp_fsm_5 == 4) && (_tmp_205 || !_tmp_204)) && (_tmp_206 == 1)) begin
        _tmp_203 <= { _cat_data_207, _tmp_203[127:64] };
        _tmp_204 <= 1;
        _tmp_206 <= 0;
      end 
    end
  end


endmodule



module ram_a_0
(
  input CLK,
  input [10-1:0] ram_a_0_0_addr,
  output [32-1:0] ram_a_0_0_rdata,
  input [32-1:0] ram_a_0_0_wdata,
  input ram_a_0_0_wenable
);

  reg [10-1:0] ram_a_0_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(ram_a_0_0_wenable) begin
      mem[ram_a_0_0_addr] <= ram_a_0_0_wdata;
    end 
    ram_a_0_0_daddr <= ram_a_0_0_addr;
  end

  assign ram_a_0_0_rdata = mem[ram_a_0_0_daddr];

endmodule



module ram_a_1
(
  input CLK,
  input [10-1:0] ram_a_1_0_addr,
  output [32-1:0] ram_a_1_0_rdata,
  input [32-1:0] ram_a_1_0_wdata,
  input ram_a_1_0_wenable
);

  reg [10-1:0] ram_a_1_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(ram_a_1_0_wenable) begin
      mem[ram_a_1_0_addr] <= ram_a_1_0_wdata;
    end 
    ram_a_1_0_daddr <= ram_a_1_0_addr;
  end

  assign ram_a_1_0_rdata = mem[ram_a_1_0_daddr];

endmodule



module ram_b_0
(
  input CLK,
  input [10-1:0] ram_b_0_0_addr,
  output [32-1:0] ram_b_0_0_rdata,
  input [32-1:0] ram_b_0_0_wdata,
  input ram_b_0_0_wenable
);

  reg [10-1:0] ram_b_0_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(ram_b_0_0_wenable) begin
      mem[ram_b_0_0_addr] <= ram_b_0_0_wdata;
    end 
    ram_b_0_0_daddr <= ram_b_0_0_addr;
  end

  assign ram_b_0_0_rdata = mem[ram_b_0_0_daddr];

endmodule



module ram_b_1
(
  input CLK,
  input [10-1:0] ram_b_1_0_addr,
  output [32-1:0] ram_b_1_0_rdata,
  input [32-1:0] ram_b_1_0_wdata,
  input ram_b_1_0_wenable
);

  reg [10-1:0] ram_b_1_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(ram_b_1_0_wenable) begin
      mem[ram_b_1_0_addr] <= ram_b_1_0_wdata;
    end 
    ram_b_1_0_daddr <= ram_b_1_0_addr;
  end

  assign ram_b_1_0_rdata = mem[ram_b_1_0_daddr];

endmodule



module ram_c_0
(
  input CLK,
  input [10-1:0] ram_c_0_0_addr,
  output [32-1:0] ram_c_0_0_rdata,
  input [32-1:0] ram_c_0_0_wdata,
  input ram_c_0_0_wenable
);

  reg [10-1:0] ram_c_0_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(ram_c_0_0_wenable) begin
      mem[ram_c_0_0_addr] <= ram_c_0_0_wdata;
    end 
    ram_c_0_0_daddr <= ram_c_0_0_addr;
  end

  assign ram_c_0_0_rdata = mem[ram_c_0_0_daddr];

endmodule



module ram_c_1
(
  input CLK,
  input [10-1:0] ram_c_1_0_addr,
  output [32-1:0] ram_c_1_0_rdata,
  input [32-1:0] ram_c_1_0_wdata,
  input ram_c_1_0_wenable
);

  reg [10-1:0] ram_c_1_0_daddr;
  reg [32-1:0] mem [0:1024-1];

  always @(posedge CLK) begin
    if(ram_c_1_0_wenable) begin
      mem[ram_c_1_0_addr] <= ram_c_1_0_wdata;
    end 
    ram_c_1_0_daddr <= ram_c_1_0_addr;
  end

  assign ram_c_1_0_rdata = mem[ram_c_1_0_daddr];

endmodule
"""


def test():
    veriloggen.reset()
    test_module = thread_stream_multibank.mkTest()
    code = test_module.to_verilog()

    from pyverilog.vparser.parser import VerilogParser
    from pyverilog.ast_code_generator.codegen import ASTCodeGenerator
    parser = VerilogParser()
    expected_ast = parser.parse(expected_verilog)
    codegen = ASTCodeGenerator()
    expected_code = codegen.visit(expected_ast)

    assert(expected_code == code)
